#line 1 "dfa_loongarch.cpp"
//
// Copyright (c) 2003, 2013, Oracle and/or its affiliates. All rights reserved.
// Copyright (c) 2015, 2022, Loongson Technology. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/ad_loongarch.hpp"
#include "oops/compressedOops.hpp"
#include "opto/cfgnode.hpp"
#include "opto/intrinsicnode.hpp"
#include "opto/matcher.hpp"
#include "opto/narrowptrnode.hpp"
#include "opto/opcodes.hpp"
#include "opto/convertnode.hpp"
#include "utilities/powerOfTwo.hpp"

//------------------------- Source -----------------------------------------

//------------------------- Attributes -------------------------------------

// AttributeForm 
static const int op_cost = 0;

// AttributeForm 
static const int ins_cost = 100;

// AttributeForm 
static const int ins_size = 32;

// AttributeForm 
static const int ins_pc_relative = 0;

// AttributeForm 
static const int ins_short_branch = 0;

// AttributeForm 
static const int ins_alignment = 4;

//------------------------- Macros -----------------------------------------
#define DFA_PRODUCTION(result, rule, cost)\
  assert(rule < (1 << 15), "too many rules"); _cost[ (result) ] = cost; _rule[ (result) ] = (rule << 1) | 0x1;

//------------------------- DFA --------------------------------------------
// DFA is a large switch with case statements for each ideal opcode encountered
// in any match rule in the ad file.  Each case has a series of if's to handle
// the match or fail decisions.  The matches test the cost function of that
// rule, and prune any cases which are higher cost for the same reduction.
// In order to generate the DFA we walk the table of ideal opcode/MatchList
// pairs generated by the ADLC front end to build the contents of the case
// statements (a series of if statements).


void  State::_sub_Op_RegN(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(S7_REGN, s7_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(S6_REGN, s6_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(S5_REGN, s5_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(S4_REGN, s4_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(S3_REGN, s3_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(S2_REGN, s2_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(S1_REGN, s1_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(S0_REGN, s0_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A7_REGN, a7_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A6_REGN, a6_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A5_REGN, a5_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A4_REGN, a4_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A3_REGN, a3_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A2_REGN, a2_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A1_REGN, a1_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A0_REGN, a0_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(T8_REGN, t8_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(T3_REGN, t3_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(T1_REGN, t1_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(T0_REGN, t0_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MREGN, mRegN_rule, c)
    }
}
void  State::_sub_Op_RegI(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MA7REGI, mA7RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MA6REGI, mA6RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MA5REGI, mA5RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MA4REGI, mA4RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MA3REGI, mA3RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MA2REGI, mA2RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MA1REGI, mA1RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MA0REGI, mA0RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MT4REGI, mT4RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MT8REGI, mT8RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MT3REGI, mT3RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MT2REGI, mT2RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MT1REGI, mT1RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MT0REGI, mT0RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MS7REGI, mS7RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MS6REGI, mS6RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MS5REGI, mS5RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MS4REGI, mS4RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MS3REGI, mS3RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MS1REGI, mS1RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MS0REGI, mS0RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(NO_AX_MREGI, no_Ax_mRegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MREGI, mRegI_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
    }
}
void  State::_sub_Op_RegP(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(V1_REGP, v1_RegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(V0_REGP, v0_RegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A7_REGP, a7_RegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A6_REGP, a6_RegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A5_REGP, a5_RegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A4_REGP, a4_RegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A3_REGP, a3_RegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A2_REGP, a2_RegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A1_REGP, a1_RegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A0_REGP, a0_RegP_rule, c)
        DFA_PRODUCTION(MREGP, mRegP_rule, c)
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION(NO_T8_MREGP, no_T8_mRegP_rule, c)
        DFA_PRODUCTION(S1_REGP, s1_RegP_rule, c)
        DFA_PRODUCTION(S3_REGP, s3_RegP_rule, c)
        DFA_PRODUCTION(S4_REGP, s4_RegP_rule, c)
        DFA_PRODUCTION(S5_REGP, s5_RegP_rule, c)
        DFA_PRODUCTION(S6_REGP, s6_RegP_rule, c)
        DFA_PRODUCTION(S7_REGP, s7_RegP_rule, c)
        DFA_PRODUCTION(T0_REGP, t0_RegP_rule, c)
        DFA_PRODUCTION(T1_REGP, t1_RegP_rule, c)
        DFA_PRODUCTION(T2_REGP, t2_RegP_rule, c)
        DFA_PRODUCTION(T3_REGP, t3_RegP_rule, c)
        DFA_PRODUCTION(NO_AX_MREGP, no_Ax_mRegP_rule, c)
        DFA_PRODUCTION(T8_REGP, t8_RegP_rule, c)
        DFA_PRODUCTION(INDIRECT, indirect_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
}
void  State::_sub_Op_RegF(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(REGF, regF_rule, c)
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_RegD(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(REGD, regD_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_RegL(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(S7REGL, s7RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(S4REGL, s4RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(S3REGL, s3RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(S1REGL, s1RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(S0REGL, s0RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A7REGL, a7RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A6REGL, a6RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A5REGL, a5RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A4REGL, a4RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(T8REGL, t8RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(T3REGL, t3RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(T1REGL, t1RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(T0REGL, t0RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A3REGL, a3RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A2REGL, a2RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A1REGL, a1RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(A0REGL, a0RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(V1REGL, v1RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(V0REGL, v0RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MREGL, mRegL_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
    }
}
void  State::_sub_Op_VecX(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(VECX, vecX_rule, c)
    }
}
void  State::_sub_Op_VecY(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(VECY, vecY_rule, c)
    }
}
void  State::_sub_Op_RegFlags(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(FLAGSREG, FlagsReg_rule, c)
    }
}
void  State::_sub_Op_AbsD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION(REGD, absD_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_AbsF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION(REGF, absF_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_AbsI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
        DFA_PRODUCTION(MREGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MS0REGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MS1REGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MS3REGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MS4REGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MS5REGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MS6REGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MS7REGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MT0REGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MT1REGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MT2REGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MT3REGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MT8REGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MT4REGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MA0REGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MA1REGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MA2REGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MA3REGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MA4REGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MA5REGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MA6REGI, absI_rReg_rule, c)
        DFA_PRODUCTION(MA7REGI, absI_rReg_rule, c)
    }
}
void  State::_sub_Op_AbsL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+100;
        DFA_PRODUCTION(MREGL, absL_rReg_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, absL_rReg_rule, c)
        DFA_PRODUCTION(V1REGL, absL_rReg_rule, c)
        DFA_PRODUCTION(A0REGL, absL_rReg_rule, c)
        DFA_PRODUCTION(A1REGL, absL_rReg_rule, c)
        DFA_PRODUCTION(A2REGL, absL_rReg_rule, c)
        DFA_PRODUCTION(A3REGL, absL_rReg_rule, c)
        DFA_PRODUCTION(T0REGL, absL_rReg_rule, c)
        DFA_PRODUCTION(T1REGL, absL_rReg_rule, c)
        DFA_PRODUCTION(T3REGL, absL_rReg_rule, c)
        DFA_PRODUCTION(T8REGL, absL_rReg_rule, c)
        DFA_PRODUCTION(A4REGL, absL_rReg_rule, c)
        DFA_PRODUCTION(A5REGL, absL_rReg_rule, c)
        DFA_PRODUCTION(A6REGL, absL_rReg_rule, c)
        DFA_PRODUCTION(A7REGL, absL_rReg_rule, c)
        DFA_PRODUCTION(S0REGL, absL_rReg_rule, c)
        DFA_PRODUCTION(S1REGL, absL_rReg_rule, c)
        DFA_PRODUCTION(S3REGL, absL_rReg_rule, c)
        DFA_PRODUCTION(S4REGL, absL_rReg_rule, c)
        DFA_PRODUCTION(S7REGL, absL_rReg_rule, c)
    }
}
void  State::_sub_Op_AddD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+100;
        DFA_PRODUCTION(REGD, addD_reg_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_AddF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+100;
        DFA_PRODUCTION(REGF, addF_reg_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_AddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_MREGI_IMMI_1_4) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_MREGI_IMMI_1_4]+_kids[1]->_cost[MREGI]+100;
        DFA_PRODUCTION(MREGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MS0REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MS1REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MS3REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MS4REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MS5REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MS6REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MS7REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MT0REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MT1REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MT2REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MT3REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MT8REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MT4REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MA0REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MA1REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MA2REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MA3REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MA4REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MA5REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MA6REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
        DFA_PRODUCTION(MA7REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_MREGI_IMMI_1_4) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[_LSHIFTI_MREGI_IMMI_1_4]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI12) ) {
      unsigned int c = _kids[0]->_cost[MREGIORL2I]+_kids[1]->_cost[IMMI12]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, addI_Reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGIORL2I) && STATE__VALID_CHILD(_kids[1], MREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[MREGIORL2I]+_kids[1]->_cost[MREGIORL2I]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, addI_Reg_Reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], IMML12) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[IMML12]+100;
        DFA_PRODUCTION(MREGL, addL_Reg_imm_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, addL_Reg_imm_rule, c)
        DFA_PRODUCTION(V1REGL, addL_Reg_imm_rule, c)
        DFA_PRODUCTION(A0REGL, addL_Reg_imm_rule, c)
        DFA_PRODUCTION(A1REGL, addL_Reg_imm_rule, c)
        DFA_PRODUCTION(A2REGL, addL_Reg_imm_rule, c)
        DFA_PRODUCTION(A3REGL, addL_Reg_imm_rule, c)
        DFA_PRODUCTION(T0REGL, addL_Reg_imm_rule, c)
        DFA_PRODUCTION(T1REGL, addL_Reg_imm_rule, c)
        DFA_PRODUCTION(T3REGL, addL_Reg_imm_rule, c)
        DFA_PRODUCTION(T8REGL, addL_Reg_imm_rule, c)
        DFA_PRODUCTION(A4REGL, addL_Reg_imm_rule, c)
        DFA_PRODUCTION(A5REGL, addL_Reg_imm_rule, c)
        DFA_PRODUCTION(A6REGL, addL_Reg_imm_rule, c)
        DFA_PRODUCTION(A7REGL, addL_Reg_imm_rule, c)
        DFA_PRODUCTION(S0REGL, addL_Reg_imm_rule, c)
        DFA_PRODUCTION(S1REGL, addL_Reg_imm_rule, c)
        DFA_PRODUCTION(S3REGL, addL_Reg_imm_rule, c)
        DFA_PRODUCTION(S4REGL, addL_Reg_imm_rule, c)
        DFA_PRODUCTION(S7REGL, addL_Reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], MREGLORI2L) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[MREGLORI2L]+200;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, addL_Reg_Reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_MREGLORI2L_IMMI_0_3) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_LSHIFTL_MREGLORI2L_IMMI_0_3]+110;
        DFA_PRODUCTION(MREGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION(NO_T8_MREGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(S1_REGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(S3_REGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(S4_REGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(S5_REGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(S6_REGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(S7_REGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(T0_REGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(T1_REGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(T2_REGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(T3_REGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(A0_REGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(A1_REGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(A2_REGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(A3_REGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(A4_REGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(A5_REGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(A6_REGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(A7_REGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(V0_REGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(V1_REGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(NO_AX_MREGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(T8_REGP, leaPIdxScale_rule, c)
        DFA_PRODUCTION(INDIRECT, leaPIdxScale_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_MREGI__IMMI_1_4) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_LSHIFTL__CONVI2L_MREGI__IMMI_1_4]+100;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION(MREGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION(NO_T8_MREGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION(S1_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION(S3_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION(S4_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION(S5_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION(S6_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION(S7_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION(T0_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION(T1_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION(T2_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION(T3_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION(A0_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION(A1_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION(A2_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION(A3_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION(A4_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION(A5_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION(A6_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION(A7_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION(V0_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION(V1_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION(NO_AX_MREGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION(T8_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], IMML12) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[IMML12]+100;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION(MREGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION(NO_T8_MREGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION(S1_REGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION(S3_REGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION(S4_REGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION(S5_REGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION(S6_REGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION(S7_REGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION(T0_REGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION(T1_REGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION(T2_REGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION(T3_REGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION(A0_REGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION(A1_REGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION(A2_REGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION(A3_REGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION(A4_REGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION(A5_REGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION(A6_REGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION(A7_REGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION(V0_REGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION(V1_REGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION(NO_AX_MREGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION(T8_REGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _ANDL_MREGLORI2L_IMML_M8) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_ANDL_MREGLORI2L_IMML_M8]+100;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION(MREGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION(NO_T8_MREGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION(S1_REGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION(S3_REGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION(S4_REGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION(S5_REGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION(S6_REGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION(S7_REGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION(T0_REGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION(T1_REGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION(T2_REGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION(T3_REGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION(A0_REGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION(A1_REGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION(A2_REGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION(A3_REGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION(A4_REGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION(A5_REGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION(A6_REGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION(A7_REGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION(V0_REGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION(V1_REGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION(NO_AX_MREGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION(T8_REGP, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, addP_reg_reg_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], MREGLORI2L) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[MREGLORI2L]+100;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION(MREGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION(NO_T8_MREGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION(S1_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION(S3_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION(S4_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION(S5_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION(S6_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION(S7_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION(T0_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION(T1_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION(T2_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION(T3_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION(A0_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION(A1_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION(A2_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION(A3_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION(A4_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION(A5_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION(A6_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION(A7_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION(V0_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION(V1_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION(NO_AX_MREGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION(T8_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_MREGN_) && STATE__VALID_CHILD(_kids[1], IMML12) &&
        
#line 4075 "src/hotspot/cpu/loongarch/loongarch_64.ad"
CompressedOops::shift() == 0
#line 1305 "dfa_loongarch.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_MREGN_]+_kids[1]->_cost[IMML12]+10;
        DFA_PRODUCTION(INDOFFSET12NARROW, indOffset12Narrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indOffset12Narrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c+110) {
        DFA_PRODUCTION(MREGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c+110) {
        DFA_PRODUCTION(NO_T8_MREGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c+110) {
        DFA_PRODUCTION(S1_REGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c+110) {
        DFA_PRODUCTION(S3_REGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c+110) {
        DFA_PRODUCTION(S4_REGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c+110) {
        DFA_PRODUCTION(S5_REGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c+110) {
        DFA_PRODUCTION(S6_REGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c+110) {
        DFA_PRODUCTION(S7_REGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c+110) {
        DFA_PRODUCTION(T0_REGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c+110) {
        DFA_PRODUCTION(T1_REGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c+110) {
        DFA_PRODUCTION(T2_REGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c+110) {
        DFA_PRODUCTION(T3_REGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c+110) {
        DFA_PRODUCTION(A0_REGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c+110) {
        DFA_PRODUCTION(A1_REGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c+110) {
        DFA_PRODUCTION(A2_REGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c+110) {
        DFA_PRODUCTION(A3_REGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c+110) {
        DFA_PRODUCTION(A4_REGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c+110) {
        DFA_PRODUCTION(A5_REGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c+110) {
        DFA_PRODUCTION(A6_REGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c+110) {
        DFA_PRODUCTION(A7_REGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c+110) {
        DFA_PRODUCTION(V0_REGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c+110) {
        DFA_PRODUCTION(V1_REGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c+110) {
        DFA_PRODUCTION(NO_AX_MREGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c+110) {
        DFA_PRODUCTION(T8_REGP, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION(INDIRECT, leaP12Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c+110) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _CONVI2L_MREGI_) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_CONVI2L_MREGI_]+10;
        DFA_PRODUCTION(INDINDEXI2L, indIndexI2L_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indIndexI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[MREGL]+20;
        DFA_PRODUCTION(INDINDEX, indIndex_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indIndex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _CONVI2L_IMMI12_) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_CONVI2L_IMMI12_]+10;
        DFA_PRODUCTION(INDOFFSET12I2L, indOffset12I2L_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indOffset12I2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], IMML12) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[IMML12]+10;
        DFA_PRODUCTION(INDOFFSET12, indOffset12_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indOffset12_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indOffset12_rule, c)
      }
    }
}
void  State::_sub_Op_AndI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_MREGI_IMMI_0_31) && STATE__VALID_CHILD(_kids[1], IMMI_NONNEG_MASK) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_MREGI_IMMI_0_31]+_kids[1]->_cost[IMMI_NONNEG_MASK]+100;
        DFA_PRODUCTION(MREGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MS0REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MS1REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MS3REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MS4REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MS5REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MS6REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MS7REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MT0REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MT1REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MT2REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MT3REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MT8REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MT4REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MA0REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MA1REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MA2REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MA3REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MA4REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MA5REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MA6REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION(MA7REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_1) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_1];
        DFA_PRODUCTION(_ANDI_MREGI_IMMI_1, _AndI_mRegI_immI_1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVL2I__URSHIFTL_MREGLORI2L_IMMI_0_31_) && STATE__VALID_CHILD(_kids[1], IMMI_MAXI) ) {
      unsigned int c = _kids[0]->_cost[_CONVL2I__URSHIFTL_MREGLORI2L_IMMI_0_31_]+_kids[1]->_cost[IMMI_MAXI]+80;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_MREGI_IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_M65536) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_MREGI_IMMI_16]+_kids[1]->_cost[IMMI_M65536]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, salI_Reg_imm_and_M65536_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI_MREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[_XORI_MREGI_IMMI_M1]+_kids[1]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, andnI_Reg_nReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], _XORI_MREGI_IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[_XORI_MREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, andnI_Reg_nReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, andI_Reg_Reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+_kids[1]->_cost[IMMI_255]+60;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, lbu_and_lmask_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_255) && STATE__VALID_CHILD(_kids[1], _LOADB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IMMI_255]+_kids[1]->_cost[_LOADB_MEMORY_]+60;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, lbu_and_lmask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_NONNEG_MASK) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_NONNEG_MASK]+60;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_0_4095) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_0_4095]+60;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, andI_Reg_imm_0_4095_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_65535]+125;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, loadI2US_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_255]+125;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, loadI2UB_rule, c)
      }
    }
}
void  State::_sub_Op_AndL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMML_MAXUI) && STATE__VALID_CHILD(_kids[1], _CONVI2L__LOADI_MEMORY__) ) {
      unsigned int c = _kids[0]->_cost[IMML_MAXUI]+_kids[1]->_cost[_CONVI2L__LOADI_MEMORY__]+100;
        DFA_PRODUCTION(MREGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION(V1REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION(A0REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION(A1REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION(A2REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION(A3REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION(T0REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION(T1REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION(T3REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION(T8REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION(A4REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION(A5REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION(A6REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION(A7REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION(S0REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION(S1REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION(S3REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION(S4REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION(S7REGL, loadUI2L_lmask_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L__LOADI_MEMORY__) && STATE__VALID_CHILD(_kids[1], IMML_MAXUI) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L__LOADI_MEMORY__]+_kids[1]->_cost[IMML_MAXUI]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, loadUI2L_rmask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L__CONVL2I_MREGL__) && STATE__VALID_CHILD(_kids[1], IMML_MAXUI) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L__CONVL2I_MREGL__]+_kids[1]->_cost[IMML_MAXUI]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, convL2I2L_reg_reg_zex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_MREGI_) && STATE__VALID_CHILD(_kids[1], IMML_MAXUI) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_MREGI_]+_kids[1]->_cost[IMML_MAXUI]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, convI2L_reg_reg_zex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_MREGI_) && STATE__VALID_CHILD(_kids[1], IMML_MAXUI) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_MREGI_]+_kids[1]->_cost[IMML_MAXUI];
        DFA_PRODUCTION(_ANDL__CONVI2L_MREGI__IMML_MAXUI, _AndL__ConvI2L_mRegI__immL_MaxUI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_MAXUI) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_MAXUI]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, zerox_long_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_7) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_7];
        DFA_PRODUCTION(_ANDL_MREGL_IMML_7, _AndL_mRegL_immL_7_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_M121) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_M121]+60;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, andL_Reg_immL_M121_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_M4) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_M4]+60;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, andL_Reg_immL_M4_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_M7) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_M7]+60;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, andL_Reg_immL_M7_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_M5) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_M5]+60;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, andL_Reg_immL_M5_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_M8) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_M8]+60;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, andL_Reg_immL_M8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_0_4095) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_0_4095];
        DFA_PRODUCTION(_ANDL_MREGL_IMML_0_4095, _AndL_mRegL_immL_0_4095_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_0_4095) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_0_4095]+60;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, andL_Reg_imm_0_4095_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGLORI2L) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGLORI2L]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, andL_Reg_Reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_NONNEG_MASK) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_NONNEG_MASK]+60;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], IMML_M8) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[IMML_M8];
        DFA_PRODUCTION(_ANDL_MREGLORI2L_IMML_M8, _AndL_mRegLorI2L_immL_M8_rule, c)
    }
}
void  State::_sub_Op_Binary(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[REGD];
        DFA_PRODUCTION(_BINARY_VECY_REGD, _Binary_vecY_regD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[REGF];
        DFA_PRODUCTION(_BINARY_VECY_REGF, _Binary_vecY_regF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[MREGL];
        DFA_PRODUCTION(_BINARY_VECY_MREGL, _Binary_vecY_mRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[MREGI];
        DFA_PRODUCTION(_BINARY_VECY_MREGI, _Binary_vecY_mRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[REGD];
        DFA_PRODUCTION(_BINARY_VECX_REGD, _Binary_vecX_regD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[REGF];
        DFA_PRODUCTION(_BINARY_VECX_REGF, _Binary_vecX_regF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[MREGL];
        DFA_PRODUCTION(_BINARY_VECX_MREGL, _Binary_vecX_mRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[MREGI];
        DFA_PRODUCTION(_BINARY_VECX_MREGI, _Binary_vecX_mRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _NEGVD_VECY_) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_NEGVD_VECY_];
        DFA_PRODUCTION(_BINARY_VECY__NEGVD_VECY_, _Binary_vecY__NegVD_vecY__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVD_VECY_) && STATE__VALID_CHILD(_kids[1], VECY) ) {
      unsigned int c = _kids[0]->_cost[_NEGVD_VECY_]+_kids[1]->_cost[VECY];
        DFA_PRODUCTION(_BINARY__NEGVD_VECY__VECY, _Binary__NegVD_vecY__vecY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _NEGVF_VECY_) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_NEGVF_VECY_];
        DFA_PRODUCTION(_BINARY_VECY__NEGVF_VECY_, _Binary_vecY__NegVF_vecY__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVF_VECY_) && STATE__VALID_CHILD(_kids[1], VECY) ) {
      unsigned int c = _kids[0]->_cost[_NEGVF_VECY_]+_kids[1]->_cost[VECY];
        DFA_PRODUCTION(_BINARY__NEGVF_VECY__VECY, _Binary__NegVF_vecY__vecY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _NEGVD_VECX_) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_NEGVD_VECX_];
        DFA_PRODUCTION(_BINARY_VECX__NEGVD_VECX_, _Binary_vecX__NegVD_vecX__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVD_VECX_) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[_NEGVD_VECX_]+_kids[1]->_cost[VECX];
        DFA_PRODUCTION(_BINARY__NEGVD_VECX__VECX, _Binary__NegVD_vecX__vecX_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _NEGVF_VECX_) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_NEGVF_VECX_];
        DFA_PRODUCTION(_BINARY_VECX__NEGVF_VECX_, _Binary_vecX__NegVF_vecX__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVF_VECX_) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[_NEGVF_VECX_]+_kids[1]->_cost[VECX];
        DFA_PRODUCTION(_BINARY__NEGVF_VECX__VECX, _Binary__NegVF_vecX__vecX_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY];
        DFA_PRODUCTION(_BINARY_VECY_VECY, _Binary_vecY_vecY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX];
        DFA_PRODUCTION(_BINARY_VECX_VECX, _Binary_vecX_vecX_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD_0) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD_0];
        DFA_PRODUCTION(_BINARY_REGD_IMMD_0, _Binary_regD_immD_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _NEGD_REGD_) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_NEGD_REGD_];
        DFA_PRODUCTION(_BINARY_REGD__NEGD_REGD_, _Binary_regD__NegD_regD__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGD_REGD_) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[_NEGD_REGD_]+_kids[1]->_cost[REGD];
        DFA_PRODUCTION(_BINARY__NEGD_REGD__REGD, _Binary__NegD_regD__regD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _NEGF_REGF_) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_NEGF_REGF_];
        DFA_PRODUCTION(_BINARY_REGF__NEGF_REGF_, _Binary_regF__NegF_regF__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGF_REGF_) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[_NEGF_REGF_]+_kids[1]->_cost[REGF];
        DFA_PRODUCTION(_BINARY__NEGF_REGF__REGF, _Binary__NegF_regF__regF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], A4_REGP) && STATE__VALID_CHILD(_kids[1], A5_REGP) ) {
      unsigned int c = _kids[0]->_cost[A4_REGP]+_kids[1]->_cost[A5_REGP];
        DFA_PRODUCTION(_BINARY_A4_REGP_A5_REGP, _Binary_a4_RegP_a5_RegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], A5_REGP) && STATE__VALID_CHILD(_kids[1], MA6REGI) ) {
      unsigned int c = _kids[0]->_cost[A5_REGP]+_kids[1]->_cost[MA6REGI];
        DFA_PRODUCTION(_BINARY_A5_REGP_MA6REGI, _Binary_a5_RegP_mA6RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], A6_REGP) && STATE__VALID_CHILD(_kids[1], IMMI_1) ) {
      unsigned int c = _kids[0]->_cost[A6_REGP]+_kids[1]->_cost[IMMI_1];
        DFA_PRODUCTION(_BINARY_A6_REGP_IMMI_1, _Binary_a6_RegP_immI_1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], A6_REGP) && STATE__VALID_CHILD(_kids[1], IMMI_1_4) ) {
      unsigned int c = _kids[0]->_cost[A6_REGP]+_kids[1]->_cost[IMMI_1_4];
        DFA_PRODUCTION(_BINARY_A6_REGP_IMMI_1_4, _Binary_a6_RegP_immI_1_4_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], A6_REGP) && STATE__VALID_CHILD(_kids[1], MA7REGI) ) {
      unsigned int c = _kids[0]->_cost[A6_REGP]+_kids[1]->_cost[MA7REGI];
        DFA_PRODUCTION(_BINARY_A6_REGP_MA7REGI, _Binary_a6_RegP_mA7RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], A4_REGP) && STATE__VALID_CHILD(_kids[1], MA5REGI) ) {
      unsigned int c = _kids[0]->_cost[A4_REGP]+_kids[1]->_cost[MA5REGI];
        DFA_PRODUCTION(_BINARY_A4_REGP_MA5REGI, _Binary_a4_RegP_mA5RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF];
        DFA_PRODUCTION(_BINARY_REGF_REGF, _Binary_regF_regF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD];
        DFA_PRODUCTION(_BINARY_REGD_REGD, _Binary_regD_regD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPUL_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPUL_MREGL_MREGL];
        DFA_PRODUCTION(_BINARY_CMPOP__CMPUL_MREGL_MREGL, _Binary_cmpOp__CmpUL_mRegL_mRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPL_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPL_MREGL_MREGL];
        DFA_PRODUCTION(_BINARY_CMPOP__CMPL_MREGL_MREGL, _Binary_cmpOp__CmpL_mRegL_mRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGL];
        DFA_PRODUCTION(_BINARY_MREGL_MREGL, _Binary_mRegL_mRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPUL_MREGLORI2L_MREGLORI2L) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPUL_MREGLORI2L_MREGLORI2L];
        DFA_PRODUCTION(_BINARY_CMPOP__CMPUL_MREGLORI2L_MREGLORI2L, _Binary_cmpOp__CmpUL_mRegLorI2L_mRegLorI2L_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGIORL2I];
        DFA_PRODUCTION(_BINARY_MREGI_MREGIORL2I, _Binary_mRegI_mRegIorL2I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPL_MREGLORI2L_MREGLORI2L) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPL_MREGLORI2L_MREGLORI2L];
        DFA_PRODUCTION(_BINARY_CMPOP__CMPL_MREGLORI2L_MREGLORI2L, _Binary_cmpOp__CmpL_mRegLorI2L_mRegLorI2L_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPD_REGD_REGD) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPD_REGD_REGD];
        DFA_PRODUCTION(_BINARY_CMPOP__CMPD_REGD_REGD, _Binary_cmpOp__CmpD_regD_regD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGN) && STATE__VALID_CHILD(_kids[1], MREGN) ) {
      unsigned int c = _kids[0]->_cost[MREGN]+_kids[1]->_cost[MREGN];
        DFA_PRODUCTION(_BINARY_MREGN_MREGN, _Binary_mRegN_mRegN_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPF_REGF_REGF) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPF_REGF_REGF];
        DFA_PRODUCTION(_BINARY_CMPOP__CMPF_REGF_REGF, _Binary_cmpOp__CmpF_regF_regF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[MREGP];
        DFA_PRODUCTION(_BINARY_MREGP_MREGP, _Binary_mRegP_mRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPU_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPU_MREGI_MREGI];
        DFA_PRODUCTION(_BINARY_CMPOP__CMPU_MREGI_MREGI, _Binary_cmpOp__CmpU_mRegI_mRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPN_MREGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPN_MREGN_MREGN];
        DFA_PRODUCTION(_BINARY_CMPOP__CMPN_MREGN_MREGN, _Binary_cmpOp__CmpN_mRegN_mRegN_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPP_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPP_MREGP_MREGP];
        DFA_PRODUCTION(_BINARY_CMPOP__CMPP_MREGP_MREGP, _Binary_cmpOp__CmpP_mRegP_mRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI];
        DFA_PRODUCTION(_BINARY_MREGI_MREGI, _Binary_mRegI_mRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_MREGI_MREGI];
        DFA_PRODUCTION(_BINARY_CMPOP__CMPI_MREGI_MREGI, _Binary_cmpOp__CmpI_mRegI_mRegI_rule, c)
    }
}
void  State::_sub_Op_Bool(const Node *n){
    if(         
#line 4122 "src/hotspot/cpu/loongarch/loongarch_64.ad"
n->as_Bool()->_test._test == BoolTest::ne
            || n->as_Bool()->_test._test == BoolTest::eq
#line 3383 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(CMPOPEQNE, cmpOpEqNe_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(CMPOP, cmpOp_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[MREGIORL2I]+100;
        DFA_PRODUCTION(MREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MS0REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MS1REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MS3REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MS4REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MS5REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MS6REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MS7REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MT0REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MT1REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MT2REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MT3REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MT8REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MT4REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MA0REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MA1REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MA2REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MA3REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MA4REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MA5REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MA6REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(MA7REGI, bytes_reverse_int_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+100;
        DFA_PRODUCTION(MREGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION(V1REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION(A0REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION(A1REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION(A2REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION(A3REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION(T0REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION(T1REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION(T3REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION(T8REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION(A4REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION(A5REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION(A6REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION(A7REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION(S0REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION(S1REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION(S3REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION(S4REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION(S7REGL, bytes_reverse_long_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesUS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[MREGIORL2I]+100;
        DFA_PRODUCTION(MREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MS0REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MS1REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MS3REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MS4REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MS5REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MS6REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MS7REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MT0REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MT1REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MT2REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MT3REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MT8REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MT4REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MA0REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MA1REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MA2REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MA3REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MA4REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MA5REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MA6REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION(MA7REGI, bytes_reverse_unsigned_short_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[MREGIORL2I]+100;
        DFA_PRODUCTION(MREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MS0REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MS1REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MS3REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MS4REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MS5REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MS6REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MS7REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MT0REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MT1REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MT2REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MT3REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MT8REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MT4REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MA0REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MA1REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MA2REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MA3REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MA4REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MA5REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MA6REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION(MA7REGI, bytes_reverse_short_rule, c)
    }
}
void  State::_sub_Op_CallDynamicJava(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION(UNIVERSE, CallDynamicJavaDirect_rule, c)
    }
}
void  State::_sub_Op_CallLeaf(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION(UNIVERSE, CallLeafDirect_rule, c)
    }
}
void  State::_sub_Op_CallLeafNoFP(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION(UNIVERSE, CallLeafNoFPDirect_rule, c)
    }
}
void  State::_sub_Op_CallRuntime(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION(UNIVERSE, CallRuntimeDirect_rule, c)
    }
}
void  State::_sub_Op_CallStaticJava(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION(UNIVERSE, CallStaticJavaDirect_rule, c)
    }
}
void  State::_sub_Op_CastDD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION(REGD, castDD_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_CastFF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION(REGF, castFF_rule, c)
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_CastII(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI];
        DFA_PRODUCTION(MREGI, castII_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, castII_rule, c)
        DFA_PRODUCTION(MS0REGI, castII_rule, c)
        DFA_PRODUCTION(MS1REGI, castII_rule, c)
        DFA_PRODUCTION(MS3REGI, castII_rule, c)
        DFA_PRODUCTION(MS4REGI, castII_rule, c)
        DFA_PRODUCTION(MS5REGI, castII_rule, c)
        DFA_PRODUCTION(MS6REGI, castII_rule, c)
        DFA_PRODUCTION(MS7REGI, castII_rule, c)
        DFA_PRODUCTION(MT0REGI, castII_rule, c)
        DFA_PRODUCTION(MT1REGI, castII_rule, c)
        DFA_PRODUCTION(MT2REGI, castII_rule, c)
        DFA_PRODUCTION(MT3REGI, castII_rule, c)
        DFA_PRODUCTION(MT8REGI, castII_rule, c)
        DFA_PRODUCTION(MT4REGI, castII_rule, c)
        DFA_PRODUCTION(MA0REGI, castII_rule, c)
        DFA_PRODUCTION(MA1REGI, castII_rule, c)
        DFA_PRODUCTION(MA2REGI, castII_rule, c)
        DFA_PRODUCTION(MA3REGI, castII_rule, c)
        DFA_PRODUCTION(MA4REGI, castII_rule, c)
        DFA_PRODUCTION(MA5REGI, castII_rule, c)
        DFA_PRODUCTION(MA6REGI, castII_rule, c)
        DFA_PRODUCTION(MA7REGI, castII_rule, c)
    }
}
void  State::_sub_Op_CastLL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL];
        DFA_PRODUCTION(MREGL, castLL_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, castLL_rule, c)
        DFA_PRODUCTION(V1REGL, castLL_rule, c)
        DFA_PRODUCTION(A0REGL, castLL_rule, c)
        DFA_PRODUCTION(A1REGL, castLL_rule, c)
        DFA_PRODUCTION(A2REGL, castLL_rule, c)
        DFA_PRODUCTION(A3REGL, castLL_rule, c)
        DFA_PRODUCTION(T0REGL, castLL_rule, c)
        DFA_PRODUCTION(T1REGL, castLL_rule, c)
        DFA_PRODUCTION(T3REGL, castLL_rule, c)
        DFA_PRODUCTION(T8REGL, castLL_rule, c)
        DFA_PRODUCTION(A4REGL, castLL_rule, c)
        DFA_PRODUCTION(A5REGL, castLL_rule, c)
        DFA_PRODUCTION(A6REGL, castLL_rule, c)
        DFA_PRODUCTION(A7REGL, castLL_rule, c)
        DFA_PRODUCTION(S0REGL, castLL_rule, c)
        DFA_PRODUCTION(S1REGL, castLL_rule, c)
        DFA_PRODUCTION(S3REGL, castLL_rule, c)
        DFA_PRODUCTION(S4REGL, castLL_rule, c)
        DFA_PRODUCTION(S7REGL, castLL_rule, c)
    }
}
void  State::_sub_Op_CastVV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, castVVY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, castVVX_rule, c)
    }
}
void  State::_sub_Op_CastX2P(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+10;
        DFA_PRODUCTION(MREGP, castX2P_rule, c)
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION(NO_T8_MREGP, castX2P_rule, c)
        DFA_PRODUCTION(S1_REGP, castX2P_rule, c)
        DFA_PRODUCTION(S3_REGP, castX2P_rule, c)
        DFA_PRODUCTION(S4_REGP, castX2P_rule, c)
        DFA_PRODUCTION(S5_REGP, castX2P_rule, c)
        DFA_PRODUCTION(S6_REGP, castX2P_rule, c)
        DFA_PRODUCTION(S7_REGP, castX2P_rule, c)
        DFA_PRODUCTION(T0_REGP, castX2P_rule, c)
        DFA_PRODUCTION(T1_REGP, castX2P_rule, c)
        DFA_PRODUCTION(T2_REGP, castX2P_rule, c)
        DFA_PRODUCTION(T3_REGP, castX2P_rule, c)
        DFA_PRODUCTION(A0_REGP, castX2P_rule, c)
        DFA_PRODUCTION(A1_REGP, castX2P_rule, c)
        DFA_PRODUCTION(A2_REGP, castX2P_rule, c)
        DFA_PRODUCTION(A3_REGP, castX2P_rule, c)
        DFA_PRODUCTION(A4_REGP, castX2P_rule, c)
        DFA_PRODUCTION(A5_REGP, castX2P_rule, c)
        DFA_PRODUCTION(A6_REGP, castX2P_rule, c)
        DFA_PRODUCTION(A7_REGP, castX2P_rule, c)
        DFA_PRODUCTION(V0_REGP, castX2P_rule, c)
        DFA_PRODUCTION(V1_REGP, castX2P_rule, c)
        DFA_PRODUCTION(NO_AX_MREGP, castX2P_rule, c)
        DFA_PRODUCTION(T8_REGP, castX2P_rule, c)
        DFA_PRODUCTION(INDIRECT, castX2P_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
    }
}
void  State::_sub_Op_CastP2X(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP];
        DFA_PRODUCTION(_CASTP2X_MREGP_, _CastP2X_mRegP__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+100;
        DFA_PRODUCTION(MREGL, castP2X_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, castP2X_rule, c)
        DFA_PRODUCTION(V1REGL, castP2X_rule, c)
        DFA_PRODUCTION(A0REGL, castP2X_rule, c)
        DFA_PRODUCTION(A1REGL, castP2X_rule, c)
        DFA_PRODUCTION(A2REGL, castP2X_rule, c)
        DFA_PRODUCTION(A3REGL, castP2X_rule, c)
        DFA_PRODUCTION(T0REGL, castP2X_rule, c)
        DFA_PRODUCTION(T1REGL, castP2X_rule, c)
        DFA_PRODUCTION(T3REGL, castP2X_rule, c)
        DFA_PRODUCTION(T8REGL, castP2X_rule, c)
        DFA_PRODUCTION(A4REGL, castP2X_rule, c)
        DFA_PRODUCTION(A5REGL, castP2X_rule, c)
        DFA_PRODUCTION(A6REGL, castP2X_rule, c)
        DFA_PRODUCTION(A7REGL, castP2X_rule, c)
        DFA_PRODUCTION(S0REGL, castP2X_rule, c)
        DFA_PRODUCTION(S1REGL, castP2X_rule, c)
        DFA_PRODUCTION(S3REGL, castP2X_rule, c)
        DFA_PRODUCTION(S4REGL, castP2X_rule, c)
        DFA_PRODUCTION(S7REGL, castP2X_rule, c)
    }
}
void  State::_sub_Op_CastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+100;
        DFA_PRODUCTION(MREGP, castPP_rule, c)
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION(NO_T8_MREGP, castPP_rule, c)
        DFA_PRODUCTION(S1_REGP, castPP_rule, c)
        DFA_PRODUCTION(S3_REGP, castPP_rule, c)
        DFA_PRODUCTION(S4_REGP, castPP_rule, c)
        DFA_PRODUCTION(S5_REGP, castPP_rule, c)
        DFA_PRODUCTION(S6_REGP, castPP_rule, c)
        DFA_PRODUCTION(S7_REGP, castPP_rule, c)
        DFA_PRODUCTION(T0_REGP, castPP_rule, c)
        DFA_PRODUCTION(T1_REGP, castPP_rule, c)
        DFA_PRODUCTION(T2_REGP, castPP_rule, c)
        DFA_PRODUCTION(T3_REGP, castPP_rule, c)
        DFA_PRODUCTION(A0_REGP, castPP_rule, c)
        DFA_PRODUCTION(A1_REGP, castPP_rule, c)
        DFA_PRODUCTION(A2_REGP, castPP_rule, c)
        DFA_PRODUCTION(A3_REGP, castPP_rule, c)
        DFA_PRODUCTION(A4_REGP, castPP_rule, c)
        DFA_PRODUCTION(A5_REGP, castPP_rule, c)
        DFA_PRODUCTION(A6_REGP, castPP_rule, c)
        DFA_PRODUCTION(A7_REGP, castPP_rule, c)
        DFA_PRODUCTION(V0_REGP, castPP_rule, c)
        DFA_PRODUCTION(V1_REGP, castPP_rule, c)
        DFA_PRODUCTION(NO_AX_MREGP, castPP_rule, c)
        DFA_PRODUCTION(T8_REGP, castPP_rule, c)
        DFA_PRODUCTION(INDIRECT, castPP_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
    }
}
void  State::_sub_Op_CheckCastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+100;
        DFA_PRODUCTION(MREGP, checkCastPP_rule, c)
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION(NO_T8_MREGP, checkCastPP_rule, c)
        DFA_PRODUCTION(S1_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(S3_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(S4_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(S5_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(S6_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(S7_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(T0_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(T1_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(T2_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(T3_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(A0_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(A1_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(A2_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(A3_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(A4_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(A5_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(A6_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(A7_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(V0_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(V1_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(NO_AX_MREGP, checkCastPP_rule, c)
        DFA_PRODUCTION(T8_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(INDIRECT, checkCastPP_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
    }
}
void  State::_sub_Op_ClearArray(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMML) && STATE__VALID_CHILD(_kids[1], T3_REGP) ) {
      unsigned int c = _kids[0]->_cost[IMML]+_kids[1]->_cost[T3_REGP]+100;
        DFA_PRODUCTION(UNIVERSE, clear_array_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], T8REGL) && STATE__VALID_CHILD(_kids[1], T3_REGP) ) {
      unsigned int c = _kids[0]->_cost[T8REGL]+_kids[1]->_cost[T3_REGP]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, clear_array_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPP_MREGP_MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPP_MREGP_MREGP]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
        DFA_PRODUCTION(REGD, cmovD_cmpP_reg_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPI_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPI_MREGI_MREGI]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, cmovD_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+100) {
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPD_REGD_REGD) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPD_REGD_REGD]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, cmovD_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+100) {
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
      }
    }
}
void  State::_sub_Op_CMoveF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPF_REGF_REGF) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPF_REGF_REGF]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
        DFA_PRODUCTION(REGF, cmovF_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPI_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPI_MREGI_MREGI]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, cmovF_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+100) {
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
      }
    }
}
void  State::_sub_Op_CMoveI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPF_REGF_REGF) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPF_REGF_REGF]+_kids[1]->_cost[_BINARY_MREGI_MREGI]+80;
        DFA_PRODUCTION(MREGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MS0REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MS1REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MS3REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MS4REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MS5REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MS6REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MS7REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MT0REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MT1REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MT2REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MT3REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MT8REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MT4REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MA0REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MA1REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MA2REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MA3REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MA4REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MA5REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MA6REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION(MA7REGI, cmovI_cmpF_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPD_REGD_REGD) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPD_REGD_REGD]+_kids[1]->_cost[_BINARY_MREGI_MREGI]+80;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, cmovI_cmpD_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPUL_MREGLORI2L_MREGLORI2L) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPUL_MREGLORI2L_MREGLORI2L]+_kids[1]->_cost[_BINARY_MREGI_MREGIORL2I]+80;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, cmovI_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, cmovI_cmpUL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPL_MREGLORI2L_MREGLORI2L) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPL_MREGLORI2L_MREGLORI2L]+_kids[1]->_cost[_BINARY_MREGI_MREGIORL2I]+80;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, cmovI_cmpL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPU_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPU_MREGI_MREGI]+_kids[1]->_cost[_BINARY_MREGI_MREGI]+80;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, cmovI_cmpU_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPN_MREGN_MREGN) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPN_MREGN_MREGN]+_kids[1]->_cost[_BINARY_MREGI_MREGI]+80;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, cmovI_cmpN_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPP_MREGP_MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPP_MREGP_MREGP]+_kids[1]->_cost[_BINARY_MREGI_MREGI]+80;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, cmovI_cmpP_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPI_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPI_MREGI_MREGI]+_kids[1]->_cost[_BINARY_MREGI_MREGI]+80;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, cmovI_cmpI_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, cmovI_cmpI_dst_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPI_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGI) &&
        /*src1*/(_kids[0]->_kids[1]->_kids[0]->_leaf == _kids[1]->_kids[1]->_leaf) && /*src2*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPI_MREGI_MREGI]+_kids[1]->_cost[_BINARY_MREGI_MREGI]+50;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, cmovI_cmpI_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, cmovI_cmpI_reg_reg2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPI_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGI) &&
        /*src1*/(_kids[0]->_kids[1]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*src2*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPI_MREGI_MREGI]+_kids[1]->_cost[_BINARY_MREGI_MREGI]+50;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, cmovI_cmpI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPD_REGD_REGD) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPD_REGD_REGD]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+80;
        DFA_PRODUCTION(MREGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION(V1REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION(A0REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION(A1REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION(A2REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION(A3REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION(T0REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION(T1REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION(T3REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION(T8REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION(A4REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION(A5REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION(A6REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION(A7REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION(S0REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION(S1REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION(S3REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION(S4REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION(S7REGL, cmovL_cmpD_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPN_MREGN_MREGN) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPN_MREGN_MREGN]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, cmovL_cmpN_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPUL_MREGL_MREGL) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPUL_MREGL_MREGL]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, cmovL_cmpUL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, cmovL_cmpUL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, cmovL_cmpUL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, cmovL_cmpUL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, cmovL_cmpUL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, cmovL_cmpUL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, cmovL_cmpUL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, cmovL_cmpUL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, cmovL_cmpUL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, cmovL_cmpUL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, cmovL_cmpUL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, cmovL_cmpUL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, cmovL_cmpUL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, cmovL_cmpUL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, cmovL_cmpUL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, cmovL_cmpUL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, cmovL_cmpUL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, cmovL_cmpUL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, cmovL_cmpUL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, cmovL_cmpUL_dst_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPL_MREGL_MREGL) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPL_MREGL_MREGL]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, cmovL_cmpL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, cmovL_cmpL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, cmovL_cmpL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, cmovL_cmpL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, cmovL_cmpL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, cmovL_cmpL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, cmovL_cmpL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, cmovL_cmpL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, cmovL_cmpL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, cmovL_cmpL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, cmovL_cmpL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, cmovL_cmpL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, cmovL_cmpL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, cmovL_cmpL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, cmovL_cmpL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, cmovL_cmpL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, cmovL_cmpL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, cmovL_cmpL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, cmovL_cmpL_dst_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, cmovL_cmpL_dst_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPUL_MREGL_MREGL) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) &&
        /*src1*/(_kids[0]->_kids[1]->_kids[0]->_leaf == _kids[1]->_kids[1]->_leaf) && /*src2*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPUL_MREGL_MREGL]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+50;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, cmovL_cmpUL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, cmovL_cmpUL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, cmovL_cmpUL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, cmovL_cmpUL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, cmovL_cmpUL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, cmovL_cmpUL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, cmovL_cmpUL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, cmovL_cmpUL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, cmovL_cmpUL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, cmovL_cmpUL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, cmovL_cmpUL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, cmovL_cmpUL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, cmovL_cmpUL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, cmovL_cmpUL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, cmovL_cmpUL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, cmovL_cmpUL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, cmovL_cmpUL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, cmovL_cmpUL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, cmovL_cmpUL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, cmovL_cmpUL_reg_reg2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPL_MREGL_MREGL) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) &&
        /*src1*/(_kids[0]->_kids[1]->_kids[0]->_leaf == _kids[1]->_kids[1]->_leaf) && /*src2*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPL_MREGL_MREGL]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+50;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, cmovL_cmpL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, cmovL_cmpL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, cmovL_cmpL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, cmovL_cmpL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, cmovL_cmpL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, cmovL_cmpL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, cmovL_cmpL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, cmovL_cmpL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, cmovL_cmpL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, cmovL_cmpL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, cmovL_cmpL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, cmovL_cmpL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, cmovL_cmpL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, cmovL_cmpL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, cmovL_cmpL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, cmovL_cmpL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, cmovL_cmpL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, cmovL_cmpL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, cmovL_cmpL_reg_reg2_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, cmovL_cmpL_reg_reg2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPUL_MREGL_MREGL) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) &&
        /*src1*/(_kids[0]->_kids[1]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*src2*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPUL_MREGL_MREGL]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+50;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, cmovL_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, cmovL_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, cmovL_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, cmovL_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, cmovL_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, cmovL_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, cmovL_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, cmovL_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, cmovL_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, cmovL_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, cmovL_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, cmovL_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, cmovL_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, cmovL_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, cmovL_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, cmovL_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, cmovL_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, cmovL_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, cmovL_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, cmovL_cmpUL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPL_MREGL_MREGL) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) &&
        /*src1*/(_kids[0]->_kids[1]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*src2*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPL_MREGL_MREGL]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+50;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, cmovL_cmpL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPI_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPI_MREGI_MREGI]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, cmovL_cmpI_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPF_REGF_REGF) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPF_REGF_REGF]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, cmovL_cmpF_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPU_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPU_MREGI_MREGI]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, cmovL_cmpU_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPP_MREGP_MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPP_MREGP_MREGP]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, cmovL_cmpP_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPI_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPI_MREGI_MREGI]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+80;
        DFA_PRODUCTION(MREGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION(NO_T8_MREGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(S1_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(S3_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(S4_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(S5_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(S6_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(S7_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(T0_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(T1_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(T2_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(T3_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(A0_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(A1_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(A2_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(A3_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(A4_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(A5_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(A6_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(A7_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(V0_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(V1_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(NO_AX_MREGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(T8_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(INDIRECT, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPP_MREGP_MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPP_MREGP_MREGP]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+80;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION(MREGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION(NO_T8_MREGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION(S1_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION(S3_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION(S4_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION(S5_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION(S6_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION(S7_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION(T0_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION(T1_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION(T2_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION(T3_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION(A0_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION(A1_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION(A2_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION(A3_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION(A4_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION(A5_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION(A6_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION(A7_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION(V0_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION(V1_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION(NO_AX_MREGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION(T8_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPUL_MREGLORI2L_MREGLORI2L) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPUL_MREGLORI2L_MREGLORI2L]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+80;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION(MREGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION(NO_T8_MREGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION(S1_REGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION(S3_REGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION(S4_REGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION(S5_REGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION(S6_REGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION(S7_REGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION(T0_REGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION(T1_REGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION(T2_REGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION(T3_REGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION(A0_REGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION(A1_REGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION(A2_REGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION(A3_REGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION(A4_REGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION(A5_REGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION(A6_REGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION(A7_REGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION(V0_REGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION(V1_REGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION(NO_AX_MREGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION(T8_REGP, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, cmovP_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPL_MREGLORI2L_MREGLORI2L) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPL_MREGLORI2L_MREGLORI2L]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+80;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION(MREGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION(NO_T8_MREGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION(S1_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION(S3_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION(S4_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION(S5_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION(S6_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION(S7_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION(T0_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION(T1_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION(T2_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION(T3_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION(A0_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION(A1_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION(A2_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION(A3_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION(A4_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION(A5_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION(A6_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION(A7_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION(V0_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION(V1_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION(NO_AX_MREGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION(T8_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPD_REGD_REGD) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPD_REGD_REGD]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+80;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION(MREGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION(NO_T8_MREGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION(S1_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION(S3_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION(S4_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION(S5_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION(S6_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION(S7_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION(T0_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION(T1_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION(T2_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION(T3_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION(A0_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION(A1_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION(A2_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION(A3_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION(A4_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION(A5_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION(A6_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION(A7_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION(V0_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION(V1_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION(NO_AX_MREGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION(T8_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPN_MREGN_MREGN) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPN_MREGN_MREGN]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+80;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION(MREGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION(NO_T8_MREGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION(S1_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION(S3_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION(S4_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION(S5_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION(S6_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION(S7_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION(T0_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION(T1_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION(T2_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION(T3_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION(A0_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION(A1_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION(A2_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION(A3_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION(A4_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION(A5_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION(A6_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION(A7_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION(V0_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION(V1_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION(NO_AX_MREGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION(T8_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPF_REGF_REGF) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPF_REGF_REGF]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+80;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION(MREGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION(NO_T8_MREGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION(S1_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION(S3_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION(S4_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION(S5_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION(S6_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION(S7_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION(T0_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION(T1_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION(T2_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION(T3_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION(A0_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION(A1_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION(A2_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION(A3_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION(A4_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION(A5_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION(A6_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION(A7_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION(V0_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION(V1_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION(NO_AX_MREGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION(T8_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPU_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPU_MREGI_MREGI]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+80;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION(MREGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION(NO_T8_MREGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION(S1_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION(S3_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION(S4_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION(S5_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION(S6_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION(S7_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION(T0_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION(T1_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION(T2_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION(T3_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION(A0_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION(A1_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION(A2_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION(A3_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION(A4_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION(A5_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION(A6_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION(A7_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION(V0_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION(V1_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION(NO_AX_MREGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION(T8_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPI_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPI_MREGI_MREGI]+_kids[1]->_cost[_BINARY_MREGN_MREGN]+80;
        DFA_PRODUCTION(MREGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(T0_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(T1_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(T3_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(T8_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(A0_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(A1_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(A2_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(A3_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(A4_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(A5_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(A6_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(A7_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(S0_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(S1_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(S2_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(S3_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(S4_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(S5_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(S6_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION(S7_REGN, cmovN_cmpI_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPUL_MREGL_MREGL) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPUL_MREGL_MREGL]+_kids[1]->_cost[_BINARY_MREGN_MREGN]+80;
      if (STATE__NOT_YET_VALID(MREGN) || _cost[MREGN] > c) {
        DFA_PRODUCTION(MREGN, cmovN_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGN) || _cost[T0_REGN] > c) {
        DFA_PRODUCTION(T0_REGN, cmovN_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGN) || _cost[T1_REGN] > c) {
        DFA_PRODUCTION(T1_REGN, cmovN_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGN) || _cost[T3_REGN] > c) {
        DFA_PRODUCTION(T3_REGN, cmovN_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGN) || _cost[T8_REGN] > c) {
        DFA_PRODUCTION(T8_REGN, cmovN_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGN) || _cost[A0_REGN] > c) {
        DFA_PRODUCTION(A0_REGN, cmovN_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGN) || _cost[A1_REGN] > c) {
        DFA_PRODUCTION(A1_REGN, cmovN_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGN) || _cost[A2_REGN] > c) {
        DFA_PRODUCTION(A2_REGN, cmovN_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGN) || _cost[A3_REGN] > c) {
        DFA_PRODUCTION(A3_REGN, cmovN_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGN) || _cost[A4_REGN] > c) {
        DFA_PRODUCTION(A4_REGN, cmovN_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGN) || _cost[A5_REGN] > c) {
        DFA_PRODUCTION(A5_REGN, cmovN_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGN) || _cost[A6_REGN] > c) {
        DFA_PRODUCTION(A6_REGN, cmovN_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGN) || _cost[A7_REGN] > c) {
        DFA_PRODUCTION(A7_REGN, cmovN_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGN) || _cost[S0_REGN] > c) {
        DFA_PRODUCTION(S0_REGN, cmovN_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGN) || _cost[S1_REGN] > c) {
        DFA_PRODUCTION(S1_REGN, cmovN_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGN) || _cost[S2_REGN] > c) {
        DFA_PRODUCTION(S2_REGN, cmovN_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGN) || _cost[S3_REGN] > c) {
        DFA_PRODUCTION(S3_REGN, cmovN_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGN) || _cost[S4_REGN] > c) {
        DFA_PRODUCTION(S4_REGN, cmovN_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGN) || _cost[S5_REGN] > c) {
        DFA_PRODUCTION(S5_REGN, cmovN_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGN) || _cost[S6_REGN] > c) {
        DFA_PRODUCTION(S6_REGN, cmovN_cmpUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGN) || _cost[S7_REGN] > c) {
        DFA_PRODUCTION(S7_REGN, cmovN_cmpUL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPL_MREGL_MREGL) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPL_MREGL_MREGL]+_kids[1]->_cost[_BINARY_MREGN_MREGN]+80;
      if (STATE__NOT_YET_VALID(MREGN) || _cost[MREGN] > c) {
        DFA_PRODUCTION(MREGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGN) || _cost[T0_REGN] > c) {
        DFA_PRODUCTION(T0_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGN) || _cost[T1_REGN] > c) {
        DFA_PRODUCTION(T1_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGN) || _cost[T3_REGN] > c) {
        DFA_PRODUCTION(T3_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGN) || _cost[T8_REGN] > c) {
        DFA_PRODUCTION(T8_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGN) || _cost[A0_REGN] > c) {
        DFA_PRODUCTION(A0_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGN) || _cost[A1_REGN] > c) {
        DFA_PRODUCTION(A1_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGN) || _cost[A2_REGN] > c) {
        DFA_PRODUCTION(A2_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGN) || _cost[A3_REGN] > c) {
        DFA_PRODUCTION(A3_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGN) || _cost[A4_REGN] > c) {
        DFA_PRODUCTION(A4_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGN) || _cost[A5_REGN] > c) {
        DFA_PRODUCTION(A5_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGN) || _cost[A6_REGN] > c) {
        DFA_PRODUCTION(A6_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGN) || _cost[A7_REGN] > c) {
        DFA_PRODUCTION(A7_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGN) || _cost[S0_REGN] > c) {
        DFA_PRODUCTION(S0_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGN) || _cost[S1_REGN] > c) {
        DFA_PRODUCTION(S1_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGN) || _cost[S2_REGN] > c) {
        DFA_PRODUCTION(S2_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGN) || _cost[S3_REGN] > c) {
        DFA_PRODUCTION(S3_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGN) || _cost[S4_REGN] > c) {
        DFA_PRODUCTION(S4_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGN) || _cost[S5_REGN] > c) {
        DFA_PRODUCTION(S5_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGN) || _cost[S6_REGN] > c) {
        DFA_PRODUCTION(S6_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGN) || _cost[S7_REGN] > c) {
        DFA_PRODUCTION(S7_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPU_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPU_MREGI_MREGI]+_kids[1]->_cost[_BINARY_MREGN_MREGN]+80;
      if (STATE__NOT_YET_VALID(MREGN) || _cost[MREGN] > c) {
        DFA_PRODUCTION(MREGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGN) || _cost[T0_REGN] > c) {
        DFA_PRODUCTION(T0_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGN) || _cost[T1_REGN] > c) {
        DFA_PRODUCTION(T1_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGN) || _cost[T3_REGN] > c) {
        DFA_PRODUCTION(T3_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGN) || _cost[T8_REGN] > c) {
        DFA_PRODUCTION(T8_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGN) || _cost[A0_REGN] > c) {
        DFA_PRODUCTION(A0_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGN) || _cost[A1_REGN] > c) {
        DFA_PRODUCTION(A1_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGN) || _cost[A2_REGN] > c) {
        DFA_PRODUCTION(A2_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGN) || _cost[A3_REGN] > c) {
        DFA_PRODUCTION(A3_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGN) || _cost[A4_REGN] > c) {
        DFA_PRODUCTION(A4_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGN) || _cost[A5_REGN] > c) {
        DFA_PRODUCTION(A5_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGN) || _cost[A6_REGN] > c) {
        DFA_PRODUCTION(A6_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGN) || _cost[A7_REGN] > c) {
        DFA_PRODUCTION(A7_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGN) || _cost[S0_REGN] > c) {
        DFA_PRODUCTION(S0_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGN) || _cost[S1_REGN] > c) {
        DFA_PRODUCTION(S1_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGN) || _cost[S2_REGN] > c) {
        DFA_PRODUCTION(S2_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGN) || _cost[S3_REGN] > c) {
        DFA_PRODUCTION(S3_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGN) || _cost[S4_REGN] > c) {
        DFA_PRODUCTION(S4_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGN) || _cost[S5_REGN] > c) {
        DFA_PRODUCTION(S5_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGN) || _cost[S6_REGN] > c) {
        DFA_PRODUCTION(S6_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGN) || _cost[S7_REGN] > c) {
        DFA_PRODUCTION(S7_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPN_MREGN_MREGN) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPN_MREGN_MREGN]+_kids[1]->_cost[_BINARY_MREGN_MREGN]+80;
      if (STATE__NOT_YET_VALID(MREGN) || _cost[MREGN] > c) {
        DFA_PRODUCTION(MREGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGN) || _cost[T0_REGN] > c) {
        DFA_PRODUCTION(T0_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGN) || _cost[T1_REGN] > c) {
        DFA_PRODUCTION(T1_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGN) || _cost[T3_REGN] > c) {
        DFA_PRODUCTION(T3_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGN) || _cost[T8_REGN] > c) {
        DFA_PRODUCTION(T8_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGN) || _cost[A0_REGN] > c) {
        DFA_PRODUCTION(A0_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGN) || _cost[A1_REGN] > c) {
        DFA_PRODUCTION(A1_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGN) || _cost[A2_REGN] > c) {
        DFA_PRODUCTION(A2_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGN) || _cost[A3_REGN] > c) {
        DFA_PRODUCTION(A3_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGN) || _cost[A4_REGN] > c) {
        DFA_PRODUCTION(A4_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGN) || _cost[A5_REGN] > c) {
        DFA_PRODUCTION(A5_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGN) || _cost[A6_REGN] > c) {
        DFA_PRODUCTION(A6_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGN) || _cost[A7_REGN] > c) {
        DFA_PRODUCTION(A7_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGN) || _cost[S0_REGN] > c) {
        DFA_PRODUCTION(S0_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGN) || _cost[S1_REGN] > c) {
        DFA_PRODUCTION(S1_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGN) || _cost[S2_REGN] > c) {
        DFA_PRODUCTION(S2_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGN) || _cost[S3_REGN] > c) {
        DFA_PRODUCTION(S3_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGN) || _cost[S4_REGN] > c) {
        DFA_PRODUCTION(S4_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGN) || _cost[S5_REGN] > c) {
        DFA_PRODUCTION(S5_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGN) || _cost[S6_REGN] > c) {
        DFA_PRODUCTION(S6_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGN) || _cost[S7_REGN] > c) {
        DFA_PRODUCTION(S7_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPP_MREGP_MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPP_MREGP_MREGP]+_kids[1]->_cost[_BINARY_MREGN_MREGN]+80;
      if (STATE__NOT_YET_VALID(MREGN) || _cost[MREGN] > c) {
        DFA_PRODUCTION(MREGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGN) || _cost[T0_REGN] > c) {
        DFA_PRODUCTION(T0_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGN) || _cost[T1_REGN] > c) {
        DFA_PRODUCTION(T1_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGN) || _cost[T3_REGN] > c) {
        DFA_PRODUCTION(T3_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGN) || _cost[T8_REGN] > c) {
        DFA_PRODUCTION(T8_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGN) || _cost[A0_REGN] > c) {
        DFA_PRODUCTION(A0_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGN) || _cost[A1_REGN] > c) {
        DFA_PRODUCTION(A1_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGN) || _cost[A2_REGN] > c) {
        DFA_PRODUCTION(A2_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGN) || _cost[A3_REGN] > c) {
        DFA_PRODUCTION(A3_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGN) || _cost[A4_REGN] > c) {
        DFA_PRODUCTION(A4_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGN) || _cost[A5_REGN] > c) {
        DFA_PRODUCTION(A5_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGN) || _cost[A6_REGN] > c) {
        DFA_PRODUCTION(A6_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGN) || _cost[A7_REGN] > c) {
        DFA_PRODUCTION(A7_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGN) || _cost[S0_REGN] > c) {
        DFA_PRODUCTION(S0_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGN) || _cost[S1_REGN] > c) {
        DFA_PRODUCTION(S1_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGN) || _cost[S2_REGN] > c) {
        DFA_PRODUCTION(S2_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGN) || _cost[S3_REGN] > c) {
        DFA_PRODUCTION(S3_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGN) || _cost[S4_REGN] > c) {
        DFA_PRODUCTION(S4_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGN) || _cost[S5_REGN] > c) {
        DFA_PRODUCTION(S5_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGN) || _cost[S6_REGN] > c) {
        DFA_PRODUCTION(S6_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGN) || _cost[S7_REGN] > c) {
        DFA_PRODUCTION(S7_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGN) && STATE__VALID_CHILD(_kids[1], MREGN) ) {
      unsigned int c = _kids[0]->_cost[MREGN]+_kids[1]->_cost[MREGN];
        DFA_PRODUCTION(_CMPN_MREGN_MREGN, _CmpN_mRegN_mRegN_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGN) && STATE__VALID_CHILD(_kids[1], IMMN_0) ) {
      unsigned int c = _kids[0]->_cost[MREGN]+_kids[1]->_cost[IMMN_0];
        DFA_PRODUCTION(_CMPN_MREGN_IMMN_0, _CmpN_mRegN_immN_0_rule, c)
    }
}
void  State::_sub_Op_CmpD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD];
        DFA_PRODUCTION(_CMPD_REGD_REGD, _CmpD_regD_regD_rule, c)
    }
}
void  State::_sub_Op_CmpD3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+1000;
        DFA_PRODUCTION(MREGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MS0REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MS1REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MS3REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MS4REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MS5REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MS6REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MS7REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MT0REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MT1REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MT2REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MT3REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MT8REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MT4REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MA0REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MA1REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MA2REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MA3REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MA4REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MA5REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MA6REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(MA7REGI, cmpD3_reg_reg_rule, c)
    }
}
void  State::_sub_Op_CmpF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF];
        DFA_PRODUCTION(_CMPF_REGF_REGF, _CmpF_regF_regF_rule, c)
    }
}
void  State::_sub_Op_CmpF3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+1000;
        DFA_PRODUCTION(MREGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MS0REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MS1REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MS3REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MS4REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MS5REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MS6REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MS7REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MT0REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MT1REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MT2REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MT3REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MT8REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MT4REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MA0REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MA1REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MA2REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MA3REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MA4REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MA5REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MA6REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(MA7REGI, cmpF3_reg_reg_rule, c)
    }
}
void  State::_sub_Op_CmpI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION(_CMPI_MREGI_IMMI, _CmpI_mRegI_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI];
        DFA_PRODUCTION(_CMPI_MREGI_MREGI, _CmpI_mRegI_mRegI_rule, c)
    }
}
void  State::_sub_Op_CmpL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGL];
        DFA_PRODUCTION(_CMPL_MREGL_MREGL, _CmpL_mRegL_mRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML];
        DFA_PRODUCTION(_CMPL_MREGL_IMML, _CmpL_mRegL_immL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], MREGLORI2L) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[MREGLORI2L];
        DFA_PRODUCTION(_CMPL_MREGLORI2L_MREGLORI2L, _CmpL_mRegLorI2L_mRegLorI2L_rule, c)
    }
}
void  State::_sub_Op_CmpL3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGL]+1000;
        DFA_PRODUCTION(MREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MS0REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MS1REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MS3REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MS4REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MS5REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MS6REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MS7REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MT0REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MT1REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MT2REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MT3REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MT8REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MT4REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MA0REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MA1REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MA2REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MA3REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MA4REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MA5REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MA6REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(MA7REGI, cmpL3_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_0) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_0]+1000;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, cmpL3_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, cmpL3_reg_zero_rule, c)
      }
    }
}
void  State::_sub_Op_CmpLTMask(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+400;
        DFA_PRODUCTION(MREGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MS0REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MS1REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MS3REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MS4REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MS5REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MS6REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MS7REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MT0REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MT1REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MT2REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MT3REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MT8REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MT4REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MA0REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MA1REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MA2REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MA3REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MA4REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MA5REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MA6REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION(MA7REGI, cmpLTMask_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_0) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_0]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, cmpLTMask_immI_0_rule, c)
      }
    }
}
void  State::_sub_Op_CmpP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[MREGP];
        DFA_PRODUCTION(_CMPP_MREGP_MREGP, _CmpP_mRegP_mRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_MREGN_) && STATE__VALID_CHILD(_kids[1], IMMP_0) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_MREGN_]+_kids[1]->_cost[IMMP_0];
        DFA_PRODUCTION(_CMPP__DECODEN_MREGN__IMMP_0, _CmpP__DecodeN_mRegN__immP_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], IMMP_0) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[IMMP_0];
        DFA_PRODUCTION(_CMPP_MREGP_IMMP_0, _CmpP_mRegP_immP_0_rule, c)
    }
}
void  State::_sub_Op_CmpU(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION(_CMPU_MREGI_IMMI, _CmpU_mRegI_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI];
        DFA_PRODUCTION(_CMPU_MREGI_MREGI, _CmpU_mRegI_mRegI_rule, c)
    }
}
void  State::_sub_Op_CmpUL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGL];
        DFA_PRODUCTION(_CMPUL_MREGL_MREGL, _CmpUL_mRegL_mRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML];
        DFA_PRODUCTION(_CMPUL_MREGL_IMML, _CmpUL_mRegL_immL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], MREGLORI2L) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[MREGLORI2L];
        DFA_PRODUCTION(_CMPUL_MREGLORI2L_MREGLORI2L, _CmpUL_mRegLorI2L_mRegLorI2L_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_BINARY_MREGI_MREGI]+3 * MEMORY_REF_COST;
        DFA_PRODUCTION(MREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MS0REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MS1REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MS3REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MS4REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MS5REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MS6REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MS7REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MT0REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MT1REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MT2REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MT3REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MT8REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MT4REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MA0REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MA1REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MA2REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MA3REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MA4REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MA5REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MA6REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION(MA7REGI, compareAndSwapI_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) &&
        (
#line 10597 "src/hotspot/cpu/loongarch/loongarch_64.ad"
VM_Version::supports_cx8()
#line 6721 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+3 * MEMORY_REF_COST;
        DFA_PRODUCTION(MREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MS0REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MS1REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MS3REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MS4REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MS5REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MS6REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MS7REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MT0REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MT1REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MT2REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MT3REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MT8REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MT4REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MA0REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MA1REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MA2REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MA3REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MA4REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MA5REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MA6REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION(MA7REGI, compareAndSwapL_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) &&
        (
#line 156 "src/hotspot/cpu/loongarch/gc/z/z_loongarch_64.ad"
(UseZGC && n->as_LoadStore()->barrier_data() == ZLoadBarrierStrong)
#line 6756 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+4 * MEMORY_REF_COST;
        DFA_PRODUCTION(MREGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MS0REGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MS1REGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MS3REGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MS4REGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MS5REGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MS6REGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MS7REGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MT0REGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MT1REGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MT2REGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MT3REGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MT8REGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MT4REGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MA0REGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MA1REGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MA2REGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MA3REGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MA4REGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MA5REGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MA6REGI, zCompareAndSwapP_acq_rule, c)
        DFA_PRODUCTION(MA7REGI, zCompareAndSwapP_acq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) &&
        (
#line 137 "src/hotspot/cpu/loongarch/gc/z/z_loongarch_64.ad"
(UseZGC && n->as_LoadStore()->barrier_data() == ZLoadBarrierStrong)
            && (((CompareAndSwapNode*)n)->order() != MemNode::acquire && ((CompareAndSwapNode*) n)->order() != MemNode::seqcst)
#line 6790 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+3 * MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, zCompareAndSwapP_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) &&
        (
#line 10619 "src/hotspot/cpu/loongarch/loongarch_64.ad"
n->as_LoadStore()->barrier_data() == 0
#line 6873 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+3 * MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, compareAndSwapP_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndSwapN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_BINARY_MREGN_MREGN]+3 * MEMORY_REF_COST;
        DFA_PRODUCTION(MREGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MS0REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MS1REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MS3REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MS4REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MS5REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MS6REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MS7REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MT0REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MT1REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MT2REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MT3REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MT8REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MT4REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MA0REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MA1REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MA2REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MA3REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MA4REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MA5REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MA6REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION(MA7REGI, compareAndSwapN_rule, c)
    }
}
void  State::_sub_Op_WeakCompareAndSwapI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_MREGI_MREGI]+2 * MEMORY_REF_COST;
        DFA_PRODUCTION(MREGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MS0REGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MS1REGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MS3REGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MS4REGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MS5REGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MS6REGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MS7REGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MT0REGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MT1REGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MT2REGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MT3REGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MT8REGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MT4REGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MA0REGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MA1REGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MA2REGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MA3REGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MA4REGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MA5REGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MA6REGI, weakCompareAndSwapI_rule, c)
        DFA_PRODUCTION(MA7REGI, weakCompareAndSwapI_rule, c)
    }
}
void  State::_sub_Op_WeakCompareAndSwapL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+2 * MEMORY_REF_COST;
        DFA_PRODUCTION(MREGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MS0REGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MS1REGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MS3REGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MS4REGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MS5REGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MS6REGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MS7REGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MT0REGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MT1REGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MT2REGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MT3REGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MT8REGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MT4REGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MA0REGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MA1REGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MA2REGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MA3REGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MA4REGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MA5REGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MA6REGI, weakCompareAndSwapL_rule, c)
        DFA_PRODUCTION(MA7REGI, weakCompareAndSwapL_rule, c)
    }
}
void  State::_sub_Op_WeakCompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) &&
        (
#line 194 "src/hotspot/cpu/loongarch/gc/z/z_loongarch_64.ad"
(UseZGC && n->as_LoadStore()->barrier_data() == ZLoadBarrierStrong)
#line 7048 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+2* MEMORY_REF_COST;
        DFA_PRODUCTION(MREGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MS0REGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MS1REGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MS3REGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MS4REGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MS5REGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MS6REGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MS7REGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MT0REGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MT1REGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MT2REGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MT3REGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MT8REGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MT4REGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MA0REGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MA1REGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MA2REGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MA3REGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MA4REGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MA5REGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MA6REGI, zCompareAndSwapPWeak_acq_rule, c)
        DFA_PRODUCTION(MA7REGI, zCompareAndSwapPWeak_acq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) &&
        (
#line 174 "src/hotspot/cpu/loongarch/gc/z/z_loongarch_64.ad"
(UseZGC && n->as_LoadStore()->barrier_data() == ZLoadBarrierStrong)
            && ((CompareAndSwapNode*)n)->order() != MemNode::acquire && ((CompareAndSwapNode*) n)->order() != MemNode::seqcst
#line 7082 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_BINARY_MREGP_MREGP] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, zCompareAndSwapPWeak_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, zCompareAndSwapPWeak_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) &&
        (
#line 10923 "src/hotspot/cpu/loongarch/loongarch_64.ad"
n->as_LoadStore()->barrier_data() == 0
#line 7165 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+2 * MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, weakCompareAndSwapP_acq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, weakCompareAndSwapP_acq_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) &&
        (
#line 10901 "src/hotspot/cpu/loongarch/loongarch_64.ad"
(((CompareAndSwapNode*)n)->order() != MemNode::acquire && ((CompareAndSwapNode*)n)->order() != MemNode::seqcst) && n->as_LoadStore()->barrier_data() == 0
#line 7248 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_MREGP_MREGP] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, weakCompareAndSwapP_rule, c)
      }
    }
}
void  State::_sub_Op_WeakCompareAndSwapN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_MREGN_MREGN]+2 * MEMORY_REF_COST;
        DFA_PRODUCTION(MREGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MS0REGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MS1REGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MS3REGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MS4REGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MS5REGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MS6REGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MS7REGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MT0REGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MT1REGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MT2REGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MT3REGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MT8REGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MT4REGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MA0REGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MA1REGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MA2REGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MA3REGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MA4REGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MA5REGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MA6REGI, weakCompareAndSwapN_rule, c)
        DFA_PRODUCTION(MA7REGI, weakCompareAndSwapN_rule, c)
    }
}
void  State::_sub_Op_CompareAndExchangeI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_MREGI_MREGI]+2 * MEMORY_REF_COST;
        DFA_PRODUCTION(MREGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MS0REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MS1REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MS3REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MS4REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MS5REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MS6REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MS7REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MT0REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MT1REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MT2REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MT3REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MT8REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MT4REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MA0REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MA1REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MA2REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MA3REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MA4REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MA5REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MA6REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION(MA7REGI, compareAndExchangeI_rule, c)
    }
}
void  State::_sub_Op_CompareAndExchangeL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+2 * MEMORY_REF_COST;
        DFA_PRODUCTION(MREGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION(V1REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION(A0REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION(A1REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION(A2REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION(A3REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION(T0REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION(T1REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION(T3REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION(T8REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION(A4REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION(A5REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION(A6REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION(A7REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION(S0REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION(S1REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION(S3REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION(S4REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION(S7REGL, compareAndExchangeL_rule, c)
    }
}
void  State::_sub_Op_CompareAndExchangeP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) &&
        (
#line 234 "src/hotspot/cpu/loongarch/gc/z/z_loongarch_64.ad"
(UseZGC && n->as_LoadStore()->barrier_data() == ZLoadBarrierStrong)
            && (
              ((CompareAndSwapNode*)n)->order() == MemNode::acquire
              || ((CompareAndSwapNode*)n)->order() == MemNode::seqcst
            )
#line 7424 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+100;
        DFA_PRODUCTION(MREGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION(NO_T8_MREGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(S1_REGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(S3_REGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(S4_REGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(S5_REGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(S6_REGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(S7_REGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(T0_REGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(T1_REGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(T2_REGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(T3_REGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(A0_REGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(A1_REGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(A2_REGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(A3_REGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(A4_REGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(A5_REGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(A6_REGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(A7_REGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(V0_REGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(V1_REGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(NO_AX_MREGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(T8_REGP, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(INDIRECT, zCompareAndExchangeP_acq_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) &&
        (
#line 213 "src/hotspot/cpu/loongarch/gc/z/z_loongarch_64.ad"
(UseZGC && n->as_LoadStore()->barrier_data() == ZLoadBarrierStrong)
            && (
              ((CompareAndSwapNode*)n)->order() != MemNode::acquire
              && ((CompareAndSwapNode*)n)->order() != MemNode::seqcst
            )
#line 7464 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+2* MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION(MREGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION(NO_T8_MREGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION(S1_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION(S3_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION(S4_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION(S5_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION(S6_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION(S7_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION(T0_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION(T1_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION(T2_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION(T3_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION(A0_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION(A1_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION(A2_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION(A3_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION(A4_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION(A5_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION(A6_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION(A7_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION(V0_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION(V1_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION(NO_AX_MREGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION(T8_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) &&
        (
#line 10821 "src/hotspot/cpu/loongarch/loongarch_64.ad"
n->as_LoadStore()->barrier_data() == 0
#line 7556 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+2 * MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION(MREGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION(NO_T8_MREGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION(S1_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION(S3_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION(S4_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION(S5_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION(S6_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION(S7_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION(T0_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION(T1_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION(T2_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION(T3_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION(A0_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION(A1_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION(A2_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION(A3_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION(A4_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION(A5_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION(A6_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION(A7_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION(V0_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION(V1_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION(NO_AX_MREGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION(T8_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndExchangeN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_MREGN_MREGN]+2 * MEMORY_REF_COST;
        DFA_PRODUCTION(MREGN, compareAndExchangeN_rule, c)
        DFA_PRODUCTION(T0_REGN, compareAndExchangeN_rule, c)
        DFA_PRODUCTION(T1_REGN, compareAndExchangeN_rule, c)
        DFA_PRODUCTION(T3_REGN, compareAndExchangeN_rule, c)
        DFA_PRODUCTION(T8_REGN, compareAndExchangeN_rule, c)
        DFA_PRODUCTION(A0_REGN, compareAndExchangeN_rule, c)
        DFA_PRODUCTION(A1_REGN, compareAndExchangeN_rule, c)
        DFA_PRODUCTION(A2_REGN, compareAndExchangeN_rule, c)
        DFA_PRODUCTION(A3_REGN, compareAndExchangeN_rule, c)
        DFA_PRODUCTION(A4_REGN, compareAndExchangeN_rule, c)
        DFA_PRODUCTION(A5_REGN, compareAndExchangeN_rule, c)
        DFA_PRODUCTION(A6_REGN, compareAndExchangeN_rule, c)
        DFA_PRODUCTION(A7_REGN, compareAndExchangeN_rule, c)
        DFA_PRODUCTION(S0_REGN, compareAndExchangeN_rule, c)
        DFA_PRODUCTION(S1_REGN, compareAndExchangeN_rule, c)
        DFA_PRODUCTION(S2_REGN, compareAndExchangeN_rule, c)
        DFA_PRODUCTION(S3_REGN, compareAndExchangeN_rule, c)
        DFA_PRODUCTION(S4_REGN, compareAndExchangeN_rule, c)
        DFA_PRODUCTION(S5_REGN, compareAndExchangeN_rule, c)
        DFA_PRODUCTION(S6_REGN, compareAndExchangeN_rule, c)
        DFA_PRODUCTION(S7_REGN, compareAndExchangeN_rule, c)
    }
}
void  State::_sub_Op_GetAndAddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], MREGIORL2I) &&
        (
#line 10774 "src/hotspot/cpu/loongarch/loongarch_64.ad"
n->as_LoadStore()->result_not_used()
#line 7676 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[MREGIORL2I]+2 * MEMORY_REF_COST;
        DFA_PRODUCTION(UNIVERSE, get_and_addI_no_res_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], MREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[MREGIORL2I]+2 * MEMORY_REF_COST + 1;
        DFA_PRODUCTION(MREGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MS0REGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MS1REGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MS3REGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MS4REGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MS5REGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MS6REGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MS7REGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MT0REGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MT1REGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MT2REGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MT3REGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MT8REGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MT4REGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MA0REGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MA1REGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MA2REGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MA3REGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MA4REGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MA5REGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MA6REGI, get_and_addI_rule, c)
        DFA_PRODUCTION(MA7REGI, get_and_addI_rule, c)
    }
}
void  State::_sub_Op_GetAndAddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], MREGL) &&
        (
#line 10745 "src/hotspot/cpu/loongarch/loongarch_64.ad"
n->as_LoadStore()->result_not_used()
#line 7715 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[MREGL]+2 * MEMORY_REF_COST;
        DFA_PRODUCTION(UNIVERSE, get_and_addL_no_res_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[MREGL]+2 * MEMORY_REF_COST + 1;
        DFA_PRODUCTION(MREGL, get_and_addL_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, get_and_addL_rule, c)
        DFA_PRODUCTION(V1REGL, get_and_addL_rule, c)
        DFA_PRODUCTION(A0REGL, get_and_addL_rule, c)
        DFA_PRODUCTION(A1REGL, get_and_addL_rule, c)
        DFA_PRODUCTION(A2REGL, get_and_addL_rule, c)
        DFA_PRODUCTION(A3REGL, get_and_addL_rule, c)
        DFA_PRODUCTION(T0REGL, get_and_addL_rule, c)
        DFA_PRODUCTION(T1REGL, get_and_addL_rule, c)
        DFA_PRODUCTION(T3REGL, get_and_addL_rule, c)
        DFA_PRODUCTION(T8REGL, get_and_addL_rule, c)
        DFA_PRODUCTION(A4REGL, get_and_addL_rule, c)
        DFA_PRODUCTION(A5REGL, get_and_addL_rule, c)
        DFA_PRODUCTION(A6REGL, get_and_addL_rule, c)
        DFA_PRODUCTION(A7REGL, get_and_addL_rule, c)
        DFA_PRODUCTION(S0REGL, get_and_addL_rule, c)
        DFA_PRODUCTION(S1REGL, get_and_addL_rule, c)
        DFA_PRODUCTION(S3REGL, get_and_addL_rule, c)
        DFA_PRODUCTION(S4REGL, get_and_addL_rule, c)
        DFA_PRODUCTION(S7REGL, get_and_addL_rule, c)
    }
}
void  State::_sub_Op_GetAndSetI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[MREGI]+2 * MEMORY_REF_COST;
        DFA_PRODUCTION(MREGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MS0REGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MS1REGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MS3REGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MS4REGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MS5REGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MS6REGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MS7REGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MT0REGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MT1REGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MT2REGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MT3REGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MT8REGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MT4REGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MA0REGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MA1REGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MA2REGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MA3REGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MA4REGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MA5REGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MA6REGI, get_and_setI_rule, c)
        DFA_PRODUCTION(MA7REGI, get_and_setI_rule, c)
    }
}
void  State::_sub_Op_GetAndSetL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[MREGL]+2 * MEMORY_REF_COST;
        DFA_PRODUCTION(MREGL, get_and_setL_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, get_and_setL_rule, c)
        DFA_PRODUCTION(V1REGL, get_and_setL_rule, c)
        DFA_PRODUCTION(A0REGL, get_and_setL_rule, c)
        DFA_PRODUCTION(A1REGL, get_and_setL_rule, c)
        DFA_PRODUCTION(A2REGL, get_and_setL_rule, c)
        DFA_PRODUCTION(A3REGL, get_and_setL_rule, c)
        DFA_PRODUCTION(T0REGL, get_and_setL_rule, c)
        DFA_PRODUCTION(T1REGL, get_and_setL_rule, c)
        DFA_PRODUCTION(T3REGL, get_and_setL_rule, c)
        DFA_PRODUCTION(T8REGL, get_and_setL_rule, c)
        DFA_PRODUCTION(A4REGL, get_and_setL_rule, c)
        DFA_PRODUCTION(A5REGL, get_and_setL_rule, c)
        DFA_PRODUCTION(A6REGL, get_and_setL_rule, c)
        DFA_PRODUCTION(A7REGL, get_and_setL_rule, c)
        DFA_PRODUCTION(S0REGL, get_and_setL_rule, c)
        DFA_PRODUCTION(S1REGL, get_and_setL_rule, c)
        DFA_PRODUCTION(S3REGL, get_and_setL_rule, c)
        DFA_PRODUCTION(S4REGL, get_and_setL_rule, c)
        DFA_PRODUCTION(S7REGL, get_and_setL_rule, c)
    }
}
void  State::_sub_Op_GetAndSetP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], MREGP) &&
        (
#line 255 "src/hotspot/cpu/loongarch/gc/z/z_loongarch_64.ad"
UseZGC && n->as_LoadStore()->barrier_data() != 0
#line 7808 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[MREGP]+100;
        DFA_PRODUCTION(MREGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION(NO_T8_MREGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(S1_REGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(S3_REGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(S4_REGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(S5_REGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(S6_REGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(S7_REGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(T0_REGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(T1_REGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(T2_REGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(T3_REGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(A0_REGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(A1_REGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(A2_REGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(A3_REGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(A4_REGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(A5_REGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(A6_REGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(A7_REGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(V0_REGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(V1_REGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(NO_AX_MREGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(T8_REGP, zGetAndSetP_rule, c)
        DFA_PRODUCTION(INDIRECT, zGetAndSetP_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], MREGP) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[MREGP]+2 * MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION(MREGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION(NO_T8_MREGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION(S1_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION(S3_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION(S4_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION(S5_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION(S6_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION(S7_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION(T0_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION(T1_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION(T2_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION(T3_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION(A0_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION(A1_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION(A2_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION(A3_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION(A4_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION(A5_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION(A6_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION(A7_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION(V0_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION(V1_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION(NO_AX_MREGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION(T8_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
      }
    }
}
void  State::_sub_Op_GetAndSetN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], MREGN) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[MREGN]+2 * MEMORY_REF_COST;
        DFA_PRODUCTION(MREGN, get_and_setN_rule, c)
        DFA_PRODUCTION(T0_REGN, get_and_setN_rule, c)
        DFA_PRODUCTION(T1_REGN, get_and_setN_rule, c)
        DFA_PRODUCTION(T3_REGN, get_and_setN_rule, c)
        DFA_PRODUCTION(T8_REGN, get_and_setN_rule, c)
        DFA_PRODUCTION(A0_REGN, get_and_setN_rule, c)
        DFA_PRODUCTION(A1_REGN, get_and_setN_rule, c)
        DFA_PRODUCTION(A2_REGN, get_and_setN_rule, c)
        DFA_PRODUCTION(A3_REGN, get_and_setN_rule, c)
        DFA_PRODUCTION(A4_REGN, get_and_setN_rule, c)
        DFA_PRODUCTION(A5_REGN, get_and_setN_rule, c)
        DFA_PRODUCTION(A6_REGN, get_and_setN_rule, c)
        DFA_PRODUCTION(A7_REGN, get_and_setN_rule, c)
        DFA_PRODUCTION(S0_REGN, get_and_setN_rule, c)
        DFA_PRODUCTION(S1_REGN, get_and_setN_rule, c)
        DFA_PRODUCTION(S2_REGN, get_and_setN_rule, c)
        DFA_PRODUCTION(S3_REGN, get_and_setN_rule, c)
        DFA_PRODUCTION(S4_REGN, get_and_setN_rule, c)
        DFA_PRODUCTION(S5_REGN, get_and_setN_rule, c)
        DFA_PRODUCTION(S6_REGN, get_and_setN_rule, c)
        DFA_PRODUCTION(S7_REGN, get_and_setN_rule, c)
    }
}
void  State::_sub_Op_ConN(const Node *n){
    if(         
#line 3060 "src/hotspot/cpu/loongarch/loongarch_64.ad"
n->get_narrowcon() == 0
#line 7958 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION(IMMN_0, immN_0_rule, c)
        DFA_PRODUCTION(MREGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION(T0_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION(T1_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION(T3_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION(T8_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION(A0_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION(A1_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION(A2_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION(A3_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION(A4_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION(A5_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION(A6_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION(A7_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION(S0_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION(S1_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION(S2_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION(S3_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION(S4_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION(S5_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION(S6_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION(S7_REGN, loadConN_immN_0_rule, c+100)
    }
    {
      unsigned int c = 10;
        DFA_PRODUCTION(IMMN, immN_rule, c)
      if (STATE__NOT_YET_VALID(MREGN) || _cost[MREGN] > c+125) {
        DFA_PRODUCTION(MREGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(T0_REGN) || _cost[T0_REGN] > c+125) {
        DFA_PRODUCTION(T0_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(T1_REGN) || _cost[T1_REGN] > c+125) {
        DFA_PRODUCTION(T1_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(T3_REGN) || _cost[T3_REGN] > c+125) {
        DFA_PRODUCTION(T3_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(T8_REGN) || _cost[T8_REGN] > c+125) {
        DFA_PRODUCTION(T8_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(A0_REGN) || _cost[A0_REGN] > c+125) {
        DFA_PRODUCTION(A0_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(A1_REGN) || _cost[A1_REGN] > c+125) {
        DFA_PRODUCTION(A1_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(A2_REGN) || _cost[A2_REGN] > c+125) {
        DFA_PRODUCTION(A2_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(A3_REGN) || _cost[A3_REGN] > c+125) {
        DFA_PRODUCTION(A3_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(A4_REGN) || _cost[A4_REGN] > c+125) {
        DFA_PRODUCTION(A4_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(A5_REGN) || _cost[A5_REGN] > c+125) {
        DFA_PRODUCTION(A5_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(A6_REGN) || _cost[A6_REGN] > c+125) {
        DFA_PRODUCTION(A6_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(A7_REGN) || _cost[A7_REGN] > c+125) {
        DFA_PRODUCTION(A7_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(S0_REGN) || _cost[S0_REGN] > c+125) {
        DFA_PRODUCTION(S0_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(S1_REGN) || _cost[S1_REGN] > c+125) {
        DFA_PRODUCTION(S1_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(S2_REGN) || _cost[S2_REGN] > c+125) {
        DFA_PRODUCTION(S2_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(S3_REGN) || _cost[S3_REGN] > c+125) {
        DFA_PRODUCTION(S3_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(S4_REGN) || _cost[S4_REGN] > c+125) {
        DFA_PRODUCTION(S4_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(S5_REGN) || _cost[S5_REGN] > c+125) {
        DFA_PRODUCTION(S5_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(S6_REGN) || _cost[S6_REGN] > c+125) {
        DFA_PRODUCTION(S6_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(S7_REGN) || _cost[S7_REGN] > c+125) {
        DFA_PRODUCTION(S7_REGN, loadConN_rule, c+125)
      }
    }
   if ( /* MREGN KNOWN_VALID || */ _cost[MREGN] > 125) {
     DFA_PRODUCTION(MREGN, loadConN_rule, 125)
   }
   if ( /* T0_REGN KNOWN_VALID || */ _cost[T0_REGN] > 125) {
     DFA_PRODUCTION(T0_REGN, loadConN_rule, 125)
   }
   if ( /* T1_REGN KNOWN_VALID || */ _cost[T1_REGN] > 125) {
     DFA_PRODUCTION(T1_REGN, loadConN_rule, 125)
   }
   if ( /* T3_REGN KNOWN_VALID || */ _cost[T3_REGN] > 125) {
     DFA_PRODUCTION(T3_REGN, loadConN_rule, 125)
   }
   if ( /* T8_REGN KNOWN_VALID || */ _cost[T8_REGN] > 125) {
     DFA_PRODUCTION(T8_REGN, loadConN_rule, 125)
   }
   if ( /* A0_REGN KNOWN_VALID || */ _cost[A0_REGN] > 125) {
     DFA_PRODUCTION(A0_REGN, loadConN_rule, 125)
   }
   if ( /* A1_REGN KNOWN_VALID || */ _cost[A1_REGN] > 125) {
     DFA_PRODUCTION(A1_REGN, loadConN_rule, 125)
   }
   if ( /* A2_REGN KNOWN_VALID || */ _cost[A2_REGN] > 125) {
     DFA_PRODUCTION(A2_REGN, loadConN_rule, 125)
   }
   if ( /* A3_REGN KNOWN_VALID || */ _cost[A3_REGN] > 125) {
     DFA_PRODUCTION(A3_REGN, loadConN_rule, 125)
   }
   if ( /* A4_REGN KNOWN_VALID || */ _cost[A4_REGN] > 125) {
     DFA_PRODUCTION(A4_REGN, loadConN_rule, 125)
   }
   if ( /* A5_REGN KNOWN_VALID || */ _cost[A5_REGN] > 125) {
     DFA_PRODUCTION(A5_REGN, loadConN_rule, 125)
   }
   if ( /* A6_REGN KNOWN_VALID || */ _cost[A6_REGN] > 125) {
     DFA_PRODUCTION(A6_REGN, loadConN_rule, 125)
   }
   if ( /* A7_REGN KNOWN_VALID || */ _cost[A7_REGN] > 125) {
     DFA_PRODUCTION(A7_REGN, loadConN_rule, 125)
   }
   if ( /* S0_REGN KNOWN_VALID || */ _cost[S0_REGN] > 125) {
     DFA_PRODUCTION(S0_REGN, loadConN_rule, 125)
   }
   if ( /* S1_REGN KNOWN_VALID || */ _cost[S1_REGN] > 125) {
     DFA_PRODUCTION(S1_REGN, loadConN_rule, 125)
   }
   if ( /* S2_REGN KNOWN_VALID || */ _cost[S2_REGN] > 125) {
     DFA_PRODUCTION(S2_REGN, loadConN_rule, 125)
   }
   if ( /* S3_REGN KNOWN_VALID || */ _cost[S3_REGN] > 125) {
     DFA_PRODUCTION(S3_REGN, loadConN_rule, 125)
   }
   if ( /* S4_REGN KNOWN_VALID || */ _cost[S4_REGN] > 125) {
     DFA_PRODUCTION(S4_REGN, loadConN_rule, 125)
   }
   if ( /* S5_REGN KNOWN_VALID || */ _cost[S5_REGN] > 125) {
     DFA_PRODUCTION(S5_REGN, loadConN_rule, 125)
   }
   if ( /* S6_REGN KNOWN_VALID || */ _cost[S6_REGN] > 125) {
     DFA_PRODUCTION(S6_REGN, loadConN_rule, 125)
   }
   if ( /* S7_REGN KNOWN_VALID || */ _cost[S7_REGN] > 125) {
     DFA_PRODUCTION(S7_REGN, loadConN_rule, 125)
   }
}
void  State::_sub_Op_ConNKlass(const Node *n){
    {
      unsigned int c = 10;
        DFA_PRODUCTION(IMMNKLASS, immNKlass_rule, c)
        DFA_PRODUCTION(MREGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION(T0_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION(T1_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION(T3_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION(T8_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION(A0_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION(A1_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION(A2_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION(A3_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION(A4_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION(A5_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION(A6_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION(A7_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION(S0_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION(S1_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION(S2_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION(S3_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION(S4_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION(S5_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION(S6_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION(S7_REGN, loadConNKlass_rule, c+125)
    }
     DFA_PRODUCTION(MREGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(T0_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(T1_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(T3_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(T8_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(A0_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(A1_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(A2_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(A3_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(A4_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(A5_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(A6_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(A7_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(S0_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(S1_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(S2_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(S3_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(S4_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(S5_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(S6_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(S7_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
}
void  State::_sub_Op_ConD(const Node *n){
    if(         
#line 3106 "src/hotspot/cpu/loongarch/loongarch_64.ad"
jlong_cast(n->getd()) == 0
#line 8167 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION(IMMD_0, immD_0_rule, c)
        DFA_PRODUCTION(REGD, loadConD_immD_0_rule, c+100)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100+100)
    }
    {
      unsigned int c = 20;
        DFA_PRODUCTION(IMMD, immD_rule, c)
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c+125) {
        DFA_PRODUCTION(REGD, loadConD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+125+100) {
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+125+100)
      }
    }
   if ( /* REGD KNOWN_VALID || */ _cost[REGD] > 125) {
     DFA_PRODUCTION(REGD, loadConD_rule, 125)
   }
   if ( /* STACKSLOTD KNOWN_VALID || */ _cost[STACKSLOTD] > 125+100) {
     DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, 125+100)
   }
}
void  State::_sub_Op_ConF(const Node *n){
    if(         
#line 3087 "src/hotspot/cpu/loongarch/loongarch_64.ad"
jint_cast(n->getf()) == 0
#line 8195 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION(IMMF_0, immF_0_rule, c)
        DFA_PRODUCTION(REGF, loadConF_immF_0_rule, c+100)
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100+100)
    }
    {
      unsigned int c = 20;
        DFA_PRODUCTION(IMMF, immF_rule, c)
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c+125) {
        DFA_PRODUCTION(REGF, loadConF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+125+100) {
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+125+100)
      }
    }
   if ( /* REGF KNOWN_VALID || */ _cost[REGF] > 125) {
     DFA_PRODUCTION(REGF, loadConF_rule, 125)
   }
   if ( /* STACKSLOTF KNOWN_VALID || */ _cost[STACKSLOTF] > 125+100) {
     DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, 125+100)
   }
}
void  State::_sub_Op_ConI(const Node *n){
    int _n_get_int__ = n->get_int();
    if(         
#line 2858 "src/hotspot/cpu/loongarch/loongarch_64.ad"
(_n_get_int__ >= 0) && (Assembler::is_int_mask(_n_get_int__) != -1)
#line 8224 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_NONNEG_MASK, immI_nonneg_mask_rule, c)
    }
    if(         
#line 2848 "src/hotspot/cpu/loongarch/loongarch_64.ad"
(-128 <= _n_get_int__) && (_n_get_int__ <= 255)
#line 8232 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION(IMMI_M128_255, immI_M128_255_rule, c)
    }
    if(         
#line 2839 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_int__ >= 32 && _n_get_int__ <= 63
#line 8240 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_32_63, immI_32_63_rule, c)
    }
    if(         
#line 2831 "src/hotspot/cpu/loongarch/loongarch_64.ad"
1 <= _n_get_int__ && (_n_get_int__ <= 4)
#line 8248 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_1_4, immI_1_4_rule, c)
    }
    if(         
#line 2822 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_int__ >= 0 && _n_get_int__ <= 4095
#line 8256 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_0_4095, immI_0_4095_rule, c)
    }
    if(         
#line 2813 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_int__ >= 0 && _n_get_int__ <= 31
#line 8264 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_0_31, immI_0_31_rule, c)
    }
    if(         
#line 2805 "src/hotspot/cpu/loongarch/loongarch_64.ad"
0 <= _n_get_int__ && (_n_get_int__ <= 3)
#line 8272 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_0_3, immI_0_3_rule, c)
    }
    if(         
#line 2795 "src/hotspot/cpu/loongarch/loongarch_64.ad"
(-2047 <= _n_get_int__) && (_n_get_int__ <= 2048)
#line 8280 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 10;
        DFA_PRODUCTION(IMMI_M2047_2048, immI_M2047_2048_rule, c)
    }
    if(         
#line 2786 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_int__ == 2147483647
#line 8288 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_MAXI, immI_MaxI_rule, c)
    }
    if(         
#line 2777 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_int__ == 65535
#line 8296 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION(IMMI_65535, immI_65535_rule, c)
    }
    if(         
#line 2768 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_int__ == 255
#line 8304 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_255, immI_255_rule, c)
    }
    if(         
#line 2758 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_int__ == 32
#line 8312 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_32, immI_32_rule, c)
    }
    if(         
#line 2749 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_int__ == 24
#line 8320 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_24, immI_24_rule, c)
    }
    if(         
#line 2741 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_int__ == 16
#line 8328 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_16, immI_16_rule, c)
    }
    if(         
#line 2732 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_int__ == 2
#line 8336 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_2, immI_2_rule, c)
    }
    if(         
#line 2723 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_int__ == 1
#line 8344 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_1, immI_1_rule, c)
    }
    if(         
#line 2714 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_int__ == 0
#line 8352 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_0, immI_0_rule, c)
    }
    if(         
#line 2704 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_int__ == -1
#line 8360 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_M1, immI_M1_rule, c)
    }
    if(         
#line 2694 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_int__ == -65536
#line 8368 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION(IMMI_M65536, immI_M65536_rule, c)
    }
    if(         
#line 2685 "src/hotspot/cpu/loongarch/loongarch_64.ad"
(-2048 <= _n_get_int__) && (_n_get_int__ <= 2047)
#line 8376 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION(IMMI12, immI12_rule, c)
    }
    if(         
#line 2676 "src/hotspot/cpu/loongarch/loongarch_64.ad"
(-512 <= _n_get_int__) && (_n_get_int__ <= 511)
#line 8384 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION(IMMI10, immI10_rule, c)
    }
    if(         
#line 2667 "src/hotspot/cpu/loongarch/loongarch_64.ad"
(0 <= _n_get_int__) && (_n_get_int__ <= 255)
#line 8392 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION(IMMIU8, immIU8_rule, c)
    }
    if(         
#line 2658 "src/hotspot/cpu/loongarch/loongarch_64.ad"
(0 <= _n_get_int__) && (_n_get_int__ <= 63)
#line 8400 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION(IMMIU6, immIU6_rule, c)
    }
    if(         
#line 2649 "src/hotspot/cpu/loongarch/loongarch_64.ad"
(0 <= _n_get_int__) && (_n_get_int__ <= 31)
#line 8408 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION(IMMIU5, immIU5_rule, c)
    }
    if(         
#line 2640 "src/hotspot/cpu/loongarch/loongarch_64.ad"
(0 <= _n_get_int__) && (_n_get_int__ <= 15)
#line 8416 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION(IMMIU4, immIU4_rule, c)
    }
    if(         
#line 2631 "src/hotspot/cpu/loongarch/loongarch_64.ad"
(0 <= _n_get_int__) && (_n_get_int__ <= 7)
#line 8424 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION(IMMIU3, immIU3_rule, c)
    }
    if(         
#line 2622 "src/hotspot/cpu/loongarch/loongarch_64.ad"
(0 <= _n_get_int__) && (_n_get_int__ <= 3)
#line 8432 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION(IMMIU2, immIU2_rule, c)
    }
    if(         
#line 2613 "src/hotspot/cpu/loongarch/loongarch_64.ad"
(0 <= _n_get_int__) && (_n_get_int__ <= 1)
#line 8440 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION(IMMIU1, immIU1_rule, c)
    }
    {
      unsigned int c = 20;
        DFA_PRODUCTION(IMMI, immI_rule, c)
        DFA_PRODUCTION(MREGI, loadConI_rule, c+120)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+120+100)
        DFA_PRODUCTION(NO_AX_MREGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MS0REGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MS1REGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MS3REGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MS4REGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MS5REGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MS6REGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MS7REGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MT0REGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MT1REGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MT2REGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MT3REGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MT8REGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MT4REGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MA0REGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MA1REGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MA2REGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MA3REGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MA4REGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MA5REGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MA6REGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MA7REGI, loadConI_rule, c+120)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c+120)
    }
     DFA_PRODUCTION(MREGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, 120+100)	  // overwrites higher cost rule
     DFA_PRODUCTION(NO_AX_MREGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MS0REGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MS1REGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MS3REGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MS4REGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MS5REGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MS6REGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MS7REGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MT0REGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MT1REGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MT2REGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MT3REGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MT8REGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MT4REGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MA0REGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MA1REGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MA2REGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MA3REGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MA4REGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MA5REGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MA6REGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MA7REGI, loadConI_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MREGIORL2I, mRegI_rule, 120)	  // overwrites higher cost rule
}
void  State::_sub_Op_ConL(const Node *n){
    jlong _n_get_long__ = n->get_long();
    if(         
#line 3011 "src/hotspot/cpu/loongarch/loongarch_64.ad"
(_n_get_long__ >= 0) && (Assembler::is_jlong_mask(_n_get_long__) != -1)
#line 8505 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMML_NONNEG_MASK, immL_nonneg_mask_rule, c)
    }
    if(         
#line 3001 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_long__ >= 0 && _n_get_long__ <= 4095
#line 8513 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMML_0_4095, immL_0_4095_rule, c)
    }
    if(         
#line 2992 "src/hotspot/cpu/loongarch/loongarch_64.ad"
(-2047 <= _n_get_long__) && (_n_get_long__ <= 2048)
#line 8521 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 10;
        DFA_PRODUCTION(IMML_M2047_2048, immL_M2047_2048_rule, c)
    }
    if(         
#line 2983 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_long__ == 0xFFFFFFFFL
#line 8529 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 20;
        DFA_PRODUCTION(IMML_MAXUI, immL_MaxUI_rule, c)
    }
    if(         
#line 2974 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_long__ == 7L
#line 8537 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMML_7, immL_7_rule, c)
    }
    if(         
#line 2965 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_long__ == 0L
#line 8545 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMML_0, immL_0_rule, c)
    }
    if(         
#line 2955 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_long__ == -4L
#line 8553 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMML_M4, immL_M4_rule, c)
    }
    if(         
#line 2945 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_long__ == -5L
#line 8561 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMML_M5, immL_M5_rule, c)
    }
    if(         
#line 2935 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_long__ == -7L
#line 8569 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMML_M7, immL_M7_rule, c)
    }
    if(         
#line 2925 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_long__ == -8L
#line 8577 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMML_M8, immL_M8_rule, c)
    }
    if(         
#line 2915 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_long__ == -121L
#line 8585 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMML_M121, immL_M121_rule, c)
    }
    if(         
#line 2905 "src/hotspot/cpu/loongarch/loongarch_64.ad"
_n_get_long__ == (int)n->get_long()
#line 8593 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 15;
        DFA_PRODUCTION(IMML32, immL32_rule, c)
    }
    if(         
#line 2894 "src/hotspot/cpu/loongarch/loongarch_64.ad"
(-2048 <= _n_get_long__) && (_n_get_long__ <= 2047)
#line 8601 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 10;
        DFA_PRODUCTION(IMML12, immL12_rule, c)
    }
    if(         
#line 2885 "src/hotspot/cpu/loongarch/loongarch_64.ad"
(-512 <= _n_get_long__) && (_n_get_long__ <= 511)
#line 8609 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION(IMML10, immL10_rule, c)
    }
    if(         
#line 2876 "src/hotspot/cpu/loongarch/loongarch_64.ad"
(0 <= _n_get_long__) && (_n_get_long__ <= 31)
#line 8617 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION(IMMLU5, immLU5_rule, c)
    }
    {
      unsigned int c = 20;
        DFA_PRODUCTION(IMML, immL_rule, c)
        DFA_PRODUCTION(MREGL, loadConL_rule, c+120)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+120+100)
        DFA_PRODUCTION(V0REGL, loadConL_rule, c+120)
        DFA_PRODUCTION(V1REGL, loadConL_rule, c+120)
        DFA_PRODUCTION(A0REGL, loadConL_rule, c+120)
        DFA_PRODUCTION(A1REGL, loadConL_rule, c+120)
        DFA_PRODUCTION(A2REGL, loadConL_rule, c+120)
        DFA_PRODUCTION(A3REGL, loadConL_rule, c+120)
        DFA_PRODUCTION(T0REGL, loadConL_rule, c+120)
        DFA_PRODUCTION(T1REGL, loadConL_rule, c+120)
        DFA_PRODUCTION(T3REGL, loadConL_rule, c+120)
        DFA_PRODUCTION(T8REGL, loadConL_rule, c+120)
        DFA_PRODUCTION(A4REGL, loadConL_rule, c+120)
        DFA_PRODUCTION(A5REGL, loadConL_rule, c+120)
        DFA_PRODUCTION(A6REGL, loadConL_rule, c+120)
        DFA_PRODUCTION(A7REGL, loadConL_rule, c+120)
        DFA_PRODUCTION(S0REGL, loadConL_rule, c+120)
        DFA_PRODUCTION(S1REGL, loadConL_rule, c+120)
        DFA_PRODUCTION(S3REGL, loadConL_rule, c+120)
        DFA_PRODUCTION(S4REGL, loadConL_rule, c+120)
        DFA_PRODUCTION(S7REGL, loadConL_rule, c+120)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c+120)
    }
     DFA_PRODUCTION(MREGL, loadConL_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, 120+100)	  // overwrites higher cost rule
     DFA_PRODUCTION(V0REGL, loadConL_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(V1REGL, loadConL_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(A0REGL, loadConL_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(A1REGL, loadConL_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(A2REGL, loadConL_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(A3REGL, loadConL_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(T0REGL, loadConL_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(T1REGL, loadConL_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(T3REGL, loadConL_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(T8REGL, loadConL_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(A4REGL, loadConL_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(A5REGL, loadConL_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(A6REGL, loadConL_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(A7REGL, loadConL_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(S0REGL, loadConL_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(S1REGL, loadConL_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(S3REGL, loadConL_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(S4REGL, loadConL_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(S7REGL, loadConL_rule, 120)	  // overwrites higher cost rule
     DFA_PRODUCTION(MREGLORI2L, mRegL_rule, 120)	  // overwrites higher cost rule
}
void  State::_sub_Op_ConP(const Node *n){
    if(         
#line 3040 "src/hotspot/cpu/loongarch/loongarch_64.ad"
!n->bottom_type()->isa_oop_ptr()
#line 8675 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION(IMMP_NO_OOP_CHEAP, immP_no_oop_cheap_rule, c)
        DFA_PRODUCTION(MREGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+80+100)
        DFA_PRODUCTION(NO_T8_MREGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(S1_REGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(S3_REGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(S4_REGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(S5_REGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(S6_REGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(S7_REGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(T0_REGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(T1_REGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(T2_REGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(T3_REGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(A0_REGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(A1_REGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(A2_REGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(A3_REGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(A4_REGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(A5_REGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(A6_REGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(A7_REGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(V0_REGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(V1_REGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(NO_AX_MREGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(T8_REGP, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(INDIRECT, loadConP_no_oop_cheap_rule, c+80)
        DFA_PRODUCTION(MEMORY, indirect_rule, c+80)
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c+80)
    }
    if(         
#line 3030 "src/hotspot/cpu/loongarch/loongarch_64.ad"
n->get_ptr() == 0
#line 8711 "dfa_loongarch.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMP_0, immP_0_rule, c)
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c+50) {
        DFA_PRODUCTION(MREGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+50+100) {
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+50+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c+50) {
        DFA_PRODUCTION(NO_T8_MREGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c+50) {
        DFA_PRODUCTION(S1_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c+50) {
        DFA_PRODUCTION(S3_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c+50) {
        DFA_PRODUCTION(S4_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c+50) {
        DFA_PRODUCTION(S5_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c+50) {
        DFA_PRODUCTION(S6_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c+50) {
        DFA_PRODUCTION(S7_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c+50) {
        DFA_PRODUCTION(T0_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c+50) {
        DFA_PRODUCTION(T1_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c+50) {
        DFA_PRODUCTION(T2_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c+50) {
        DFA_PRODUCTION(T3_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c+50) {
        DFA_PRODUCTION(A0_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c+50) {
        DFA_PRODUCTION(A1_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c+50) {
        DFA_PRODUCTION(A2_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c+50) {
        DFA_PRODUCTION(A3_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c+50) {
        DFA_PRODUCTION(A4_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c+50) {
        DFA_PRODUCTION(A5_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c+50) {
        DFA_PRODUCTION(A6_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c+50) {
        DFA_PRODUCTION(A7_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c+50) {
        DFA_PRODUCTION(V0_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c+50) {
        DFA_PRODUCTION(V1_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c+50) {
        DFA_PRODUCTION(NO_AX_MREGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c+50) {
        DFA_PRODUCTION(T8_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+50) {
        DFA_PRODUCTION(INDIRECT, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+50) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c+50) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c+50)
      }
    }
    {
      unsigned int c = 10;
        DFA_PRODUCTION(IMMP, immP_rule, c)
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c+120) {
        DFA_PRODUCTION(MREGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+120+100) {
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+120+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c+120) {
        DFA_PRODUCTION(NO_T8_MREGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c+120) {
        DFA_PRODUCTION(S1_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c+120) {
        DFA_PRODUCTION(S3_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c+120) {
        DFA_PRODUCTION(S4_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c+120) {
        DFA_PRODUCTION(S5_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c+120) {
        DFA_PRODUCTION(S6_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c+120) {
        DFA_PRODUCTION(S7_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c+120) {
        DFA_PRODUCTION(T0_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c+120) {
        DFA_PRODUCTION(T1_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c+120) {
        DFA_PRODUCTION(T2_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c+120) {
        DFA_PRODUCTION(T3_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c+120) {
        DFA_PRODUCTION(A0_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c+120) {
        DFA_PRODUCTION(A1_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c+120) {
        DFA_PRODUCTION(A2_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c+120) {
        DFA_PRODUCTION(A3_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c+120) {
        DFA_PRODUCTION(A4_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c+120) {
        DFA_PRODUCTION(A5_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c+120) {
        DFA_PRODUCTION(A6_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c+120) {
        DFA_PRODUCTION(A7_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c+120) {
        DFA_PRODUCTION(V0_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c+120) {
        DFA_PRODUCTION(V1_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c+120) {
        DFA_PRODUCTION(NO_AX_MREGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c+120) {
        DFA_PRODUCTION(T8_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+120) {
        DFA_PRODUCTION(INDIRECT, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+120) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c+120) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c+120)
      }
    }
   if ( /* MREGP KNOWN_VALID || */ _cost[MREGP] > 120) {
     DFA_PRODUCTION(MREGP, loadConP_general_rule, 120)
   }
   if ( /* STACKSLOTP KNOWN_VALID || */ _cost[STACKSLOTP] > 120+100) {
     DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, 120+100)
   }
   if ( /* NO_T8_MREGP KNOWN_VALID || */ _cost[NO_T8_MREGP] > 120) {
     DFA_PRODUCTION(NO_T8_MREGP, loadConP_general_rule, 120)
   }
   if ( /* S1_REGP KNOWN_VALID || */ _cost[S1_REGP] > 120) {
     DFA_PRODUCTION(S1_REGP, loadConP_general_rule, 120)
   }
   if ( /* S3_REGP KNOWN_VALID || */ _cost[S3_REGP] > 120) {
     DFA_PRODUCTION(S3_REGP, loadConP_general_rule, 120)
   }
   if ( /* S4_REGP KNOWN_VALID || */ _cost[S4_REGP] > 120) {
     DFA_PRODUCTION(S4_REGP, loadConP_general_rule, 120)
   }
   if ( /* S5_REGP KNOWN_VALID || */ _cost[S5_REGP] > 120) {
     DFA_PRODUCTION(S5_REGP, loadConP_general_rule, 120)
   }
   if ( /* S6_REGP KNOWN_VALID || */ _cost[S6_REGP] > 120) {
     DFA_PRODUCTION(S6_REGP, loadConP_general_rule, 120)
   }
   if ( /* S7_REGP KNOWN_VALID || */ _cost[S7_REGP] > 120) {
     DFA_PRODUCTION(S7_REGP, loadConP_general_rule, 120)
   }
   if ( /* T0_REGP KNOWN_VALID || */ _cost[T0_REGP] > 120) {
     DFA_PRODUCTION(T0_REGP, loadConP_general_rule, 120)
   }
   if ( /* T1_REGP KNOWN_VALID || */ _cost[T1_REGP] > 120) {
     DFA_PRODUCTION(T1_REGP, loadConP_general_rule, 120)
   }
   if ( /* T2_REGP KNOWN_VALID || */ _cost[T2_REGP] > 120) {
     DFA_PRODUCTION(T2_REGP, loadConP_general_rule, 120)
   }
   if ( /* T3_REGP KNOWN_VALID || */ _cost[T3_REGP] > 120) {
     DFA_PRODUCTION(T3_REGP, loadConP_general_rule, 120)
   }
   if ( /* A0_REGP KNOWN_VALID || */ _cost[A0_REGP] > 120) {
     DFA_PRODUCTION(A0_REGP, loadConP_general_rule, 120)
   }
   if ( /* A1_REGP KNOWN_VALID || */ _cost[A1_REGP] > 120) {
     DFA_PRODUCTION(A1_REGP, loadConP_general_rule, 120)
   }
   if ( /* A2_REGP KNOWN_VALID || */ _cost[A2_REGP] > 120) {
     DFA_PRODUCTION(A2_REGP, loadConP_general_rule, 120)
   }
   if ( /* A3_REGP KNOWN_VALID || */ _cost[A3_REGP] > 120) {
     DFA_PRODUCTION(A3_REGP, loadConP_general_rule, 120)
   }
   if ( /* A4_REGP KNOWN_VALID || */ _cost[A4_REGP] > 120) {
     DFA_PRODUCTION(A4_REGP, loadConP_general_rule, 120)
   }
   if ( /* A5_REGP KNOWN_VALID || */ _cost[A5_REGP] > 120) {
     DFA_PRODUCTION(A5_REGP, loadConP_general_rule, 120)
   }
   if ( /* A6_REGP KNOWN_VALID || */ _cost[A6_REGP] > 120) {
     DFA_PRODUCTION(A6_REGP, loadConP_general_rule, 120)
   }
   if ( /* A7_REGP KNOWN_VALID || */ _cost[A7_REGP] > 120) {
     DFA_PRODUCTION(A7_REGP, loadConP_general_rule, 120)
   }
   if ( /* V0_REGP KNOWN_VALID || */ _cost[V0_REGP] > 120) {
     DFA_PRODUCTION(V0_REGP, loadConP_general_rule, 120)
   }
   if ( /* V1_REGP KNOWN_VALID || */ _cost[V1_REGP] > 120) {
     DFA_PRODUCTION(V1_REGP, loadConP_general_rule, 120)
   }
   if ( /* NO_AX_MREGP KNOWN_VALID || */ _cost[NO_AX_MREGP] > 120) {
     DFA_PRODUCTION(NO_AX_MREGP, loadConP_general_rule, 120)
   }
   if ( /* T8_REGP KNOWN_VALID || */ _cost[T8_REGP] > 120) {
     DFA_PRODUCTION(T8_REGP, loadConP_general_rule, 120)
   }
   if ( /* INDIRECT KNOWN_VALID || */ _cost[INDIRECT] > 120) {
     DFA_PRODUCTION(INDIRECT, loadConP_general_rule, 120)
   }
   if ( /* MEMORY KNOWN_VALID || */ _cost[MEMORY] > 120) {
     DFA_PRODUCTION(MEMORY, indirect_rule, 120)
   }
   if ( /* MEMORY_LOADRANGE KNOWN_VALID || */ _cost[MEMORY_LOADRANGE] > 120) {
     DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, 120)
   }
}
void  State::_sub_Op_Conv2B(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+100;
        DFA_PRODUCTION(MREGI, convP2B_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, convP2B_rule, c)
        DFA_PRODUCTION(MS0REGI, convP2B_rule, c)
        DFA_PRODUCTION(MS1REGI, convP2B_rule, c)
        DFA_PRODUCTION(MS3REGI, convP2B_rule, c)
        DFA_PRODUCTION(MS4REGI, convP2B_rule, c)
        DFA_PRODUCTION(MS5REGI, convP2B_rule, c)
        DFA_PRODUCTION(MS6REGI, convP2B_rule, c)
        DFA_PRODUCTION(MS7REGI, convP2B_rule, c)
        DFA_PRODUCTION(MT0REGI, convP2B_rule, c)
        DFA_PRODUCTION(MT1REGI, convP2B_rule, c)
        DFA_PRODUCTION(MT2REGI, convP2B_rule, c)
        DFA_PRODUCTION(MT3REGI, convP2B_rule, c)
        DFA_PRODUCTION(MT8REGI, convP2B_rule, c)
        DFA_PRODUCTION(MT4REGI, convP2B_rule, c)
        DFA_PRODUCTION(MA0REGI, convP2B_rule, c)
        DFA_PRODUCTION(MA1REGI, convP2B_rule, c)
        DFA_PRODUCTION(MA2REGI, convP2B_rule, c)
        DFA_PRODUCTION(MA3REGI, convP2B_rule, c)
        DFA_PRODUCTION(MA4REGI, convP2B_rule, c)
        DFA_PRODUCTION(MA5REGI, convP2B_rule, c)
        DFA_PRODUCTION(MA6REGI, convP2B_rule, c)
        DFA_PRODUCTION(MA7REGI, convP2B_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, convI2B_rule, c)
      }
    }
}
void  State::_sub_Op_ConvD2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION(REGF, convD2F_reg_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _SQRTD__CONVF2D_REGF__) ) {
      unsigned int c = _kids[0]->_cost[_SQRTD__CONVF2D_REGF__]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, sqrtF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+100) {
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
      }
    }
}
void  State::_sub_Op_ConvD2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION(MREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MS0REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MS1REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MS3REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MS4REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MS5REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MS6REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MS7REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MT0REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MT1REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MT2REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MT3REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MT8REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MT4REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA0REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA1REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA2REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA3REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA4REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA5REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA6REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA7REGI, convD2I_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION(MREGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(V1REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(A0REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(A1REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(A2REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(A3REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(T0REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(T1REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(T3REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(T8REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(A4REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(A5REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(A6REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(A7REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(S0REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(S1REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(S3REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(S4REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(S7REGL, convD2L_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvF2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION(REGD, convF2D_reg_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF];
        DFA_PRODUCTION(_CONVF2D_REGF_, _ConvF2D_regF__rule, c)
    }
}
void  State::_sub_Op_ConvF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION(MREGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MS0REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MS1REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MS3REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MS4REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MS5REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MS6REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MS7REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MT0REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MT1REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MT2REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MT3REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MT8REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MT4REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA0REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA1REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA2REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA3REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA4REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA5REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA6REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA7REGI, convF2I_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvF2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION(MREGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(V1REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(A0REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(A1REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(A2REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(A3REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(T0REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(T1REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(T3REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(T8REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(A4REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(A5REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(A6REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(A7REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(S0REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(S1REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(S3REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(S4REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(S7REGL, convF2L_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvI2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
        DFA_PRODUCTION(REGD, convI2D_reg_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_ConvI2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
        DFA_PRODUCTION(REGF, convI2F_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_ConvI2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION(_CONVI2L__LOADI_MEMORY__, _ConvI2L__LoadI_memory___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVL2I_MREGL_) ) {
      unsigned int c = _kids[0]->_cost[_CONVL2I_MREGL_];
        DFA_PRODUCTION(_CONVI2L__CONVL2I_MREGL__, _ConvI2L__ConvL2I_mRegL___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+125;
        DFA_PRODUCTION(MREGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION(V1REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION(A0REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION(A1REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION(A2REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION(A3REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION(T0REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION(T1REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION(T3REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION(T8REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION(A4REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION(A5REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION(A6REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION(A7REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION(S0REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION(S1REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION(S3REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION(S4REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION(S7REGL, loadUS_convI2L_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, convI2L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, loadS_convI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUB_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, loadUB_convI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, loadB_convI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, loadI_convI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI];
        DFA_PRODUCTION(_CONVI2L_MREGI_, _ConvI2L_mRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI12) ) {
      unsigned int c = _kids[0]->_cost[IMMI12];
        DFA_PRODUCTION(_CONVI2L_IMMI12_, _ConvI2L_immI12__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI];
        DFA_PRODUCTION(MREGI2L, mRegI2L_rule, c)
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegI2L_rule, c)
      }
    }
}
void  State::_sub_Op_ConvL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+100;
        DFA_PRODUCTION(REGD, convL2D_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_ConvL2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+100;
        DFA_PRODUCTION(REGF, convL2F_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_ConvL2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+100;
        DFA_PRODUCTION(MREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MS0REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MS1REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MS3REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MS4REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MS5REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MS6REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MS7REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MT0REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MT1REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MT2REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MT3REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MT8REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MT4REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MA0REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MA1REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MA2REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MA3REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MA4REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MA5REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MA6REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION(MA7REGI, convL2I_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_MREGLORI2L_IMMI_32_63) &&
        (
#line 9104 "src/hotspot/cpu/loongarch/loongarch_64.ad"
n->in(1)->in(2)->get_int() > 32
#line 9678 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_MREGLORI2L_IMMI_32_63]+80;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, slrL_Reg_immI_convL2I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_MREGLORI2L_IMMI_0_31) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_MREGLORI2L_IMMI_0_31];
        DFA_PRODUCTION(_CONVL2I__URSHIFTL_MREGLORI2L_IMMI_0_31_, _ConvL2I__URShiftL_mRegLorI2L_immI_0_31__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL_MREGLORI2L_IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL_MREGLORI2L_IMMI_32_63]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL];
        DFA_PRODUCTION(_CONVL2I_MREGL_, _ConvL2I_mRegL__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL_MREGL_IMML_7) ) {
      unsigned int c = _kids[0]->_cost[_ANDL_MREGL_IMML_7];
        DFA_PRODUCTION(_CONVL2I__ANDL_MREGL_IMML_7_, _ConvL2I__AndL_mRegL_immL_7__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL_MREGL_IMML_0_4095) ) {
      unsigned int c = _kids[0]->_cost[_ANDL_MREGL_IMML_0_4095]+60;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL];
        DFA_PRODUCTION(MREGL2I, mRegL2I_rule, c)
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegL2I_rule, c)
      }
    }
}
void  State::_sub_Op_CountedLoopEnd(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_MREGI_IMMI) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_MREGI_IMMI]+300;
        DFA_PRODUCTION(UNIVERSE, jmpLoopEnd_reg_immI_long_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_MREGI_MREGI]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, jmpLoopEnd_long_rule, c)
      }
    }
}
void  State::_sub_Op_CountLeadingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[MREGIORL2I]+100;
        DFA_PRODUCTION(MREGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MS0REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MS1REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MS3REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MS4REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MS5REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MS6REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MS7REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MT0REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MT1REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MT2REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MT3REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MT8REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MT4REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MA0REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MA1REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MA2REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MA3REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MA4REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MA5REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MA6REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(MA7REGI, countLeadingZerosI_rule, c)
    }
}
void  State::_sub_Op_CountLeadingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+100;
        DFA_PRODUCTION(MREGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MS0REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MS1REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MS3REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MS4REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MS5REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MS6REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MS7REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MT0REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MT1REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MT2REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MT3REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MT8REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MT4REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MA0REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MA1REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MA2REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MA3REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MA4REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MA5REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MA6REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(MA7REGI, countLeadingZerosL_rule, c)
    }
}
void  State::_sub_Op_CountTrailingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[MREGIORL2I]+100;
        DFA_PRODUCTION(MREGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MS0REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MS1REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MS3REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MS4REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MS5REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MS6REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MS7REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MT0REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MT1REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MT2REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MT3REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MT8REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MT4REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MA0REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MA1REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MA2REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MA3REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MA4REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MA5REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MA6REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(MA7REGI, countTrailingZerosI_rule, c)
    }
}
void  State::_sub_Op_CountTrailingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+100;
        DFA_PRODUCTION(MREGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MS0REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MS1REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MS3REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MS4REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MS5REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MS6REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MS7REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MT0REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MT1REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MT2REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MT3REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MT8REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MT4REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MA0REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MA1REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MA2REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MA3REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MA4REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MA5REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MA6REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(MA7REGI, countTrailingZerosL_rule, c)
    }
}
void  State::_sub_Op_CreateEx(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION(A0_REGP, CreateException_rule, c)
        DFA_PRODUCTION(MREGP, CreateException_rule, c)
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION(NO_T8_MREGP, CreateException_rule, c)
        DFA_PRODUCTION(S1_REGP, CreateException_rule, c)
        DFA_PRODUCTION(S3_REGP, CreateException_rule, c)
        DFA_PRODUCTION(S4_REGP, CreateException_rule, c)
        DFA_PRODUCTION(S5_REGP, CreateException_rule, c)
        DFA_PRODUCTION(S6_REGP, CreateException_rule, c)
        DFA_PRODUCTION(S7_REGP, CreateException_rule, c)
        DFA_PRODUCTION(T0_REGP, CreateException_rule, c)
        DFA_PRODUCTION(T1_REGP, CreateException_rule, c)
        DFA_PRODUCTION(T2_REGP, CreateException_rule, c)
        DFA_PRODUCTION(T3_REGP, CreateException_rule, c)
        DFA_PRODUCTION(A1_REGP, CreateException_rule, c)
        DFA_PRODUCTION(A2_REGP, CreateException_rule, c)
        DFA_PRODUCTION(A3_REGP, CreateException_rule, c)
        DFA_PRODUCTION(A4_REGP, CreateException_rule, c)
        DFA_PRODUCTION(A5_REGP, CreateException_rule, c)
        DFA_PRODUCTION(A6_REGP, CreateException_rule, c)
        DFA_PRODUCTION(A7_REGP, CreateException_rule, c)
        DFA_PRODUCTION(V0_REGP, CreateException_rule, c)
        DFA_PRODUCTION(V1_REGP, CreateException_rule, c)
        DFA_PRODUCTION(NO_AX_MREGP, CreateException_rule, c)
        DFA_PRODUCTION(T8_REGP, CreateException_rule, c)
        DFA_PRODUCTION(INDIRECT, CreateException_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
    }
}
void  State::_sub_Op_DecodeN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGN) &&
        (
#line 9769 "src/hotspot/cpu/loongarch/loongarch_64.ad"
n->bottom_type()->is_ptr()->ptr() == TypePtr::NotNull ||
            n->bottom_type()->is_ptr()->ptr() == TypePtr::Constant
#line 10104 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGN]+100;
        DFA_PRODUCTION(MREGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION(NO_T8_MREGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(S1_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(S3_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(S4_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(S5_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(S6_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(S7_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(T0_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(T1_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(T2_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(T3_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(A0_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(A1_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(A2_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(A3_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(A4_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(A5_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(A6_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(A7_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(V0_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(V1_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(NO_AX_MREGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(T8_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(INDIRECT, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGN) &&
        (
#line 9755 "src/hotspot/cpu/loongarch/loongarch_64.ad"
n->bottom_type()->is_ptr()->ptr() != TypePtr::NotNull &&
            n->bottom_type()->is_ptr()->ptr() != TypePtr::Constant
#line 10141 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGN]+100;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION(MREGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION(NO_T8_MREGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION(S1_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION(S3_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION(S4_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION(S5_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION(S6_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION(S7_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION(T0_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION(T1_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION(T2_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION(T3_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION(A0_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION(A1_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION(A2_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION(A3_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION(A4_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION(A5_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION(A6_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION(A7_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION(V0_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION(V1_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION(NO_AX_MREGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION(T8_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADN_MEMORY_) &&
        (
#line 4699 "src/hotspot/cpu/loongarch/loongarch_64.ad"
CompressedOops::base() == NULL && CompressedOops::shift() == 0
#line 10233 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADN_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION(MREGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION(NO_T8_MREGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION(S1_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION(S3_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION(S4_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION(S5_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION(S6_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION(S7_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION(T0_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION(T1_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION(T2_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION(T3_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION(A0_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION(A1_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION(A2_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION(A3_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION(A4_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION(A5_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION(A6_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION(A7_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION(V0_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION(V1_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION(NO_AX_MREGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION(T8_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGN) ) {
      unsigned int c = _kids[0]->_cost[MREGN];
        DFA_PRODUCTION(_DECODEN_MREGN_, _DecodeN_mRegN__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGN) &&
        
#line 4058 "src/hotspot/cpu/loongarch/loongarch_64.ad"
CompressedOops::shift() == 0
#line 10329 "dfa_loongarch.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[MREGN]+10;
        DFA_PRODUCTION(INDIRECTNARROW, indirectNarrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirectNarrow_rule, c)
      }
    }
}
void  State::_sub_Op_DecodeNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGN) ) {
      unsigned int c = _kids[0]->_cost[MREGN]+100;
        DFA_PRODUCTION(MREGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION(NO_T8_MREGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(S1_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(S3_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(S4_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(S5_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(S6_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(S7_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(T0_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(T1_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(T2_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(T3_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(A0_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(A1_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(A2_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(A3_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(A4_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(A5_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(A6_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(A7_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(V0_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(V1_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(NO_AX_MREGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(T8_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(INDIRECT, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADNKLASS_MEMORY_) &&
        (
#line 4759 "src/hotspot/cpu/loongarch/loongarch_64.ad"
CompressedKlassPointers::base() == NULL && CompressedKlassPointers::shift() == 0
#line 10374 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADNKLASS_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION(MREGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION(NO_T8_MREGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION(S1_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION(S3_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION(S4_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION(S5_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION(S6_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION(S7_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION(T0_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION(T1_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION(T2_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION(T3_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION(A0_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION(A1_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION(A2_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION(A3_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION(A4_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION(A5_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION(A6_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION(A7_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION(V0_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION(V1_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION(NO_AX_MREGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION(T8_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
      }
    }
}
void  State::_sub_Op_DivD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+300;
        DFA_PRODUCTION(REGD, divD_Reg_Reg_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_DivF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+300;
        DFA_PRODUCTION(REGF, divF_Reg_Reg_rule, c)
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_DivI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+300;
        DFA_PRODUCTION(MREGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS0REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS1REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS3REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS4REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS5REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS6REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS7REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT0REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT1REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT2REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT3REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT8REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT4REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA0REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA1REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA2REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA3REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA4REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA5REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA6REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA7REGI, divI_Reg_Reg_rule, c)
    }
}
void  State::_sub_Op_DivL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGL]+100;
        DFA_PRODUCTION(MREGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION(V1REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION(A0REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION(A1REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION(A2REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION(A3REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION(T0REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION(T1REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION(T3REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION(T8REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION(A4REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION(A5REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION(A6REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION(A7REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION(S0REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION(S1REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION(S3REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION(S4REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION(S7REGL, divL_reg_reg_rule, c)
    }
}
void  State::_sub_Op_EncodeISOArray(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], A4_REGP) && STATE__VALID_CHILD(_kids[1], _BINARY_A5_REGP_MA6REGI) &&
        (
#line 7800 "src/hotspot/cpu/loongarch/loongarch_64.ad"
((EncodeISOArrayNode*)n)->is_ascii()
#line 10539 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[A4_REGP]+_kids[1]->_cost[_BINARY_A5_REGP_MA6REGI]+100;
        DFA_PRODUCTION(NO_AX_MREGI, encode_ascii_array_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], A4_REGP) && STATE__VALID_CHILD(_kids[1], _BINARY_A5_REGP_MA6REGI) &&
        (
#line 7781 "src/hotspot/cpu/loongarch/loongarch_64.ad"
!((EncodeISOArrayNode*)n)->is_ascii()
#line 10548 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[A4_REGP]+_kids[1]->_cost[_BINARY_A5_REGP_MA6REGI]+100;
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, encode_iso_array_rule, c)
      }
    }
}
void  State::_sub_Op_EncodeP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) &&
        (
#line 9745 "src/hotspot/cpu/loongarch/loongarch_64.ad"
n->bottom_type()->make_ptr()->ptr() == TypePtr::NotNull
#line 10561 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+100;
        DFA_PRODUCTION(MREGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(T0_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(T1_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(T3_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(T8_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(A0_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(A1_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(A2_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(A3_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(A4_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(A5_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(A6_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(A7_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(S0_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(S1_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(S2_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(S3_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(S4_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(S5_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(S6_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(S7_REGN, encodeHeapOop_not_null_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) &&
        (
#line 9732 "src/hotspot/cpu/loongarch/loongarch_64.ad"
n->bottom_type()->make_ptr()->ptr() != TypePtr::NotNull
#line 10590 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+100;
      if (STATE__NOT_YET_VALID(MREGN) || _cost[MREGN] > c) {
        DFA_PRODUCTION(MREGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGN) || _cost[T0_REGN] > c) {
        DFA_PRODUCTION(T0_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGN) || _cost[T1_REGN] > c) {
        DFA_PRODUCTION(T1_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGN) || _cost[T3_REGN] > c) {
        DFA_PRODUCTION(T3_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGN) || _cost[T8_REGN] > c) {
        DFA_PRODUCTION(T8_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGN) || _cost[A0_REGN] > c) {
        DFA_PRODUCTION(A0_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGN) || _cost[A1_REGN] > c) {
        DFA_PRODUCTION(A1_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGN) || _cost[A2_REGN] > c) {
        DFA_PRODUCTION(A2_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGN) || _cost[A3_REGN] > c) {
        DFA_PRODUCTION(A3_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGN) || _cost[A4_REGN] > c) {
        DFA_PRODUCTION(A4_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGN) || _cost[A5_REGN] > c) {
        DFA_PRODUCTION(A5_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGN) || _cost[A6_REGN] > c) {
        DFA_PRODUCTION(A6_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGN) || _cost[A7_REGN] > c) {
        DFA_PRODUCTION(A7_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGN) || _cost[S0_REGN] > c) {
        DFA_PRODUCTION(S0_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGN) || _cost[S1_REGN] > c) {
        DFA_PRODUCTION(S1_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGN) || _cost[S2_REGN] > c) {
        DFA_PRODUCTION(S2_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGN) || _cost[S3_REGN] > c) {
        DFA_PRODUCTION(S3_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGN) || _cost[S4_REGN] > c) {
        DFA_PRODUCTION(S4_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGN) || _cost[S5_REGN] > c) {
        DFA_PRODUCTION(S5_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGN) || _cost[S6_REGN] > c) {
        DFA_PRODUCTION(S6_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGN) || _cost[S7_REGN] > c) {
        DFA_PRODUCTION(S7_REGN, encodeHeapOop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP];
        DFA_PRODUCTION(_ENCODEP_MREGP_, _EncodeP_mRegP__rule, c)
    }
}
void  State::_sub_Op_EncodePKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+100;
        DFA_PRODUCTION(MREGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(T0_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(T1_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(T3_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(T8_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(A0_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(A1_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(A2_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(A3_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(A4_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(A5_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(A6_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(A7_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(S0_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(S1_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(S2_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(S3_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(S4_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(S5_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(S6_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(S7_REGN, encodeKlass_not_null_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP];
        DFA_PRODUCTION(_ENCODEPKLASS_MREGP_, _EncodePKlass_mRegP__rule, c)
    }
}
void  State::_sub_Op_FastLock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[MREGP]+300;
        DFA_PRODUCTION(FLAGSREG, cmpFastLock_rule, c)
    }
}
void  State::_sub_Op_FastUnlock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[MREGP]+300;
        DFA_PRODUCTION(FLAGSREG, cmpFastUnlock_rule, c)
    }
}
void  State::_sub_Op_FmaD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD__NEGD_REGD_) &&
        (
#line 8473 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA
#line 10709 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_BINARY_REGD__NEGD_REGD_]+100;
        DFA_PRODUCTION(REGD, mnsubD_reg_reg_0_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGD_REGD__REGD) &&
        (
#line 8473 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA
#line 10719 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_BINARY__NEGD_REGD__REGD]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, mnsubD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+100) {
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGD_REGD_) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD__NEGD_REGD_) &&
        (
#line 8441 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA
#line 10733 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGD_REGD_]+_kids[1]->_cost[_BINARY_REGD__NEGD_REGD_]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, mnaddD_reg_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+100) {
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGD_REGD_) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGD_REGD__REGD) &&
        (
#line 8441 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA
#line 10747 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGD_REGD_]+_kids[1]->_cost[_BINARY__NEGD_REGD__REGD]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, mnaddD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+100) {
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGD_REGD_) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 8410 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA
#line 10761 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGD_REGD_]+_kids[1]->_cost[_BINARY_REGD_REGD]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, msubD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+100) {
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 8380 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA
#line 10775 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_BINARY_REGD_REGD]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, maddD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+100) {
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
      }
    }
}
void  State::_sub_Op_FmaF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF__NEGF_REGF_) &&
        (
#line 8457 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA
#line 10791 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_BINARY_REGF__NEGF_REGF_]+100;
        DFA_PRODUCTION(REGF, mnsubF_reg_reg_0_rule, c)
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGF_REGF__REGF) &&
        (
#line 8457 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA
#line 10801 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_BINARY__NEGF_REGF__REGF]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, mnsubF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+100) {
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGF_REGF_) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF__NEGF_REGF_) &&
        (
#line 8425 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA
#line 10815 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGF_REGF_]+_kids[1]->_cost[_BINARY_REGF__NEGF_REGF_]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, mnaddF_reg_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+100) {
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGF_REGF_) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGF_REGF__REGF) &&
        (
#line 8425 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA
#line 10829 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGF_REGF_]+_kids[1]->_cost[_BINARY__NEGF_REGF__REGF]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, mnaddF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+100) {
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGF_REGF_) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 8395 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA
#line 10843 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGF_REGF_]+_kids[1]->_cost[_BINARY_REGF_REGF]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, msubF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+100) {
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 8365 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA
#line 10857 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_BINARY_REGF_REGF]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, maddF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+100) {
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
      }
    }
}
void  State::_sub_Op_Goto(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION(UNIVERSE, jmpDir_long_rule, c)
    }
}
void  State::_sub_Op_Halt(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION(UNIVERSE, ShouldNotReachHere_rule, c)
    }
}
void  State::_sub_Op_HasNegatives(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], A4_REGP) && STATE__VALID_CHILD(_kids[1], MA5REGI) ) {
      unsigned int c = _kids[0]->_cost[A4_REGP]+_kids[1]->_cost[MA5REGI]+100;
        DFA_PRODUCTION(NO_AX_MREGI, has_negatives_rule, c)
    }
}
void  State::_sub_Op_If(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPD_REGD_REGD) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPD_REGD_REGD]+100;
        DFA_PRODUCTION(UNIVERSE, branchConD_reg_reg_long_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPF_REGF_REGF) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPF_REGF_REGF]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, branchConF_reg_reg_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPUL_MREGL_IMML) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPUL_MREGL_IMML]+180;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, branchConUL_regL_immL_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPL_MREGL_IMML) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPL_MREGL_IMML]+180;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, branchConL_regL_immL_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPUL_MREGLORI2L_MREGLORI2L) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPUL_MREGLORI2L_MREGLORI2L]+250;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, branchConUL_regL_regL_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPL_MREGLORI2L_MREGLORI2L) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPL_MREGLORI2L_MREGLORI2L]+250;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, branchConL_regL_regL_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_MREGI_IMMI) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_MREGI_IMMI]+200;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, branchConI_reg_imm_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_MREGI_MREGI]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, branchConI_reg_reg_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPU_MREGI_IMMI) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPU_MREGI_IMMI]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, branchConIU_reg_imm_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPU_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPU_MREGI_MREGI]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, branchConIU_reg_reg_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPN_MREGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPN_MREGN_MREGN]+180;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, cmpN_reg_branch_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPEQNE) && STATE__VALID_CHILD(_kids[1], _CMPN_MREGN_IMMN_0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPEQNE]+_kids[1]->_cost[_CMPN_MREGN_IMMN_0]+180;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, cmpN_null_branch_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPP_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPP_MREGP_MREGP]+200;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, branchConP_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPEQNE) && STATE__VALID_CHILD(_kids[1], _CMPP__DECODEN_MREGN__IMMP_0) &&
        (
#line 5431 "src/hotspot/cpu/loongarch/loongarch_64.ad"
CompressedOops::base() == NULL && CompressedOops::shift() == 0
#line 10967 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPEQNE]+_kids[1]->_cost[_CMPP__DECODEN_MREGN__IMMP_0]+180;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, branchConN2P_0_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPEQNE) && STATE__VALID_CHILD(_kids[1], _CMPP_MREGP_IMMP_0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPEQNE]+_kids[1]->_cost[_CMPP_MREGP_IMMP_0]+180;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, branchConP_0_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPEQNE) && STATE__VALID_CHILD(_kids[1], FLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOPEQNE]+_kids[1]->_cost[FLAGSREG]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, jmpCon_flags_long_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_0_31) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_0_31];
        DFA_PRODUCTION(_LSHIFTI_MREGI_IMMI_0_31, _LShiftI_mRegI_immI_0_31_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI_MREGI_IMMI_1) && STATE__VALID_CHILD(_kids[1], IMMI_0_31) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_MREGI_IMMI_1]+_kids[1]->_cost[IMMI_0_31];
        DFA_PRODUCTION(_LSHIFTI__ANDI_MREGI_IMMI_1_IMMI_0_31, _LShiftI__AndI_mRegI_immI_1_immI_0_31_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGIORL2I) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGIORL2I]+_kids[1]->_cost[MREGI]+100;
        DFA_PRODUCTION(MREGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS0REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS1REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS3REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS4REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS5REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS6REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS7REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT0REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT1REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT2REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT3REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT8REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT4REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA0REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA1REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA2REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA3REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA4REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA5REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA6REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA7REGI, salI_Reg_Reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVL2I_MREGL_) && STATE__VALID_CHILD(_kids[1], IMMIU5) ) {
      unsigned int c = _kids[0]->_cost[_CONVL2I_MREGL_]+_kids[1]->_cost[IMMIU5]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, salI_RegL2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, salI_RegL2I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION(_LSHIFTI_MREGI_IMMI_24, _LShiftI_mRegI_immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVL2I__ANDL_MREGL_IMML_7_) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[_CONVL2I__ANDL_MREGL_IMML_7_]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION(_LSHIFTI__CONVL2I__ANDL_MREGL_IMML_7__IMMI_16, _LShiftI__ConvL2I__AndL_mRegL_immL_7__immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION(_LSHIFTI_MREGI_IMMI_16, _LShiftI_mRegI_immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMIU5) ) {
      unsigned int c = _kids[0]->_cost[MREGIORL2I]+_kids[1]->_cost[IMMIU5]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, salI_Reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_1_4) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_1_4];
        DFA_PRODUCTION(_LSHIFTI_MREGI_IMMI_1_4, _LShiftI_mRegI_immI_1_4_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION(_LSHIFTI__LOADS_MEMORY__IMMI_24, _LShiftI__LoadS_memory__immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION(_LSHIFTI__LOADI_MEMORY__IMMI_16, _LShiftI__LoadI_memory__immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION(_LSHIFTI__LOADI_MEMORY__IMMI_24, _LShiftI__LoadI_memory__immI_24_rule, c)
    }
}
void  State::_sub_Op_LShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_MREGI_) && STATE__VALID_CHILD(_kids[1], IMMI_32) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_MREGI_]+_kids[1]->_cost[IMMI_32];
        DFA_PRODUCTION(_LSHIFTL__CONVI2L_MREGI__IMMI_32, _LShiftL__ConvI2L_mRegI__immI_32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], IMMI_0_3) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[IMMI_0_3];
        DFA_PRODUCTION(_LSHIFTL_MREGLORI2L_IMMI_0_3, _LShiftL_mRegLorI2L_immI_0_3_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], IMMI_0_31) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[IMMI_0_31];
        DFA_PRODUCTION(_LSHIFTL_MREGLORI2L_IMMI_0_31, _LShiftL_mRegLorI2L_immI_0_31_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[IMMI_32_63];
        DFA_PRODUCTION(_LSHIFTL_MREGLORI2L_IMMI_32_63, _LShiftL_mRegLorI2L_immI_32_63_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[MREGI]+100;
        DFA_PRODUCTION(MREGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION(V1REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A0REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A1REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A2REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A3REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION(T0REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION(T1REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION(T3REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION(T8REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A4REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A5REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A6REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A7REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION(S0REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION(S1REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION(S3REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION(S4REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION(S7REGL, salL_Reg_Reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], IMMIU6) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[IMMIU6]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, salL_Reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_MREGI_) && STATE__VALID_CHILD(_kids[1], IMMI_1_4) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_MREGI_]+_kids[1]->_cost[IMMI_1_4];
        DFA_PRODUCTION(_LSHIFTL__CONVI2L_MREGI__IMMI_1_4, _LShiftL__ConvI2L_mRegI__immI_1_4_rule, c)
    }
}
void  State::_sub_Op_LoadB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADB_MEMORY_, _LoadB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION(MREGI, loadB_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, loadB_rule, c)
        DFA_PRODUCTION(MS0REGI, loadB_rule, c)
        DFA_PRODUCTION(MS1REGI, loadB_rule, c)
        DFA_PRODUCTION(MS3REGI, loadB_rule, c)
        DFA_PRODUCTION(MS4REGI, loadB_rule, c)
        DFA_PRODUCTION(MS5REGI, loadB_rule, c)
        DFA_PRODUCTION(MS6REGI, loadB_rule, c)
        DFA_PRODUCTION(MS7REGI, loadB_rule, c)
        DFA_PRODUCTION(MT0REGI, loadB_rule, c)
        DFA_PRODUCTION(MT1REGI, loadB_rule, c)
        DFA_PRODUCTION(MT2REGI, loadB_rule, c)
        DFA_PRODUCTION(MT3REGI, loadB_rule, c)
        DFA_PRODUCTION(MT8REGI, loadB_rule, c)
        DFA_PRODUCTION(MT4REGI, loadB_rule, c)
        DFA_PRODUCTION(MA0REGI, loadB_rule, c)
        DFA_PRODUCTION(MA1REGI, loadB_rule, c)
        DFA_PRODUCTION(MA2REGI, loadB_rule, c)
        DFA_PRODUCTION(MA3REGI, loadB_rule, c)
        DFA_PRODUCTION(MA4REGI, loadB_rule, c)
        DFA_PRODUCTION(MA5REGI, loadB_rule, c)
        DFA_PRODUCTION(MA6REGI, loadB_rule, c)
        DFA_PRODUCTION(MA7REGI, loadB_rule, c)
    }
}
void  State::_sub_Op_LoadUB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADUB_MEMORY_, _LoadUB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION(MREGI, loadUB_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, loadUB_rule, c)
        DFA_PRODUCTION(MS0REGI, loadUB_rule, c)
        DFA_PRODUCTION(MS1REGI, loadUB_rule, c)
        DFA_PRODUCTION(MS3REGI, loadUB_rule, c)
        DFA_PRODUCTION(MS4REGI, loadUB_rule, c)
        DFA_PRODUCTION(MS5REGI, loadUB_rule, c)
        DFA_PRODUCTION(MS6REGI, loadUB_rule, c)
        DFA_PRODUCTION(MS7REGI, loadUB_rule, c)
        DFA_PRODUCTION(MT0REGI, loadUB_rule, c)
        DFA_PRODUCTION(MT1REGI, loadUB_rule, c)
        DFA_PRODUCTION(MT2REGI, loadUB_rule, c)
        DFA_PRODUCTION(MT3REGI, loadUB_rule, c)
        DFA_PRODUCTION(MT8REGI, loadUB_rule, c)
        DFA_PRODUCTION(MT4REGI, loadUB_rule, c)
        DFA_PRODUCTION(MA0REGI, loadUB_rule, c)
        DFA_PRODUCTION(MA1REGI, loadUB_rule, c)
        DFA_PRODUCTION(MA2REGI, loadUB_rule, c)
        DFA_PRODUCTION(MA3REGI, loadUB_rule, c)
        DFA_PRODUCTION(MA4REGI, loadUB_rule, c)
        DFA_PRODUCTION(MA5REGI, loadUB_rule, c)
        DFA_PRODUCTION(MA6REGI, loadUB_rule, c)
        DFA_PRODUCTION(MA7REGI, loadUB_rule, c)
    }
}
void  State::_sub_Op_LoadUS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADUS_MEMORY_, _LoadUS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION(MREGI, loadUS_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, loadUS_rule, c)
        DFA_PRODUCTION(MS0REGI, loadUS_rule, c)
        DFA_PRODUCTION(MS1REGI, loadUS_rule, c)
        DFA_PRODUCTION(MS3REGI, loadUS_rule, c)
        DFA_PRODUCTION(MS4REGI, loadUS_rule, c)
        DFA_PRODUCTION(MS5REGI, loadUS_rule, c)
        DFA_PRODUCTION(MS6REGI, loadUS_rule, c)
        DFA_PRODUCTION(MS7REGI, loadUS_rule, c)
        DFA_PRODUCTION(MT0REGI, loadUS_rule, c)
        DFA_PRODUCTION(MT1REGI, loadUS_rule, c)
        DFA_PRODUCTION(MT2REGI, loadUS_rule, c)
        DFA_PRODUCTION(MT3REGI, loadUS_rule, c)
        DFA_PRODUCTION(MT8REGI, loadUS_rule, c)
        DFA_PRODUCTION(MT4REGI, loadUS_rule, c)
        DFA_PRODUCTION(MA0REGI, loadUS_rule, c)
        DFA_PRODUCTION(MA1REGI, loadUS_rule, c)
        DFA_PRODUCTION(MA2REGI, loadUS_rule, c)
        DFA_PRODUCTION(MA3REGI, loadUS_rule, c)
        DFA_PRODUCTION(MA4REGI, loadUS_rule, c)
        DFA_PRODUCTION(MA5REGI, loadUS_rule, c)
        DFA_PRODUCTION(MA6REGI, loadUS_rule, c)
        DFA_PRODUCTION(MA7REGI, loadUS_rule, c)
    }
}
void  State::_sub_Op_LoadD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+150;
        DFA_PRODUCTION(REGD, loadD_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_LoadD_unaligned(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+250;
        DFA_PRODUCTION(REGD, loadD_unaligned_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_LoadF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+150;
        DFA_PRODUCTION(REGF, loadF_rule, c)
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_LoadI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADI_MEMORY_, _LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION(MREGI, loadI_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, loadI_rule, c)
        DFA_PRODUCTION(MS0REGI, loadI_rule, c)
        DFA_PRODUCTION(MS1REGI, loadI_rule, c)
        DFA_PRODUCTION(MS3REGI, loadI_rule, c)
        DFA_PRODUCTION(MS4REGI, loadI_rule, c)
        DFA_PRODUCTION(MS5REGI, loadI_rule, c)
        DFA_PRODUCTION(MS6REGI, loadI_rule, c)
        DFA_PRODUCTION(MS7REGI, loadI_rule, c)
        DFA_PRODUCTION(MT0REGI, loadI_rule, c)
        DFA_PRODUCTION(MT1REGI, loadI_rule, c)
        DFA_PRODUCTION(MT2REGI, loadI_rule, c)
        DFA_PRODUCTION(MT3REGI, loadI_rule, c)
        DFA_PRODUCTION(MT8REGI, loadI_rule, c)
        DFA_PRODUCTION(MT4REGI, loadI_rule, c)
        DFA_PRODUCTION(MA0REGI, loadI_rule, c)
        DFA_PRODUCTION(MA1REGI, loadI_rule, c)
        DFA_PRODUCTION(MA2REGI, loadI_rule, c)
        DFA_PRODUCTION(MA3REGI, loadI_rule, c)
        DFA_PRODUCTION(MA4REGI, loadI_rule, c)
        DFA_PRODUCTION(MA5REGI, loadI_rule, c)
        DFA_PRODUCTION(MA6REGI, loadI_rule, c)
        DFA_PRODUCTION(MA7REGI, loadI_rule, c)
    }
}
void  State::_sub_Op_LoadKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION(MREGP, loadKlass_rule, c)
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION(NO_T8_MREGP, loadKlass_rule, c)
        DFA_PRODUCTION(S1_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(S3_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(S4_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(S5_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(S6_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(S7_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(T0_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(T1_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(T2_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(T3_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(A0_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(A1_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(A2_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(A3_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(A4_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(A5_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(A6_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(A7_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(V0_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(V1_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(NO_AX_MREGP, loadKlass_rule, c)
        DFA_PRODUCTION(T8_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(INDIRECT, loadKlass_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
    }
}
void  State::_sub_Op_LoadNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADNKLASS_MEMORY_, _LoadNKlass_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION(MREGN, loadNKlass_rule, c)
        DFA_PRODUCTION(T0_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION(T1_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION(T3_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION(T8_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION(A0_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION(A1_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION(A2_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION(A3_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION(A4_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION(A5_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION(A6_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION(A7_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION(S0_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION(S1_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION(S2_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION(S3_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION(S4_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION(S5_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION(S6_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION(S7_REGN, loadNKlass_rule, c)
    }
}
void  State::_sub_Op_LoadL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADL_MEMORY_, _LoadL_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+250;
        DFA_PRODUCTION(MREGL, loadL_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, loadL_rule, c)
        DFA_PRODUCTION(V1REGL, loadL_rule, c)
        DFA_PRODUCTION(A0REGL, loadL_rule, c)
        DFA_PRODUCTION(A1REGL, loadL_rule, c)
        DFA_PRODUCTION(A2REGL, loadL_rule, c)
        DFA_PRODUCTION(A3REGL, loadL_rule, c)
        DFA_PRODUCTION(T0REGL, loadL_rule, c)
        DFA_PRODUCTION(T1REGL, loadL_rule, c)
        DFA_PRODUCTION(T3REGL, loadL_rule, c)
        DFA_PRODUCTION(T8REGL, loadL_rule, c)
        DFA_PRODUCTION(A4REGL, loadL_rule, c)
        DFA_PRODUCTION(A5REGL, loadL_rule, c)
        DFA_PRODUCTION(A6REGL, loadL_rule, c)
        DFA_PRODUCTION(A7REGL, loadL_rule, c)
        DFA_PRODUCTION(S0REGL, loadL_rule, c)
        DFA_PRODUCTION(S1REGL, loadL_rule, c)
        DFA_PRODUCTION(S3REGL, loadL_rule, c)
        DFA_PRODUCTION(S4REGL, loadL_rule, c)
        DFA_PRODUCTION(S7REGL, loadL_rule, c)
    }
}
void  State::_sub_Op_LoadL_unaligned(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+450;
        DFA_PRODUCTION(MREGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION(V1REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION(A0REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION(A1REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION(A2REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION(A3REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION(T0REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION(T1REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION(T3REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION(T8REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION(A4REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION(A5REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION(A6REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION(A7REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION(S0REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION(S1REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION(S3REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION(S4REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION(S7REGL, loadL_unaligned_rule, c)
    }
}
void  State::_sub_Op_LoadPLocked(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + MEMORY_REF_COST;
        DFA_PRODUCTION(MREGP, loadPLocked_rule, c)
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION(NO_T8_MREGP, loadPLocked_rule, c)
        DFA_PRODUCTION(S1_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(S3_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(S4_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(S5_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(S6_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(S7_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(T0_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(T1_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(T2_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(T3_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(A0_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(A1_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(A2_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(A3_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(A4_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(A5_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(A6_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(A7_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(V0_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(V1_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(NO_AX_MREGP, loadPLocked_rule, c)
        DFA_PRODUCTION(T8_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(INDIRECT, loadPLocked_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
    }
}
void  State::_sub_Op_LoadP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 119 "src/hotspot/cpu/loongarch/gc/z/z_loongarch_64.ad"
UseZGC && n->as_Load()->barrier_data() != 0
#line 11641 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION(MREGP, zLoadP_rule, c)
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION(NO_T8_MREGP, zLoadP_rule, c)
        DFA_PRODUCTION(S1_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(S3_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(S4_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(S5_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(S6_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(S7_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(T0_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(T1_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(T2_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(T3_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(A0_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(A1_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(A2_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(A3_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(A4_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(A5_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(A6_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(A7_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(V0_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(V1_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(NO_AX_MREGP, zLoadP_rule, c)
        DFA_PRODUCTION(T8_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(INDIRECT, zLoadP_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 4714 "src/hotspot/cpu/loongarch/loongarch_64.ad"
n->as_Load()->barrier_data() == 0
#line 11677 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION(MREGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION(NO_T8_MREGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION(S1_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION(S3_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION(S4_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION(S5_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION(S6_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION(S7_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION(T0_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION(T1_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION(T2_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION(T3_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION(A0_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION(A1_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION(A2_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION(A3_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION(A4_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION(A5_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION(A6_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION(A7_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION(V0_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION(V1_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION(NO_AX_MREGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION(T8_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY_LOADRANGE) || _cost[MEMORY_LOADRANGE] > c) {
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
      }
    }
}
void  State::_sub_Op_LoadN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADN_MEMORY_, _LoadN_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION(MREGN, loadN_rule, c)
        DFA_PRODUCTION(T0_REGN, loadN_rule, c)
        DFA_PRODUCTION(T1_REGN, loadN_rule, c)
        DFA_PRODUCTION(T3_REGN, loadN_rule, c)
        DFA_PRODUCTION(T8_REGN, loadN_rule, c)
        DFA_PRODUCTION(A0_REGN, loadN_rule, c)
        DFA_PRODUCTION(A1_REGN, loadN_rule, c)
        DFA_PRODUCTION(A2_REGN, loadN_rule, c)
        DFA_PRODUCTION(A3_REGN, loadN_rule, c)
        DFA_PRODUCTION(A4_REGN, loadN_rule, c)
        DFA_PRODUCTION(A5_REGN, loadN_rule, c)
        DFA_PRODUCTION(A6_REGN, loadN_rule, c)
        DFA_PRODUCTION(A7_REGN, loadN_rule, c)
        DFA_PRODUCTION(S0_REGN, loadN_rule, c)
        DFA_PRODUCTION(S1_REGN, loadN_rule, c)
        DFA_PRODUCTION(S2_REGN, loadN_rule, c)
        DFA_PRODUCTION(S3_REGN, loadN_rule, c)
        DFA_PRODUCTION(S4_REGN, loadN_rule, c)
        DFA_PRODUCTION(S5_REGN, loadN_rule, c)
        DFA_PRODUCTION(S6_REGN, loadN_rule, c)
        DFA_PRODUCTION(S7_REGN, loadN_rule, c)
    }
}
void  State::_sub_Op_LoadRange(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY_LOADRANGE) ) {
      unsigned int c = _kids[0]->_cost[MEMORY_LOADRANGE]+125;
        DFA_PRODUCTION(MREGI, loadRange_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, loadRange_rule, c)
        DFA_PRODUCTION(MS0REGI, loadRange_rule, c)
        DFA_PRODUCTION(MS1REGI, loadRange_rule, c)
        DFA_PRODUCTION(MS3REGI, loadRange_rule, c)
        DFA_PRODUCTION(MS4REGI, loadRange_rule, c)
        DFA_PRODUCTION(MS5REGI, loadRange_rule, c)
        DFA_PRODUCTION(MS6REGI, loadRange_rule, c)
        DFA_PRODUCTION(MS7REGI, loadRange_rule, c)
        DFA_PRODUCTION(MT0REGI, loadRange_rule, c)
        DFA_PRODUCTION(MT1REGI, loadRange_rule, c)
        DFA_PRODUCTION(MT2REGI, loadRange_rule, c)
        DFA_PRODUCTION(MT3REGI, loadRange_rule, c)
        DFA_PRODUCTION(MT8REGI, loadRange_rule, c)
        DFA_PRODUCTION(MT4REGI, loadRange_rule, c)
        DFA_PRODUCTION(MA0REGI, loadRange_rule, c)
        DFA_PRODUCTION(MA1REGI, loadRange_rule, c)
        DFA_PRODUCTION(MA2REGI, loadRange_rule, c)
        DFA_PRODUCTION(MA3REGI, loadRange_rule, c)
        DFA_PRODUCTION(MA4REGI, loadRange_rule, c)
        DFA_PRODUCTION(MA5REGI, loadRange_rule, c)
        DFA_PRODUCTION(MA6REGI, loadRange_rule, c)
        DFA_PRODUCTION(MA7REGI, loadRange_rule, c)
    }
}
void  State::_sub_Op_LoadS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADS_MEMORY_, _LoadS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION(MREGI, loadS_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, loadS_rule, c)
        DFA_PRODUCTION(MS0REGI, loadS_rule, c)
        DFA_PRODUCTION(MS1REGI, loadS_rule, c)
        DFA_PRODUCTION(MS3REGI, loadS_rule, c)
        DFA_PRODUCTION(MS4REGI, loadS_rule, c)
        DFA_PRODUCTION(MS5REGI, loadS_rule, c)
        DFA_PRODUCTION(MS6REGI, loadS_rule, c)
        DFA_PRODUCTION(MS7REGI, loadS_rule, c)
        DFA_PRODUCTION(MT0REGI, loadS_rule, c)
        DFA_PRODUCTION(MT1REGI, loadS_rule, c)
        DFA_PRODUCTION(MT2REGI, loadS_rule, c)
        DFA_PRODUCTION(MT3REGI, loadS_rule, c)
        DFA_PRODUCTION(MT8REGI, loadS_rule, c)
        DFA_PRODUCTION(MT4REGI, loadS_rule, c)
        DFA_PRODUCTION(MA0REGI, loadS_rule, c)
        DFA_PRODUCTION(MA1REGI, loadS_rule, c)
        DFA_PRODUCTION(MA2REGI, loadS_rule, c)
        DFA_PRODUCTION(MA3REGI, loadS_rule, c)
        DFA_PRODUCTION(MA4REGI, loadS_rule, c)
        DFA_PRODUCTION(MA5REGI, loadS_rule, c)
        DFA_PRODUCTION(MA6REGI, loadS_rule, c)
        DFA_PRODUCTION(MA7REGI, loadS_rule, c)
    }
}
void  State::_sub_Op_MaxI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_0) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_0]+50;
        DFA_PRODUCTION(MREGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MS0REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MS1REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MS3REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MS4REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MS5REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MS6REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MS7REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MT0REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MT1REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MT2REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MT3REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MT8REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MT4REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MA0REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MA1REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MA2REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MA3REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MA4REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MA5REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MA6REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION(MA7REGI, maxI_Reg_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+80;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, maxI_Reg_Reg_rule, c)
      }
    }
}
void  State::_sub_Op_MemBarAcquire(const Node *n){
    {
      unsigned int c = 400;
        DFA_PRODUCTION(UNIVERSE, membar_acquire_rule, c)
    }
    if(         (
#line 6311 "src/hotspot/cpu/loongarch/loongarch_64.ad"
unnecessary_acquire(n)
#line 11976 "dfa_loongarch.cpp"
) ) {
      unsigned int c = 0;
        DFA_PRODUCTION(UNIVERSE, unnecessary_membar_acquire_rule, c)	  // overwrites higher cost rule
    }
}
void  State::_sub_Op_LoadFence(const Node *n){
    {
      unsigned int c = 400;
        DFA_PRODUCTION(UNIVERSE, load_fence_rule, c)
    }
}
void  State::_sub_Op_MemBarAcquireLock(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(UNIVERSE, membar_acquire_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarRelease(const Node *n){
    {
      unsigned int c = 400;
        DFA_PRODUCTION(UNIVERSE, membar_release_rule, c)
    }
    if(         (
#line 6358 "src/hotspot/cpu/loongarch/loongarch_64.ad"
unnecessary_release(n)
#line 12002 "dfa_loongarch.cpp"
) ) {
      unsigned int c = 0;
        DFA_PRODUCTION(UNIVERSE, unnecessary_membar_release_rule, c)	  // overwrites higher cost rule
    }
}
void  State::_sub_Op_StoreFence(const Node *n){
    {
      unsigned int c = 400;
        DFA_PRODUCTION(UNIVERSE, store_fence_rule, c)
    }
}
void  State::_sub_Op_MemBarReleaseLock(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(UNIVERSE, membar_release_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarVolatile(const Node *n){
    {
      unsigned int c = 400;
        DFA_PRODUCTION(UNIVERSE, membar_volatile_rule, c)
    }
    if(         (
#line 6409 "src/hotspot/cpu/loongarch/loongarch_64.ad"
unnecessary_volatile(n)
#line 12028 "dfa_loongarch.cpp"
) ) {
      unsigned int c = 0;
        DFA_PRODUCTION(UNIVERSE, unnecessary_membar_volatile_rule, c)	  // overwrites higher cost rule
    }
}
void  State::_sub_Op_MemBarStoreStore(const Node *n){
    {
      unsigned int c = 400;
        DFA_PRODUCTION(UNIVERSE, membar_storestore_rule, c)
    }
}
void  State::_sub_Op_MinI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+80;
        DFA_PRODUCTION(MREGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS0REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS1REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS3REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS4REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS5REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS6REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS7REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT0REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT1REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT2REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT3REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT8REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT4REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA0REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA1REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA2REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA3REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA4REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA5REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA6REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA7REGI, minI_Reg_Reg_rule, c)
    }
}
void  State::_sub_Op_ModI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGIORL2I) && STATE__VALID_CHILD(_kids[1], MREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[MREGIORL2I]+_kids[1]->_cost[MREGIORL2I]+300;
        DFA_PRODUCTION(MREGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS0REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS1REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS3REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS4REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS5REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS6REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS7REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT0REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT1REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT2REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT3REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT8REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT4REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA0REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA1REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA2REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA3REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA4REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA5REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA6REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA7REGI, modI_Reg_Reg_rule, c)
    }
}
void  State::_sub_Op_ModL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], MREGLORI2L) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[MREGLORI2L]+100;
        DFA_PRODUCTION(MREGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION(V1REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION(A0REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION(A1REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION(A2REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION(A3REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION(T0REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION(T1REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION(T3REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION(T8REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION(A4REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION(A5REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION(A6REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION(A7REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION(S0REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION(S1REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION(S3REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION(S4REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION(S7REGL, modL_reg_reg_rule, c)
    }
}
void  State::_sub_Op_MoveI2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+85;
        DFA_PRODUCTION(REGF, MoveI2F_reg_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_MoveF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+85;
        DFA_PRODUCTION(MREGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MS0REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MS1REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MS3REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MS4REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MS5REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MS6REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MS7REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MT0REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MT1REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MT2REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MT3REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MT8REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MT4REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA0REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA1REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA2REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA3REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA4REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA5REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA6REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(MA7REGI, MoveF2I_reg_reg_rule, c)
    }
}
void  State::_sub_Op_MoveL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+85;
        DFA_PRODUCTION(REGD, MoveL2D_reg_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_MoveD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+85;
        DFA_PRODUCTION(MREGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(V1REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(A0REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(A1REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(A2REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(A3REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(T0REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(T1REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(T3REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(T8REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(A4REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(A5REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(A6REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(A7REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(S0REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(S1REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(S3REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(S4REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(S7REGL, MoveD2L_reg_reg_rule, c)
    }
}
void  State::_sub_Op_MulD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+100;
        DFA_PRODUCTION(REGD, mulD_reg_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_MulF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+100;
        DFA_PRODUCTION(REGF, mulF_reg_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_MulHiL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGL]+100;
        DFA_PRODUCTION(MREGL, mulHiL_reg_reg_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, mulHiL_reg_reg_rule, c)
        DFA_PRODUCTION(V1REGL, mulHiL_reg_reg_rule, c)
        DFA_PRODUCTION(A0REGL, mulHiL_reg_reg_rule, c)
        DFA_PRODUCTION(A1REGL, mulHiL_reg_reg_rule, c)
        DFA_PRODUCTION(A2REGL, mulHiL_reg_reg_rule, c)
        DFA_PRODUCTION(A3REGL, mulHiL_reg_reg_rule, c)
        DFA_PRODUCTION(T0REGL, mulHiL_reg_reg_rule, c)
        DFA_PRODUCTION(T1REGL, mulHiL_reg_reg_rule, c)
        DFA_PRODUCTION(T3REGL, mulHiL_reg_reg_rule, c)
        DFA_PRODUCTION(T8REGL, mulHiL_reg_reg_rule, c)
        DFA_PRODUCTION(A4REGL, mulHiL_reg_reg_rule, c)
        DFA_PRODUCTION(A5REGL, mulHiL_reg_reg_rule, c)
        DFA_PRODUCTION(A6REGL, mulHiL_reg_reg_rule, c)
        DFA_PRODUCTION(A7REGL, mulHiL_reg_reg_rule, c)
        DFA_PRODUCTION(S0REGL, mulHiL_reg_reg_rule, c)
        DFA_PRODUCTION(S1REGL, mulHiL_reg_reg_rule, c)
        DFA_PRODUCTION(S3REGL, mulHiL_reg_reg_rule, c)
        DFA_PRODUCTION(S4REGL, mulHiL_reg_reg_rule, c)
        DFA_PRODUCTION(S7REGL, mulHiL_reg_reg_rule, c)
    }
}
void  State::_sub_Op_MulI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+300;
        DFA_PRODUCTION(MREGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS0REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS1REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS3REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS4REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS5REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS6REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS7REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT0REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT1REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT2REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT3REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT8REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT4REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA0REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA1REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA2REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA3REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA4REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA5REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA6REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA7REGI, mulI_Reg_Reg_rule, c)
    }
}
void  State::_sub_Op_MulL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], MREGLORI2L) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[MREGLORI2L]+100;
        DFA_PRODUCTION(MREGL, mulL_reg_reg_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, mulL_reg_reg_rule, c)
        DFA_PRODUCTION(V1REGL, mulL_reg_reg_rule, c)
        DFA_PRODUCTION(A0REGL, mulL_reg_reg_rule, c)
        DFA_PRODUCTION(A1REGL, mulL_reg_reg_rule, c)
        DFA_PRODUCTION(A2REGL, mulL_reg_reg_rule, c)
        DFA_PRODUCTION(A3REGL, mulL_reg_reg_rule, c)
        DFA_PRODUCTION(T0REGL, mulL_reg_reg_rule, c)
        DFA_PRODUCTION(T1REGL, mulL_reg_reg_rule, c)
        DFA_PRODUCTION(T3REGL, mulL_reg_reg_rule, c)
        DFA_PRODUCTION(T8REGL, mulL_reg_reg_rule, c)
        DFA_PRODUCTION(A4REGL, mulL_reg_reg_rule, c)
        DFA_PRODUCTION(A5REGL, mulL_reg_reg_rule, c)
        DFA_PRODUCTION(A6REGL, mulL_reg_reg_rule, c)
        DFA_PRODUCTION(A7REGL, mulL_reg_reg_rule, c)
        DFA_PRODUCTION(S0REGL, mulL_reg_reg_rule, c)
        DFA_PRODUCTION(S1REGL, mulL_reg_reg_rule, c)
        DFA_PRODUCTION(S3REGL, mulL_reg_reg_rule, c)
        DFA_PRODUCTION(S4REGL, mulL_reg_reg_rule, c)
        DFA_PRODUCTION(S7REGL, mulL_reg_reg_rule, c)
    }
}
void  State::_sub_Op_NegD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD];
        DFA_PRODUCTION(_NEGD_REGD_, _NegD_regD__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION(REGD, negD_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_NegF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF];
        DFA_PRODUCTION(_NEGF_REGF_, _NegF_regF__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION(REGF, negF_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_OrI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_MREGI_IMMI_0_31) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_MREGI_IMMI_0_31) &&
        (
#line 9242 "src/hotspot/cpu/loongarch/loongarch_64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x1f)
#line 12323 "dfa_loongarch.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_MREGI_IMMI_0_31]+_kids[1]->_cost[_LSHIFTI_MREGI_IMMI_0_31]+100;
        DFA_PRODUCTION(MREGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MS0REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MS1REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MS3REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MS4REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MS5REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MS6REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MS7REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MT0REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MT1REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MT2REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MT3REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MT8REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MT4REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MA0REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MA1REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MA2REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MA3REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MA4REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MA5REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MA6REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION(MA7REGI, rolI_Reg_immI_0_31_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_MREGI_IMMI_0_31) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_MREGI_IMMI_0_31) &&
        (
#line 9242 "src/hotspot/cpu/loongarch/loongarch_64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x1f)
#line 12356 "dfa_loongarch.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_MREGI_IMMI_0_31]+_kids[1]->_cost[_URSHIFTI_MREGI_IMMI_0_31]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, rolI_Reg_immI_0_31_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_MREGP_) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_MREGP_]+_kids[1]->_cost[MREGL]+100;
        DFA_PRODUCTION(MREGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION(V1REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION(A0REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION(A1REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION(A2REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION(A3REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION(T0REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION(T1REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION(T3REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION(T8REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION(A4REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION(A5REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION(A6REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION(A7REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION(S0REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION(S1REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION(S3REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION(S4REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION(S7REGL, orI_Reg_castP2X_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], _CASTP2X_MREGP_) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[_CASTP2X_MREGP_]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, orI_Reg_castP2X_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__ANDI_MREGI_IMMI_1_IMMI_0_31) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_MREGI_IMMI_0_31) &&
        (
#line 9177 "src/hotspot/cpu/loongarch/loongarch_64.ad"
32 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()))
#line 12533 "dfa_loongarch.cpp"
) && /*src*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__ANDI_MREGI_IMMI_1_IMMI_0_31]+_kids[1]->_cost[_URSHIFTI_MREGI_IMMI_0_31]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, rotI_shr_logical_Reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_MREGI_IMMI_0_31) && STATE__VALID_CHILD(_kids[1], _LSHIFTI__ANDI_MREGI_IMMI_1_IMMI_0_31) &&
        (
#line 9177 "src/hotspot/cpu/loongarch/loongarch_64.ad"
32 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()))
#line 12616 "dfa_loongarch.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_MREGI_IMMI_0_31]+_kids[1]->_cost[_LSHIFTI__ANDI_MREGI_IMMI_1_IMMI_0_31]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, rotI_shr_logical_Reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, orI_Reg_Reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_0_4095) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_0_4095]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, orI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, orI_Reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI_MREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[_XORI_MREGI_IMMI_M1]+_kids[1]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, ornI_Reg_nReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], _XORI_MREGI_IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[_XORI_MREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, ornI_Reg_nReg_rule, c)
      }
    }
}
void  State::_sub_Op_OrL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL__CONVI2L_MREGI__IMMI_32) && STATE__VALID_CHILD(_kids[1], _ANDL__CONVI2L_MREGI__IMML_MAXUI) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL__CONVI2L_MREGI__IMMI_32]+_kids[1]->_cost[_ANDL__CONVI2L_MREGI__IMML_MAXUI]+100;
        DFA_PRODUCTION(MREGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION(V1REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION(A0REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION(A1REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION(A2REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION(A3REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION(T0REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION(T1REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION(T3REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION(T8REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION(A4REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION(A5REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION(A6REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION(A7REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION(S0REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION(S1REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION(S3REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION(S4REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION(S7REGL, combine_i2l_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL__CONVI2L_MREGI__IMML_MAXUI) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_MREGI__IMMI_32) ) {
      unsigned int c = _kids[0]->_cost[_ANDL__CONVI2L_MREGI__IMML_MAXUI]+_kids[1]->_cost[_LSHIFTL__CONVI2L_MREGI__IMMI_32]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, combine_i2l_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_MREGLORI2L_IMMI_32_63) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_MREGLORI2L_IMMI_0_31) &&
        (
#line 9276 "src/hotspot/cpu/loongarch/loongarch_64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x3f)
#line 13107 "dfa_loongarch.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_MREGLORI2L_IMMI_32_63]+_kids[1]->_cost[_LSHIFTL_MREGLORI2L_IMMI_0_31]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_MREGLORI2L_IMMI_0_31) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_MREGLORI2L_IMMI_32_63) &&
        (
#line 9276 "src/hotspot/cpu/loongarch/loongarch_64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x3f)
#line 13181 "dfa_loongarch.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_MREGLORI2L_IMMI_0_31]+_kids[1]->_cost[_URSHIFTL_MREGLORI2L_IMMI_32_63]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, rolL_Reg_immI_32_63_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_MREGLORI2L_IMMI_0_31) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_MREGLORI2L_IMMI_32_63) &&
        (
#line 9259 "src/hotspot/cpu/loongarch/loongarch_64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x3f)
#line 13255 "dfa_loongarch.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_MREGLORI2L_IMMI_0_31]+_kids[1]->_cost[_LSHIFTL_MREGLORI2L_IMMI_32_63]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_MREGLORI2L_IMMI_32_63) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_MREGLORI2L_IMMI_0_31) &&
        (
#line 9259 "src/hotspot/cpu/loongarch/loongarch_64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x3f)
#line 13329 "dfa_loongarch.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_MREGLORI2L_IMMI_32_63]+_kids[1]->_cost[_URSHIFTL_MREGLORI2L_IMMI_0_31]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, rolL_Reg_immI_0_31_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], _CASTP2X_MREGP_) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[_CASTP2X_MREGP_]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, orL_Reg_P2XReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_MREGP_) && STATE__VALID_CHILD(_kids[1], MREGLORI2L) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_MREGP_]+_kids[1]->_cost[MREGLORI2L]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, orL_Reg_P2XReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], MREGLORI2L) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[MREGLORI2L]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, orL_Reg_Reg_rule, c)
      }
    }
}
void  State::_sub_Op_PartialSubtypeCheck(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NO_T8_MREGP) && STATE__VALID_CHILD(_kids[1], NO_T8_MREGP) ) {
      unsigned int c = _kids[0]->_cost[NO_T8_MREGP]+_kids[1]->_cost[NO_T8_MREGP]+1100;
        DFA_PRODUCTION(MREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION(NO_T8_MREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(S1_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(S3_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(S4_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(S5_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(S6_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(S7_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(T0_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(T1_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(T2_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(T3_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(A0_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(A1_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(A2_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(A3_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(A4_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(A5_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(A6_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(A7_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(V0_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(V1_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(NO_AX_MREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(T8_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(INDIRECT, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
    }
}
void  State::_sub_Op_PopCountI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 11263 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UsePopCountInstruction
#line 13645 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
        DFA_PRODUCTION(MREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MS0REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MS1REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MS3REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MS4REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MS5REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MS6REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MS7REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MT0REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MT1REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MT2REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MT3REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MT8REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MT4REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MA0REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MA1REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MA2REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MA3REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MA4REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MA5REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MA6REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION(MA7REGI, popCountI_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGIORL2I) &&
        (
#line 11246 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UsePopCountInstruction
#line 13678 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGIORL2I]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, popCountI_rule, c)
      }
    }
}
void  State::_sub_Op_PopCountL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 11298 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UsePopCountInstruction
#line 13763 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
        DFA_PRODUCTION(MREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MS0REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MS1REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MS3REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MS4REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MS5REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MS6REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MS7REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MT0REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MT1REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MT2REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MT3REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MT8REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MT4REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MA0REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MA1REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MA2REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MA3REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MA4REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MA5REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MA6REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION(MA7REGI, popCountL_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) &&
        (
#line 11281 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UsePopCountInstruction
#line 13796 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, popCountL_rule, c)
      }
    }
}
void  State::_sub_Op_PopCountVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 15562 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UsePopCountInstruction && n->as_Vector()->length() == 8
#line 13881 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, popcount8I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 15552 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UsePopCountInstruction && n->as_Vector()->length() == 4
#line 13890 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, popcount4I_rule, c)
    }
}
void  State::_sub_Op_PrefetchAllocation(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION(UNIVERSE, prefetchAlloc_rule, c)
    }
}
void  State::_sub_Op_RShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+100;
        DFA_PRODUCTION(MREGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS0REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS1REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS3REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS4REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS5REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS6REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS7REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT0REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT1REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT2REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT3REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT8REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT4REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA0REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA1REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA2REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA3REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA4REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA5REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA6REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA7REGI, shr_arith_Reg_Reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMIU5) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMIU5]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, shr_arith_Reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_MREGI_IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_MREGI_IMMI_24]+_kids[1]->_cost[IMMI_24]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, i2b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_MREGI_IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_16) &&
        /*sixteen*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_MREGI_IMMI_16]+_kids[1]->_cost[IMMI_16]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, i2s_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__CONVL2I__ANDL_MREGL_IMML_7__IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_16) &&
        /*sixteen*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__CONVL2I__ANDL_MREGL_IMML_7__IMMI_16]+_kids[1]->_cost[IMMI_16]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, land7_2_s_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADS_MEMORY__IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADS_MEMORY__IMMI_24]+_kids[1]->_cost[IMMI_24]+125;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, loadS2B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADI_MEMORY__IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_16) &&
        /*sixteen*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADI_MEMORY__IMMI_16]+_kids[1]->_cost[IMMI_16]+125;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, loadI2S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADI_MEMORY__IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADI_MEMORY__IMMI_24]+_kids[1]->_cost[IMMI_24]+125;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, loadI2B_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[MREGI]+100;
        DFA_PRODUCTION(MREGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION(V1REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A0REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A1REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A2REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A3REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION(T0REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION(T1REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION(T3REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION(T8REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A4REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A5REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A6REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A7REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION(S0REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION(S1REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION(S3REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION(S4REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION(S7REGL, sarL_Reg_Reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[IMMI_32_63];
        DFA_PRODUCTION(_RSHIFTL_MREGLORI2L_IMMI_32_63, _RShiftL_mRegLorI2L_immI_32_63_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], IMMIU6) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[IMMIU6]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, sarL_Reg_imm_rule, c)
      }
    }
}
void  State::_sub_Op_Rethrow(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION(UNIVERSE, RethrowException_rule, c)
    }
}
void  State::_sub_Op_Return(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION(UNIVERSE, Ret_rule, c)
    }
}
void  State::_sub_Op_RoundDouble(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD];
        DFA_PRODUCTION(REGD, roundDouble_nop_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_RoundDoubleMode(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 9626 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseLSX
#line 14608 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION(REGD, roundD_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_RoundDoubleModeV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 14805 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 14620 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION(VECY, round4D_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 14791 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 14629 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION(VECX, round2D_rule, c)
    }
}
void  State::_sub_Op_RoundFloat(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF];
        DFA_PRODUCTION(REGF, roundFloat_nop_rule, c)
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_RotateLeft(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGI]+100;
        DFA_PRODUCTION(MREGL, rolL_reg_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, rolL_reg_rule, c)
        DFA_PRODUCTION(V1REGL, rolL_reg_rule, c)
        DFA_PRODUCTION(A0REGL, rolL_reg_rule, c)
        DFA_PRODUCTION(A1REGL, rolL_reg_rule, c)
        DFA_PRODUCTION(A2REGL, rolL_reg_rule, c)
        DFA_PRODUCTION(A3REGL, rolL_reg_rule, c)
        DFA_PRODUCTION(T0REGL, rolL_reg_rule, c)
        DFA_PRODUCTION(T1REGL, rolL_reg_rule, c)
        DFA_PRODUCTION(T3REGL, rolL_reg_rule, c)
        DFA_PRODUCTION(T8REGL, rolL_reg_rule, c)
        DFA_PRODUCTION(A4REGL, rolL_reg_rule, c)
        DFA_PRODUCTION(A5REGL, rolL_reg_rule, c)
        DFA_PRODUCTION(A6REGL, rolL_reg_rule, c)
        DFA_PRODUCTION(A7REGL, rolL_reg_rule, c)
        DFA_PRODUCTION(S0REGL, rolL_reg_rule, c)
        DFA_PRODUCTION(S1REGL, rolL_reg_rule, c)
        DFA_PRODUCTION(S3REGL, rolL_reg_rule, c)
        DFA_PRODUCTION(S4REGL, rolL_reg_rule, c)
        DFA_PRODUCTION(S7REGL, rolL_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+100;
        DFA_PRODUCTION(MREGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MS0REGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MS1REGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MS3REGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MS4REGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MS5REGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MS6REGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MS7REGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MT0REGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MT1REGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MT2REGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MT3REGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MT8REGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MT4REGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MA0REGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MA1REGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MA2REGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MA3REGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MA4REGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MA5REGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MA6REGI, rolI_reg_rule, c)
        DFA_PRODUCTION(MA7REGI, rolI_reg_rule, c)
    }
}
void  State::_sub_Op_RotateLeftV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 13837 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 14702 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION(VECY, rotl4L_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13825 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 14711 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, rotl4L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 13815 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 14722 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, rotl8I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13803 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 14733 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, rotl8I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 13793 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 14744 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION(VECX, rotl2L_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13781 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 14753 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, rotl2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 13771 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 14764 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, rotl4I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13759 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 14775 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, rotl4I_rule, c)
      }
    }
}
void  State::_sub_Op_RotateRight(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGI]+100;
        DFA_PRODUCTION(MREGL, rorL_reg_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, rorL_reg_rule, c)
        DFA_PRODUCTION(V1REGL, rorL_reg_rule, c)
        DFA_PRODUCTION(A0REGL, rorL_reg_rule, c)
        DFA_PRODUCTION(A1REGL, rorL_reg_rule, c)
        DFA_PRODUCTION(A2REGL, rorL_reg_rule, c)
        DFA_PRODUCTION(A3REGL, rorL_reg_rule, c)
        DFA_PRODUCTION(T0REGL, rorL_reg_rule, c)
        DFA_PRODUCTION(T1REGL, rorL_reg_rule, c)
        DFA_PRODUCTION(T3REGL, rorL_reg_rule, c)
        DFA_PRODUCTION(T8REGL, rorL_reg_rule, c)
        DFA_PRODUCTION(A4REGL, rorL_reg_rule, c)
        DFA_PRODUCTION(A5REGL, rorL_reg_rule, c)
        DFA_PRODUCTION(A6REGL, rorL_reg_rule, c)
        DFA_PRODUCTION(A7REGL, rorL_reg_rule, c)
        DFA_PRODUCTION(S0REGL, rorL_reg_rule, c)
        DFA_PRODUCTION(S1REGL, rorL_reg_rule, c)
        DFA_PRODUCTION(S3REGL, rorL_reg_rule, c)
        DFA_PRODUCTION(S4REGL, rorL_reg_rule, c)
        DFA_PRODUCTION(S7REGL, rorL_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, rorL_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, rorL_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, rorL_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, rorL_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, rorL_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, rorL_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, rorL_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, rorL_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, rorL_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, rorL_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, rorL_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, rorL_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, rorL_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, rorL_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, rorL_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, rorL_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, rorL_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, rorL_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, rorL_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, rorL_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+100;
        DFA_PRODUCTION(MREGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MS0REGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MS1REGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MS3REGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MS4REGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MS5REGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MS6REGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MS7REGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MT0REGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MT1REGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MT2REGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MT3REGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MT8REGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MT4REGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MA0REGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MA1REGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MA2REGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MA3REGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MA4REGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MA5REGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MA6REGI, rorI_reg_rule, c)
        DFA_PRODUCTION(MA7REGI, rorI_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, rorI_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, rorI_imm_rule, c)
      }
    }
}
void  State::_sub_Op_RotateRightV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 13747 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 14990 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION(VECY, rotr4L_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13737 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 14999 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, rotr4L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 13727 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 15010 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, rotr8I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13717 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 15021 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, rotr8I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 13707 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 15032 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION(VECX, rotr2L_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13697 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 15041 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, rotr2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 13687 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 15052 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, rotr4I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13677 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 15063 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, rotr4I_rule, c)
      }
    }
}
void  State::_sub_Op_SafePoint(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+125;
        DFA_PRODUCTION(UNIVERSE, safePoint_poll_tls_rule, c)
    }
}
void  State::_sub_Op_ShenandoahCompareAndExchangeP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+100;
        DFA_PRODUCTION(MREGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION(NO_T8_MREGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(S1_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(S3_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(S4_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(S5_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(S6_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(S7_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(T0_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(T1_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(T2_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(T3_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(A0_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(A1_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(A2_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(A3_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(A4_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(A5_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(A6_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(A7_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(V0_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(V1_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(NO_AX_MREGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(T8_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(INDIRECT, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
    }
}
void  State::_sub_Op_ShenandoahCompareAndExchangeN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_MREGN_MREGN]+100;
        DFA_PRODUCTION(MREGN, compareAndExchangeN_shenandoah_rule, c)
        DFA_PRODUCTION(T0_REGN, compareAndExchangeN_shenandoah_rule, c)
        DFA_PRODUCTION(T1_REGN, compareAndExchangeN_shenandoah_rule, c)
        DFA_PRODUCTION(T3_REGN, compareAndExchangeN_shenandoah_rule, c)
        DFA_PRODUCTION(T8_REGN, compareAndExchangeN_shenandoah_rule, c)
        DFA_PRODUCTION(A0_REGN, compareAndExchangeN_shenandoah_rule, c)
        DFA_PRODUCTION(A1_REGN, compareAndExchangeN_shenandoah_rule, c)
        DFA_PRODUCTION(A2_REGN, compareAndExchangeN_shenandoah_rule, c)
        DFA_PRODUCTION(A3_REGN, compareAndExchangeN_shenandoah_rule, c)
        DFA_PRODUCTION(A4_REGN, compareAndExchangeN_shenandoah_rule, c)
        DFA_PRODUCTION(A5_REGN, compareAndExchangeN_shenandoah_rule, c)
        DFA_PRODUCTION(A6_REGN, compareAndExchangeN_shenandoah_rule, c)
        DFA_PRODUCTION(A7_REGN, compareAndExchangeN_shenandoah_rule, c)
        DFA_PRODUCTION(S0_REGN, compareAndExchangeN_shenandoah_rule, c)
        DFA_PRODUCTION(S1_REGN, compareAndExchangeN_shenandoah_rule, c)
        DFA_PRODUCTION(S2_REGN, compareAndExchangeN_shenandoah_rule, c)
        DFA_PRODUCTION(S3_REGN, compareAndExchangeN_shenandoah_rule, c)
        DFA_PRODUCTION(S4_REGN, compareAndExchangeN_shenandoah_rule, c)
        DFA_PRODUCTION(S5_REGN, compareAndExchangeN_shenandoah_rule, c)
        DFA_PRODUCTION(S6_REGN, compareAndExchangeN_shenandoah_rule, c)
        DFA_PRODUCTION(S7_REGN, compareAndExchangeN_shenandoah_rule, c)
    }
}
void  State::_sub_Op_ShenandoahCompareAndSwapN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_MREGN_MREGN]+100;
        DFA_PRODUCTION(MREGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MS0REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MS1REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MS3REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MS4REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MS5REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MS6REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MS7REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MT0REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MT1REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MT2REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MT3REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MT8REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MT4REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MA0REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MA1REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MA2REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MA3REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MA4REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MA5REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MA6REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MA7REGI, compareAndSwapN_shenandoah_rule, c)
    }
}
void  State::_sub_Op_ShenandoahCompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+100;
        DFA_PRODUCTION(MREGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MS0REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MS1REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MS3REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MS4REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MS5REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MS6REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MS7REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MT0REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MT1REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MT2REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MT3REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MT8REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MT4REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MA0REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MA1REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MA2REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MA3REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MA4REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MA5REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MA6REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MA7REGI, compareAndSwapP_shenandoah_rule, c)
    }
}
void  State::_sub_Op_ShenandoahWeakCompareAndSwapN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_MREGN_MREGN]+100;
        DFA_PRODUCTION(MREGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MS0REGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MS1REGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MS3REGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MS4REGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MS5REGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MS6REGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MS7REGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MT0REGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MT1REGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MT2REGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MT3REGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MT8REGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MT4REGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MA0REGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MA1REGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MA2REGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MA3REGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MA4REGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MA5REGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MA6REGI, weakCompareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION(MA7REGI, weakCompareAndSwapN_shenandoah_rule, c)
    }
}
void  State::_sub_Op_ShenandoahWeakCompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+100;
        DFA_PRODUCTION(MREGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MS0REGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MS1REGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MS3REGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MS4REGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MS5REGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MS6REGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MS7REGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MT0REGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MT1REGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MT2REGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MT3REGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MT8REGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MT4REGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MA0REGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MA1REGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MA2REGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MA3REGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MA4REGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MA5REGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MA6REGI, weakCompareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION(MA7REGI, weakCompareAndSwapP_shenandoah_rule, c)
    }
}
void  State::_sub_Op_CopySignD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_IMMD_0) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_BINARY_REGD_IMMD_0]+100;
        DFA_PRODUCTION(REGD, copySignD_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_CopySignF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+100;
        DFA_PRODUCTION(REGF, copySignF_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_SqrtD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _CONVF2D_REGF_) ) {
      unsigned int c = _kids[0]->_cost[_CONVF2D_REGF_];
        DFA_PRODUCTION(_SQRTD__CONVF2D_REGF__, _SqrtD__ConvF2D_regF___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION(REGD, sqrtD_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_StoreB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], MREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[MREGIORL2I]+125;
        DFA_PRODUCTION(UNIVERSE, storeB_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI_0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI_0]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeB_immB_0_rule, c)
      }
    }
}
void  State::_sub_Op_StoreC(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI_0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI_0]+125;
        DFA_PRODUCTION(UNIVERSE, storeC_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], MREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[MREGIORL2I]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeC_rule, c)
      }
    }
}
void  State::_sub_Op_StoreCM(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI_0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI_0]+150;
        DFA_PRODUCTION(UNIVERSE, storeImmCM_rule, c)
    }
}
void  State::_sub_Op_StorePConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+100;
        DFA_PRODUCTION(FLAGSREG, storePConditional_rule, c)
    }
}
void  State::_sub_Op_StoreIConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_MREGI_MREGI]+100;
        DFA_PRODUCTION(FLAGSREG, storeIConditional_rule, c)
    }
}
void  State::_sub_Op_StoreLConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+100;
        DFA_PRODUCTION(FLAGSREG, storeLConditional_rule, c)
    }
}
void  State::_sub_Op_StoreD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMD_0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMD_0]+40;
        DFA_PRODUCTION(UNIVERSE, storeD_immD_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGD]+50;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeD_reg_rule, c)
      }
    }
}
void  State::_sub_Op_StoreF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMF_0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMF_0]+40;
        DFA_PRODUCTION(UNIVERSE, storeF_immF_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGF]+50;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeF_reg_rule, c)
      }
    }
}
void  State::_sub_Op_StoreI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], MREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[MREGIORL2I]+130;
        DFA_PRODUCTION(UNIVERSE, storeI_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], MREGIORL2I) &&
        (
#line 5114 "src/hotspot/cpu/loongarch/loongarch_64.ad"
!needs_releasing_store(n)
#line 15362 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[MREGIORL2I]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMI_0) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMI_0]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeI_immI_0_volatile_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI_0) &&
        (
#line 5090 "src/hotspot/cpu/loongarch/loongarch_64.ad"
!needs_releasing_store(n)
#line 15379 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI_0]+120;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeI_immI_0_rule, c)
      }
    }
}
void  State::_sub_Op_StoreL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMML_0) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMML_0]+185;
        DFA_PRODUCTION(UNIVERSE, storeL_immL_0_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMML_0) &&
        (
#line 4660 "src/hotspot/cpu/loongarch/loongarch_64.ad"
!needs_releasing_store(n)
#line 15396 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMML_0]+180;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeL_immL_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[MREGL]+205;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeL_reg_volatile_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], MREGL) &&
        (
#line 4637 "src/hotspot/cpu/loongarch/loongarch_64.ad"
!needs_releasing_store(n)
#line 15413 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[MREGL]+200;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeL_reg_rule, c)
      }
    }
}
void  State::_sub_Op_StoreP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMP_0) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMP_0]+130;
        DFA_PRODUCTION(UNIVERSE, storeImmP_immP_0_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMP_0) &&
        (
#line 4835 "src/hotspot/cpu/loongarch/loongarch_64.ad"
!needs_releasing_store(n)
#line 15430 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMP_0]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeImmP_immP_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], MREGP) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[MREGP]+130;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeP_volatile_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], MREGP) &&
        (
#line 4811 "src/hotspot/cpu/loongarch/loongarch_64.ad"
!needs_releasing_store(n)
#line 15447 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[MREGP]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeP_rule, c)
      }
    }
}
void  State::_sub_Op_StoreN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMN_0) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMN_0]+130;
        DFA_PRODUCTION(UNIVERSE, storeImmN_immN_0_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMN_0) &&
        (
#line 4962 "src/hotspot/cpu/loongarch/loongarch_64.ad"
!needs_releasing_store(n)
#line 15464 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMN_0]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeImmN_immN_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _ENCODEP_MREGP_) &&
        (
#line 4898 "src/hotspot/cpu/loongarch/loongarch_64.ad"
CompressedOops::base() == NULL && CompressedOops::shift() == 0
#line 15475 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_ENCODEP_MREGP_]+130;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeP2N_volatile_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ENCODEP_MREGP_) &&
        (
#line 4885 "src/hotspot/cpu/loongarch/loongarch_64.ad"
CompressedOops::base() == NULL && CompressedOops::shift() == 0 && !needs_releasing_store(n)
#line 15486 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ENCODEP_MREGP_]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeP2N_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], MREGN) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[MREGN]+130;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeN_volatile_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], MREGN) &&
        (
#line 4860 "src/hotspot/cpu/loongarch/loongarch_64.ad"
!needs_releasing_store(n)
#line 15503 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[MREGN]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeN_rule, c)
      }
    }
}
void  State::_sub_Op_StoreNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _ENCODEPKLASS_MREGP_) &&
        (
#line 4949 "src/hotspot/cpu/loongarch/loongarch_64.ad"
CompressedKlassPointers::base() == NULL && CompressedKlassPointers::shift() == 0
#line 15516 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_ENCODEPKLASS_MREGP_]+130;
        DFA_PRODUCTION(UNIVERSE, storeP2NKlass_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ENCODEPKLASS_MREGP_) &&
        (
#line 4936 "src/hotspot/cpu/loongarch/loongarch_64.ad"
CompressedKlassPointers::base() == NULL && CompressedKlassPointers::shift() == 0 && !needs_releasing_store(n)
#line 15525 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ENCODEPKLASS_MREGP_]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeP2NKlass_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], MREGN) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[MREGN]+130;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeNKlass_volatile_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], MREGN) &&
        (
#line 4911 "src/hotspot/cpu/loongarch/loongarch_64.ad"
!needs_releasing_store(n)
#line 15542 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[MREGN]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeNKlass_rule, c)
      }
    }
}
void  State::_sub_Op_StrComp(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_A4_REGP_MA5REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_A6_REGP_MA7REGI) &&
        (
#line 7572 "src/hotspot/cpu/loongarch/loongarch_64.ad"
((StrCompNode*)n)->encoding() == StrIntrinsicNode::UL
#line 15555 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_A4_REGP_MA5REGI]+_kids[1]->_cost[_BINARY_A6_REGP_MA7REGI]+100;
        DFA_PRODUCTION(NO_AX_MREGI, string_compareUL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_A4_REGP_MA5REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_A6_REGP_MA7REGI) &&
        (
#line 7557 "src/hotspot/cpu/loongarch/loongarch_64.ad"
((StrCompNode*)n)->encoding() == StrIntrinsicNode::LU
#line 15564 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_A4_REGP_MA5REGI]+_kids[1]->_cost[_BINARY_A6_REGP_MA7REGI]+100;
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, string_compareLU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_A4_REGP_MA5REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_A6_REGP_MA7REGI) &&
        (
#line 7542 "src/hotspot/cpu/loongarch/loongarch_64.ad"
((StrCompNode*)n)->encoding() == StrIntrinsicNode::UU
#line 15575 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_A4_REGP_MA5REGI]+_kids[1]->_cost[_BINARY_A6_REGP_MA7REGI]+100;
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, string_compareU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_A4_REGP_MA5REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_A6_REGP_MA7REGI) &&
        (
#line 7527 "src/hotspot/cpu/loongarch/loongarch_64.ad"
((StrCompNode*)n)->encoding() == StrIntrinsicNode::LL
#line 15586 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_A4_REGP_MA5REGI]+_kids[1]->_cost[_BINARY_A6_REGP_MA7REGI]+100;
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, string_compareL_rule, c)
      }
    }
}
void  State::_sub_Op_StrCompressedCopy(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], A4_REGP) && STATE__VALID_CHILD(_kids[1], _BINARY_A5_REGP_MA6REGI) ) {
      unsigned int c = _kids[0]->_cost[A4_REGP]+_kids[1]->_cost[_BINARY_A5_REGP_MA6REGI]+100;
        DFA_PRODUCTION(NO_AX_MREGI, string_compress_rule, c)
    }
}
void  State::_sub_Op_StrEquals(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_A4_REGP_A5_REGP) && STATE__VALID_CHILD(_kids[1], MA6REGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_A4_REGP_A5_REGP]+_kids[1]->_cost[MA6REGI]+100;
        DFA_PRODUCTION(NO_AX_MREGI, string_equals_rule, c)
    }
}
void  State::_sub_Op_StrIndexOf(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_A4_REGP_MA5REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_A6_REGP_IMMI_1) &&
        (
#line 7672 "src/hotspot/cpu/loongarch/loongarch_64.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UL
#line 15611 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_A4_REGP_MA5REGI]+_kids[1]->_cost[_BINARY_A6_REGP_IMMI_1]+100;
        DFA_PRODUCTION(MT8REGI, string_indexof_conUL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_A4_REGP_MA5REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_A6_REGP_IMMI_1_4) &&
        (
#line 7655 "src/hotspot/cpu/loongarch/loongarch_64.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::LL
#line 15620 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_A4_REGP_MA5REGI]+_kids[1]->_cost[_BINARY_A6_REGP_IMMI_1_4]+100;
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, string_indexof_conLL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_A4_REGP_MA5REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_A6_REGP_IMMI_1_4) &&
        (
#line 7637 "src/hotspot/cpu/loongarch/loongarch_64.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UU
#line 15631 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_A4_REGP_MA5REGI]+_kids[1]->_cost[_BINARY_A6_REGP_IMMI_1_4]+100;
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, string_indexof_conUU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_A4_REGP_MA5REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_A6_REGP_MA7REGI) &&
        (
#line 7621 "src/hotspot/cpu/loongarch/loongarch_64.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UL
#line 15642 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_A4_REGP_MA5REGI]+_kids[1]->_cost[_BINARY_A6_REGP_MA7REGI]+100;
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, string_indexofUL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_A4_REGP_MA5REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_A6_REGP_MA7REGI) &&
        (
#line 7605 "src/hotspot/cpu/loongarch/loongarch_64.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::LL
#line 15653 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_A4_REGP_MA5REGI]+_kids[1]->_cost[_BINARY_A6_REGP_MA7REGI]+100;
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, string_indexofLL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_A4_REGP_MA5REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_A6_REGP_MA7REGI) &&
        (
#line 7589 "src/hotspot/cpu/loongarch/loongarch_64.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UU
#line 15664 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_A4_REGP_MA5REGI]+_kids[1]->_cost[_BINARY_A6_REGP_MA7REGI]+100;
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, string_indexofUU_rule, c)
      }
    }
}
void  State::_sub_Op_StrIndexOfChar(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_A4_REGP_MA5REGI) && STATE__VALID_CHILD(_kids[1], MA6REGI) &&
        (
#line 7703 "src/hotspot/cpu/loongarch/loongarch_64.ad"
((StrIndexOfCharNode*)n)->encoding() == StrIntrinsicNode::L
#line 15677 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_A4_REGP_MA5REGI]+_kids[1]->_cost[MA6REGI]+100;
        DFA_PRODUCTION(NO_AX_MREGI, stringL_indexof_char_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_A4_REGP_MA5REGI) && STATE__VALID_CHILD(_kids[1], MA6REGI) &&
        (
#line 7687 "src/hotspot/cpu/loongarch/loongarch_64.ad"
((StrIndexOfCharNode*)n)->encoding() == StrIntrinsicNode::U
#line 15686 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_A4_REGP_MA5REGI]+_kids[1]->_cost[MA6REGI]+100;
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, string_indexof_char_rule, c)
      }
    }
}
void  State::_sub_Op_StrInflatedCopy(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], A4_REGP) && STATE__VALID_CHILD(_kids[1], _BINARY_A5_REGP_MA6REGI) ) {
      unsigned int c = _kids[0]->_cost[A4_REGP]+_kids[1]->_cost[_BINARY_A5_REGP_MA6REGI]+100;
        DFA_PRODUCTION(UNIVERSE, string_inflate_rule, c)
    }
}
void  State::_sub_Op_SubD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+100;
        DFA_PRODUCTION(REGD, subD_reg_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_SubF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+100;
        DFA_PRODUCTION(REGF, subF_reg_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_SubI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI_0) && STATE__VALID_CHILD(_kids[1], MREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IMMI_0]+_kids[1]->_cost[MREGIORL2I]+80;
        DFA_PRODUCTION(MREGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MS0REGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MS1REGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MS3REGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MS4REGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MS5REGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MS6REGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MS7REGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MT0REGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MT1REGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MT2REGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MT3REGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MT8REGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MT4REGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MA0REGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MA1REGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MA2REGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MA3REGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MA4REGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MA5REGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MA6REGI, negI_Reg_rule, c)
        DFA_PRODUCTION(MA7REGI, negI_Reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI_M2047_2048) ) {
      unsigned int c = _kids[0]->_cost[MREGIORL2I]+_kids[1]->_cost[IMMI_M2047_2048]+80;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGIORL2I) && STATE__VALID_CHILD(_kids[1], MREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[MREGIORL2I]+_kids[1]->_cost[MREGIORL2I]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, subI_Reg_Reg_rule, c)
      }
    }
}
void  State::_sub_Op_SubL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], MREGLORI2L) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[MREGLORI2L]+100;
        DFA_PRODUCTION(MREGL, subL_Reg_Reg_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, subL_Reg_Reg_rule, c)
        DFA_PRODUCTION(V1REGL, subL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A0REGL, subL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A1REGL, subL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A2REGL, subL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A3REGL, subL_Reg_Reg_rule, c)
        DFA_PRODUCTION(T0REGL, subL_Reg_Reg_rule, c)
        DFA_PRODUCTION(T1REGL, subL_Reg_Reg_rule, c)
        DFA_PRODUCTION(T3REGL, subL_Reg_Reg_rule, c)
        DFA_PRODUCTION(T8REGL, subL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A4REGL, subL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A5REGL, subL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A6REGL, subL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A7REGL, subL_Reg_Reg_rule, c)
        DFA_PRODUCTION(S0REGL, subL_Reg_Reg_rule, c)
        DFA_PRODUCTION(S1REGL, subL_Reg_Reg_rule, c)
        DFA_PRODUCTION(S3REGL, subL_Reg_Reg_rule, c)
        DFA_PRODUCTION(S4REGL, subL_Reg_Reg_rule, c)
        DFA_PRODUCTION(S7REGL, subL_Reg_Reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_M2047_2048) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_M2047_2048]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML_0) && STATE__VALID_CHILD(_kids[1], MREGLORI2L) ) {
      unsigned int c = _kids[0]->_cost[IMML_0]+_kids[1]->_cost[MREGLORI2L]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, negL_Reg_rule, c)
      }
    }
}
void  State::_sub_Op_TailCall(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[MREGP]+300;
        DFA_PRODUCTION(UNIVERSE, TailCalljmpInd_rule, c)
    }
}
void  State::_sub_Op_TailJump(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NO_AX_MREGP) && STATE__VALID_CHILD(_kids[1], MREGP) ) {
      unsigned int c = _kids[0]->_cost[NO_AX_MREGP]+_kids[1]->_cost[MREGP]+200;
        DFA_PRODUCTION(UNIVERSE, tailjmpInd_rule, c)
    }
}
void  State::_sub_Op_ThreadLocal(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(MREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION(NO_T8_MREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(S1_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(S3_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(S4_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(S5_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(S6_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(S7_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(T0_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(T1_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(T2_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(T3_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(A0_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(A1_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(A2_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(A3_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(A4_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(A5_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(A6_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(A7_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(V0_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(V1_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(NO_AX_MREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(T8_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(INDIRECT, tlsLoadP_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(MEMORY_LOADRANGE, indirect_rule, c)
    }
}
void  State::_sub_Op_URShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+100;
        DFA_PRODUCTION(MREGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS0REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS1REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS3REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS4REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS5REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS6REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS7REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT0REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT1REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT2REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT3REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT8REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT4REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA0REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA1REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA2REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA3REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA4REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA5REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA6REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA7REGI, shr_logical_Reg_Reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMIU5) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMIU5]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, shr_logical_Reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_0_31) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_0_31];
        DFA_PRODUCTION(_URSHIFTI_MREGI_IMMI_0_31, _URShiftI_mRegI_immI_0_31_rule, c)
    }
}
void  State::_sub_Op_URShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_MREGP_) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_MREGP_]+_kids[1]->_cost[IMMI_32_63]+80;
        DFA_PRODUCTION(MREGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION(V1REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION(A0REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION(A1REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION(A2REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION(A3REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION(T0REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION(T1REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION(T3REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION(T8REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION(A4REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION(A5REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION(A6REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION(A7REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION(S0REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION(S1REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION(S3REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION(S4REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION(S7REGL, slrL_P2XReg_immI_32_63_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[IMMI_32_63];
        DFA_PRODUCTION(_URSHIFTL_MREGLORI2L_IMMI_32_63, _URShiftL_mRegLorI2L_immI_32_63_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[IMMI_32_63]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, slrL_Reg_immI_32_63_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_MREGP_) && STATE__VALID_CHILD(_kids[1], IMMI_0_31) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_MREGP_]+_kids[1]->_cost[IMMI_0_31]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], IMMI_0_31) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[IMMI_0_31];
        DFA_PRODUCTION(_URSHIFTL_MREGLORI2L_IMMI_0_31, _URShiftL_mRegLorI2L_immI_0_31_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGLORI2L) && STATE__VALID_CHILD(_kids[1], IMMI_0_31) ) {
      unsigned int c = _kids[0]->_cost[MREGLORI2L]+_kids[1]->_cost[IMMI_0_31]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, slrL_Reg_immI_0_31_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, slrL_Reg_Reg_rule, c)
      }
    }
}
void  State::_sub_Op_XorI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+100;
        DFA_PRODUCTION(MREGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS0REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS1REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS3REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS4REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS5REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS6REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MS7REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT0REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT1REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT2REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT3REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT8REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MT4REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA0REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA1REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA2REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA3REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA4REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA5REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA6REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION(MA7REGI, xorI_Reg_Reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION(_XORI_MREGI_IMMI_M1, _XorI_mRegI_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[MREGIORL2I]+_kids[1]->_cost[IMMI_M1]+60;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, xorI_Reg_immI_M1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_0_4095) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_0_4095]+60;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, xorI_Reg_imm_0_4095_rule, c)
      }
    }
}
void  State::_sub_Op_XorL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGL]+100;
        DFA_PRODUCTION(MREGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION(V1REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A0REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A1REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A2REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A3REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION(T0REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION(T1REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION(T3REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION(T8REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A4REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A5REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A6REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION(A7REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION(S0REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION(S1REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION(S3REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION(S4REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION(S7REGL, xorL_Reg_Reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_0_4095) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_0_4095]+60;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, xorL_Reg_imm_0_4095_rule, c)
      }
    }
}
void  State::_sub_Op_AddVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _MULVB_VECY_VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12763 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 16824 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULVB_VECY_VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, madd32B_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _MULVB_VECY_VECY) &&
        (
#line 12763 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 16833 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_MULVB_VECY_VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, madd32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _MULVB_VECX_VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 12701 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 16844 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULVB_VECX_VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, madd16B_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _MULVB_VECX_VECX) &&
        (
#line 12701 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 16853 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_MULVB_VECX_VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, madd16B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEB_IMMIU5_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 11675 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 16864 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEB_IMMIU5_]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, add32B_imm_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _REPLICATEB_IMMIU5_) &&
        (
#line 11675 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 16875 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_REPLICATEB_IMMIU5_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, add32B_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 11665 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 16886 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, add32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEB_IMMIU5_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 11575 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 16897 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEB_IMMIU5_]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, add16B_imm_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _REPLICATEB_IMMIU5_) &&
        (
#line 11575 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 16908 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_REPLICATEB_IMMIU5_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, add16B_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 11565 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 16919 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, add16B_rule, c)
      }
    }
}
void  State::_sub_Op_AddVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _MULVS_VECY_VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12773 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 16932 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULVS_VECY_VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, madd16S_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _MULVS_VECY_VECY) &&
        (
#line 12773 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 16941 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_MULVS_VECY_VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, madd16S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _MULVS_VECX_VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 12711 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 16952 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULVS_VECX_VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, madd8S_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _MULVS_VECX_VECX) &&
        (
#line 12711 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 16961 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_MULVS_VECX_VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, madd8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATES_IMMIU5_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 11695 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 16972 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATES_IMMIU5_]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, add16S_imm_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _REPLICATES_IMMIU5_) &&
        (
#line 11695 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 16983 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_REPLICATES_IMMIU5_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, add16S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 11685 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 16994 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, add16S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATES_IMMIU5_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 11595 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 17005 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATES_IMMIU5_]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, add8S_imm_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _REPLICATES_IMMIU5_) &&
        (
#line 11595 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 17016 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_REPLICATES_IMMIU5_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, add8S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 11585 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 17027 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, add8S_rule, c)
      }
    }
}
void  State::_sub_Op_AddVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _MULVI_VECY_VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12783 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 17040 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULVI_VECY_VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, madd8I_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _MULVI_VECY_VECY) &&
        (
#line 12783 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 17049 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_MULVI_VECY_VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, madd8I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _MULVI_VECX_VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 12721 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 17060 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULVI_VECX_VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, madd4I_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _MULVI_VECX_VECX) &&
        (
#line 12721 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 17069 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_MULVI_VECX_VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, madd4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEI_IMMIU5_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 11715 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 17080 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEI_IMMIU5_]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, add8I_imm_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _REPLICATEI_IMMIU5_) &&
        (
#line 11715 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 17091 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_REPLICATEI_IMMIU5_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, add8I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 11705 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 17102 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, add8I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEI_IMMIU5_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 11615 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 17113 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEI_IMMIU5_]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, add4I_imm_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _REPLICATEI_IMMIU5_) &&
        (
#line 11615 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 17124 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_REPLICATEI_IMMIU5_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, add4I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 11605 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 17135 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, add4I_rule, c)
      }
    }
}
void  State::_sub_Op_AddReductionVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14161 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 8 && vector_element_basic_type(n->in(2)) == T_INT
#line 17148 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(MREGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MS0REGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MS1REGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MS3REGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MS4REGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MS5REGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MS6REGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MS7REGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MT0REGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MT1REGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MT2REGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MT3REGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MT8REGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MT4REGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MA0REGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MA1REGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MA2REGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MA3REGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MA4REGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MA5REGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MA6REGI, reduce_add8I_rule, c)
        DFA_PRODUCTION(MA7REGI, reduce_add8I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14150 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 16 && vector_element_basic_type(n->in(2)) == T_SHORT
#line 17181 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_add16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_add16S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14139 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 32 && vector_element_basic_type(n->in(2)) == T_BYTE
#line 17264 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_add32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_add32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14095 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 4 && vector_element_basic_type(n->in(2)) == T_INT
#line 17347 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_add4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_add4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14084 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 8 && vector_element_basic_type(n->in(2)) == T_SHORT
#line 17430 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_add8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_add8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14073 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 16 && vector_element_basic_type(n->in(2)) == T_BYTE
#line 17513 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_add16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_add16B_rule, c)
      }
    }
}
void  State::_sub_Op_AddVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _MULVL_VECY_VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12793 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 17598 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULVL_VECY_VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, madd4L_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _MULVL_VECY_VECY) &&
        (
#line 12793 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 17607 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_MULVL_VECY_VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, madd4L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _MULVL_VECX_VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 12731 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 17618 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULVL_VECX_VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, madd2L_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _MULVL_VECX_VECX) &&
        (
#line 12731 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 17627 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_MULVL_VECX_VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, madd2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEL_IMMLU5_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 11735 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 17638 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEL_IMMLU5_]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, add4L_imm_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _REPLICATEL_IMMLU5_) &&
        (
#line 11735 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 17649 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_REPLICATEL_IMMLU5_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, add4L_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 11725 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 17660 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, add4L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEL_IMMLU5_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 11635 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 17671 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEL_IMMLU5_]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, add2L_imm_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _REPLICATEL_IMMLU5_) &&
        (
#line 11635 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 17682 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_REPLICATEL_IMMLU5_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, add2L_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 11625 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 17693 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, add2L_rule, c)
      }
    }
}
void  State::_sub_Op_AddReductionVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14172 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 4 && vector_element_basic_type(n->in(2)) == T_LONG
#line 17706 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(MREGL, reduce_add4L_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, reduce_add4L_rule, c)
        DFA_PRODUCTION(V1REGL, reduce_add4L_rule, c)
        DFA_PRODUCTION(A0REGL, reduce_add4L_rule, c)
        DFA_PRODUCTION(A1REGL, reduce_add4L_rule, c)
        DFA_PRODUCTION(A2REGL, reduce_add4L_rule, c)
        DFA_PRODUCTION(A3REGL, reduce_add4L_rule, c)
        DFA_PRODUCTION(T0REGL, reduce_add4L_rule, c)
        DFA_PRODUCTION(T1REGL, reduce_add4L_rule, c)
        DFA_PRODUCTION(T3REGL, reduce_add4L_rule, c)
        DFA_PRODUCTION(T8REGL, reduce_add4L_rule, c)
        DFA_PRODUCTION(A4REGL, reduce_add4L_rule, c)
        DFA_PRODUCTION(A5REGL, reduce_add4L_rule, c)
        DFA_PRODUCTION(A6REGL, reduce_add4L_rule, c)
        DFA_PRODUCTION(A7REGL, reduce_add4L_rule, c)
        DFA_PRODUCTION(S0REGL, reduce_add4L_rule, c)
        DFA_PRODUCTION(S1REGL, reduce_add4L_rule, c)
        DFA_PRODUCTION(S3REGL, reduce_add4L_rule, c)
        DFA_PRODUCTION(S4REGL, reduce_add4L_rule, c)
        DFA_PRODUCTION(S7REGL, reduce_add4L_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14106 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 2 && vector_element_basic_type(n->in(2)) == T_LONG
#line 17736 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, reduce_add2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, reduce_add2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, reduce_add2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, reduce_add2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, reduce_add2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, reduce_add2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, reduce_add2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, reduce_add2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, reduce_add2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, reduce_add2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, reduce_add2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, reduce_add2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, reduce_add2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, reduce_add2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, reduce_add2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, reduce_add2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, reduce_add2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, reduce_add2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, reduce_add2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, reduce_add2L_rule, c)
      }
    }
}
void  State::_sub_Op_AddVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 11745 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 17812 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, add8F_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 11645 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 17821 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, add4F_rule, c)
    }
}
void  State::_sub_Op_AddReductionVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14183 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 8 && vector_element_basic_type(n->in(2)) == T_FLOAT
#line 17832 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(REGF, reduce_add8F_rule, c)
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14117 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 4 && vector_element_basic_type(n->in(2)) == T_FLOAT
#line 17842 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, reduce_add4F_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+100) {
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
      }
    }
}
void  State::_sub_Op_AddVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 11755 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 17858 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, add4D_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 11655 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 17867 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, add2D_rule, c)
    }
}
void  State::_sub_Op_AddReductionVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14194 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 4 && vector_element_basic_type(n->in(2)) == T_DOUBLE
#line 17878 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(REGD, reduce_add4D_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14128 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 2 && vector_element_basic_type(n->in(2)) == T_DOUBLE
#line 17888 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, reduce_add2D_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+100) {
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
      }
    }
}
void  State::_sub_Op_SubVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _MULVB_VECY_VECY) &&
        (
#line 12889 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 17904 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_MULVB_VECY_VECY]+100;
        DFA_PRODUCTION(VECY, msub32B_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _MULVB_VECX_VECX) &&
        (
#line 12827 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 17913 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_MULVB_VECX_VECX]+100;
        DFA_PRODUCTION(VECX, msub16B_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _REPLICATEB_IMMIU5_) &&
        (
#line 11877 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 17922 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_REPLICATEB_IMMIU5_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, sub32B_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 11867 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 17933 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, sub32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _REPLICATEB_IMMIU5_) &&
        (
#line 11777 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 17944 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_REPLICATEB_IMMIU5_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, sub16B_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 11767 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 17955 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, sub16B_rule, c)
      }
    }
}
void  State::_sub_Op_SubVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _MULVS_VECY_VECY) &&
        (
#line 12899 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 17968 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_MULVS_VECY_VECY]+100;
        DFA_PRODUCTION(VECY, msub16S_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _MULVS_VECX_VECX) &&
        (
#line 12837 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 17977 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_MULVS_VECX_VECX]+100;
        DFA_PRODUCTION(VECX, msub8S_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _REPLICATES_IMMIU5_) &&
        (
#line 11897 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 17986 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_REPLICATES_IMMIU5_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, sub16S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 11887 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 17997 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, sub16S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _REPLICATES_IMMIU5_) &&
        (
#line 11797 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 18008 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_REPLICATES_IMMIU5_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, sub8S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 11787 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 18019 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, sub8S_rule, c)
      }
    }
}
void  State::_sub_Op_SubVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _MULVI_VECY_VECY) &&
        (
#line 12909 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 18032 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_MULVI_VECY_VECY]+100;
        DFA_PRODUCTION(VECY, msub8I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _MULVI_VECX_VECX) &&
        (
#line 12847 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 18041 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_MULVI_VECX_VECX]+100;
        DFA_PRODUCTION(VECX, msub4I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY];
        DFA_PRODUCTION(_SUBVI_VECY_VECY, _SubVI_vecY_vecY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX];
        DFA_PRODUCTION(_SUBVI_VECX_VECX, _SubVI_vecX_vecX_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _REPLICATEI_IMMIU5_) &&
        (
#line 11917 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 18058 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_REPLICATEI_IMMIU5_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, sub8I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 11907 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 18069 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, sub8I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _REPLICATEI_IMMIU5_) &&
        (
#line 11817 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 18080 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_REPLICATEI_IMMIU5_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, sub4I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 11807 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 18091 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, sub4I_rule, c)
      }
    }
}
void  State::_sub_Op_SubVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _MULVL_VECY_VECY) &&
        (
#line 12919 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 18104 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_MULVL_VECY_VECY]+100;
        DFA_PRODUCTION(VECY, msub4L_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _MULVL_VECX_VECX) &&
        (
#line 12857 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 18113 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_MULVL_VECX_VECX]+100;
        DFA_PRODUCTION(VECX, msub2L_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY];
        DFA_PRODUCTION(_SUBVL_VECY_VECY, _SubVL_vecY_vecY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX];
        DFA_PRODUCTION(_SUBVL_VECX_VECX, _SubVL_vecX_vecX_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _REPLICATEL_IMMLU5_) &&
        (
#line 11937 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 18130 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_REPLICATEL_IMMLU5_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, sub4L_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 11927 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 18141 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, sub4L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _REPLICATEL_IMMLU5_) &&
        (
#line 11837 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 18152 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_REPLICATEL_IMMLU5_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, sub2L_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 11827 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 18163 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, sub2L_rule, c)
      }
    }
}
void  State::_sub_Op_SubVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 11947 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 18176 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, sub8F_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 11847 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 18185 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, sub4F_rule, c)
    }
}
void  State::_sub_Op_SubVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 11957 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 18196 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, sub4D_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 11857 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 18205 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, sub2D_rule, c)
    }
}
void  State::_sub_Op_MulVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY];
        DFA_PRODUCTION(_MULVB_VECY_VECY, _MulVB_vecY_vecY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX];
        DFA_PRODUCTION(_MULVB_VECX_VECX, _MulVB_vecX_vecX_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12028 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 18224 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, mul32B_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 11968 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 18233 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, mul16B_rule, c)
    }
}
void  State::_sub_Op_MulVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY];
        DFA_PRODUCTION(_MULVS_VECY_VECY, _MulVS_vecY_vecY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX];
        DFA_PRODUCTION(_MULVS_VECX_VECX, _MulVS_vecX_vecX_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12038 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 18252 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, mul16S_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 11978 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 18261 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, mul8S_rule, c)
    }
}
void  State::_sub_Op_MulVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY];
        DFA_PRODUCTION(_MULVI_VECY_VECY, _MulVI_vecY_vecY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX];
        DFA_PRODUCTION(_MULVI_VECX_VECX, _MulVI_vecX_vecX_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12048 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 18280 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, mul8I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 11988 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 18289 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, mul4I_rule, c)
    }
}
void  State::_sub_Op_MulReductionVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14295 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 8 && vector_element_basic_type(n->in(2)) == T_INT
#line 18300 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(MREGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MS0REGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MS1REGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MS3REGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MS4REGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MS5REGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MS6REGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MS7REGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MT0REGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MT1REGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MT2REGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MT3REGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MT8REGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MT4REGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MA0REGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MA1REGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MA2REGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MA3REGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MA4REGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MA5REGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MA6REGI, reduce_mul8I_rule, c)
        DFA_PRODUCTION(MA7REGI, reduce_mul8I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14284 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 16 && vector_element_basic_type(n->in(2)) == T_SHORT
#line 18333 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_mul16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_mul16S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14273 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 32 && vector_element_basic_type(n->in(2)) == T_BYTE
#line 18416 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_mul32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_mul32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14229 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 4 && vector_element_basic_type(n->in(2)) == T_INT
#line 18499 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_mul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_mul4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14218 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 8 && vector_element_basic_type(n->in(2)) == T_SHORT
#line 18582 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_mul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_mul8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14207 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 16 && vector_element_basic_type(n->in(2)) == T_BYTE
#line 18665 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_mul16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_mul16B_rule, c)
      }
    }
}
void  State::_sub_Op_MulVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY];
        DFA_PRODUCTION(_MULVL_VECY_VECY, _MulVL_vecY_vecY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX];
        DFA_PRODUCTION(_MULVL_VECX_VECX, _MulVL_vecX_vecX_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12058 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 18758 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, mul4L_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 11998 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 18767 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, mul2L_rule, c)
    }
}
void  State::_sub_Op_MulReductionVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14306 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 4 && vector_element_basic_type(n->in(2)) == T_LONG
#line 18778 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(MREGL, reduce_mul4L_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, reduce_mul4L_rule, c)
        DFA_PRODUCTION(V1REGL, reduce_mul4L_rule, c)
        DFA_PRODUCTION(A0REGL, reduce_mul4L_rule, c)
        DFA_PRODUCTION(A1REGL, reduce_mul4L_rule, c)
        DFA_PRODUCTION(A2REGL, reduce_mul4L_rule, c)
        DFA_PRODUCTION(A3REGL, reduce_mul4L_rule, c)
        DFA_PRODUCTION(T0REGL, reduce_mul4L_rule, c)
        DFA_PRODUCTION(T1REGL, reduce_mul4L_rule, c)
        DFA_PRODUCTION(T3REGL, reduce_mul4L_rule, c)
        DFA_PRODUCTION(T8REGL, reduce_mul4L_rule, c)
        DFA_PRODUCTION(A4REGL, reduce_mul4L_rule, c)
        DFA_PRODUCTION(A5REGL, reduce_mul4L_rule, c)
        DFA_PRODUCTION(A6REGL, reduce_mul4L_rule, c)
        DFA_PRODUCTION(A7REGL, reduce_mul4L_rule, c)
        DFA_PRODUCTION(S0REGL, reduce_mul4L_rule, c)
        DFA_PRODUCTION(S1REGL, reduce_mul4L_rule, c)
        DFA_PRODUCTION(S3REGL, reduce_mul4L_rule, c)
        DFA_PRODUCTION(S4REGL, reduce_mul4L_rule, c)
        DFA_PRODUCTION(S7REGL, reduce_mul4L_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14240 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 2 && vector_element_basic_type(n->in(2)) == T_LONG
#line 18808 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, reduce_mul2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, reduce_mul2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, reduce_mul2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, reduce_mul2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, reduce_mul2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, reduce_mul2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, reduce_mul2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, reduce_mul2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, reduce_mul2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, reduce_mul2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, reduce_mul2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, reduce_mul2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, reduce_mul2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, reduce_mul2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, reduce_mul2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, reduce_mul2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, reduce_mul2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, reduce_mul2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, reduce_mul2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, reduce_mul2L_rule, c)
      }
    }
}
void  State::_sub_Op_MulVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12068 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 18884 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, mul8F_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 12008 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 18893 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, mul4F_rule, c)
    }
}
void  State::_sub_Op_MulReductionVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14317 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 8 && vector_element_basic_type(n->in(2)) == T_FLOAT
#line 18904 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(REGF, reduce_mul8F_rule, c)
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14251 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 4 && vector_element_basic_type(n->in(2)) == T_FLOAT
#line 18914 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, reduce_mul4F_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+100) {
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100)
      }
    }
}
void  State::_sub_Op_MulVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12078 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 18930 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, mul4D_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 12018 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 18939 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, mul2D_rule, c)
    }
}
void  State::_sub_Op_MulReductionVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14328 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 4 && vector_element_basic_type(n->in(2)) == T_DOUBLE
#line 18950 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(REGD, reduce_mul4D_rule, c)
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14262 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 2 && vector_element_basic_type(n->in(2)) == T_DOUBLE
#line 18960 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, reduce_mul2D_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+100) {
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100)
      }
    }
}
void  State::_sub_Op_MulAddVS2VI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13067 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(1)) == 16 && vector_element_basic_type(n->in(1)) == T_SHORT
#line 18976 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, muladd16Sto8I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13053 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(1)) == 8 && vector_element_basic_type(n->in(1)) == T_SHORT
#line 18985 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, muladd8Sto4I_rule, c)
    }
}
void  State::_sub_Op_FmaVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY__NEGVD_VECY_) &&
        (
#line 13040 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 4
#line 18996 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_BINARY_VECY__NEGVD_VECY_]+100;
        DFA_PRODUCTION(VECY, nmsub4D_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGVD_VECY__VECY) &&
        (
#line 13040 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 4
#line 19005 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_BINARY__NEGVD_VECY__VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, nmsub4D_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _BINARY_VECX__NEGVD_VECX_) &&
        (
#line 13016 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 2
#line 19016 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_BINARY_VECX__NEGVD_VECX_]+100;
        DFA_PRODUCTION(VECX, nmsub2D_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGVD_VECX__VECX) &&
        (
#line 13016 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 2
#line 19025 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_BINARY__NEGVD_VECX__VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, nmsub2D_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVD_VECY_) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY__NEGVD_VECY_) &&
        (
#line 12990 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 4
#line 19036 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGVD_VECY_]+_kids[1]->_cost[_BINARY_VECY__NEGVD_VECY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, nmadd4D_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVD_VECY_) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGVD_VECY__VECY) &&
        (
#line 12990 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 4
#line 19047 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGVD_VECY_]+_kids[1]->_cost[_BINARY__NEGVD_VECY__VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, nmadd4D_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVD_VECX_) && STATE__VALID_CHILD(_kids[1], _BINARY_VECX__NEGVD_VECX_) &&
        (
#line 12966 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 2
#line 19058 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGVD_VECX_]+_kids[1]->_cost[_BINARY_VECX__NEGVD_VECX_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, nmadd2D_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVD_VECX_) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGVD_VECX__VECX) &&
        (
#line 12966 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 2
#line 19069 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGVD_VECX_]+_kids[1]->_cost[_BINARY__NEGVD_VECX__VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, nmadd2D_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVD_VECY_) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY_VECY) &&
        (
#line 12941 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 4
#line 19080 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGVD_VECY_]+_kids[1]->_cost[_BINARY_VECY_VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, msub4D_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVD_VECX_) && STATE__VALID_CHILD(_kids[1], _BINARY_VECX_VECX) &&
        (
#line 12879 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 2
#line 19091 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGVD_VECX_]+_kids[1]->_cost[_BINARY_VECX_VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, msub2D_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY_VECY) &&
        (
#line 12815 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 4
#line 19102 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_BINARY_VECY_VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, madd4D_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _BINARY_VECX_VECX) &&
        (
#line 12753 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 2
#line 19113 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_BINARY_VECX_VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, madd2D_rule, c)
      }
    }
}
void  State::_sub_Op_FmaVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY__NEGVF_VECY_) &&
        (
#line 13028 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 8
#line 19126 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_BINARY_VECY__NEGVF_VECY_]+100;
        DFA_PRODUCTION(VECY, nmsub8F_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGVF_VECY__VECY) &&
        (
#line 13028 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 8
#line 19135 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_BINARY__NEGVF_VECY__VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, nmsub8F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _BINARY_VECX__NEGVF_VECX_) &&
        (
#line 13004 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 4
#line 19146 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_BINARY_VECX__NEGVF_VECX_]+100;
        DFA_PRODUCTION(VECX, nmsub4F_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGVF_VECX__VECX) &&
        (
#line 13004 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 4
#line 19155 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_BINARY__NEGVF_VECX__VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, nmsub4F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVF_VECY_) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY__NEGVF_VECY_) &&
        (
#line 12978 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 8
#line 19166 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGVF_VECY_]+_kids[1]->_cost[_BINARY_VECY__NEGVF_VECY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, nmadd8F_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVF_VECY_) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGVF_VECY__VECY) &&
        (
#line 12978 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 8
#line 19177 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGVF_VECY_]+_kids[1]->_cost[_BINARY__NEGVF_VECY__VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, nmadd8F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVF_VECX_) && STATE__VALID_CHILD(_kids[1], _BINARY_VECX__NEGVF_VECX_) &&
        (
#line 12954 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 4
#line 19188 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGVF_VECX_]+_kids[1]->_cost[_BINARY_VECX__NEGVF_VECX_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, nmadd4F_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVF_VECX_) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGVF_VECX__VECX) &&
        (
#line 12954 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 4
#line 19199 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGVF_VECX_]+_kids[1]->_cost[_BINARY__NEGVF_VECX__VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, nmadd4F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVF_VECY_) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY_VECY) &&
        (
#line 12930 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 8
#line 19210 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGVF_VECY_]+_kids[1]->_cost[_BINARY_VECY_VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, msub8F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVF_VECX_) && STATE__VALID_CHILD(_kids[1], _BINARY_VECX_VECX) &&
        (
#line 12868 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 4
#line 19221 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGVF_VECX_]+_kids[1]->_cost[_BINARY_VECX_VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, msub4F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY_VECY) &&
        (
#line 12804 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 8
#line 19232 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_BINARY_VECY_VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, madd8F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _BINARY_VECX_VECX) &&
        (
#line 12742 "src/hotspot/cpu/loongarch/loongarch_64.ad"
UseFMA && vector_length(n) == 4
#line 19243 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_BINARY_VECX_VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, madd4F_rule, c)
      }
    }
}
void  State::_sub_Op_DivVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12109 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 19256 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, div8F_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 12089 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 19265 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, div4F_rule, c)
    }
}
void  State::_sub_Op_DivVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12119 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 19276 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, div4D_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 12099 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 19285 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, div2D_rule, c)
    }
}
void  State::_sub_Op_AbsVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 12199 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 19296 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, abs32B_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 12131 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 19305 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, abs16B_rule, c)
    }
}
void  State::_sub_Op_AbsVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 12211 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 19316 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, abs16S_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 12143 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 19325 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, abs8S_rule, c)
    }
}
void  State::_sub_Op_AbsVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _SUBVI_VECY_VECY) &&
        (
#line 12289 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 19336 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_SUBVI_VECY_VECY]+100;
        DFA_PRODUCTION(VECY, absd8I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBVI_VECX_VECX) &&
        (
#line 12269 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 19345 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_SUBVI_VECX_VECX]+100;
        DFA_PRODUCTION(VECX, absd4I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 12223 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 19354 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, abs8I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 12155 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 19365 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, abs4I_rule, c)
      }
    }
}
void  State::_sub_Op_AbsVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _SUBVL_VECY_VECY) &&
        (
#line 12299 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 19378 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_SUBVL_VECY_VECY]+100;
        DFA_PRODUCTION(VECY, absd4L_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBVL_VECX_VECX) &&
        (
#line 12279 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 19387 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_SUBVL_VECX_VECX]+100;
        DFA_PRODUCTION(VECX, absd2L_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 12235 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 19396 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, abs4L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 12167 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 19407 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, abs2L_rule, c)
      }
    }
}
void  State::_sub_Op_AbsVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 12247 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 19420 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, abs8F_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 12179 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 19429 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, abs4F_rule, c)
    }
}
void  State::_sub_Op_AbsVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 12257 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 19440 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, abs4D_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 12189 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 19449 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, abs2D_rule, c)
    }
}
void  State::_sub_Op_NegVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 12626 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 19460 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, neg8I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 12595 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 19469 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, neg4I_rule, c)
    }
}
void  State::_sub_Op_NegVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) ) {
      unsigned int c = _kids[0]->_cost[VECY];
        DFA_PRODUCTION(_NEGVF_VECY_, _NegVF_vecY__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) ) {
      unsigned int c = _kids[0]->_cost[VECX];
        DFA_PRODUCTION(_NEGVF_VECX_, _NegVF_vecX__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 12637 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 19488 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, neg8F_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 12606 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 19497 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, neg4F_rule, c)
    }
}
void  State::_sub_Op_NegVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) ) {
      unsigned int c = _kids[0]->_cost[VECY];
        DFA_PRODUCTION(_NEGVD_VECY_, _NegVD_vecY__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) ) {
      unsigned int c = _kids[0]->_cost[VECX];
        DFA_PRODUCTION(_NEGVD_VECX_, _NegVD_vecX__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 12647 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 19516 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, neg4D_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 12616 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 19525 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, neg2D_rule, c)
    }
}
void  State::_sub_Op_SqrtVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 12689 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 19536 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, sqrt4D_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 12669 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 19545 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, sqrt2D_rule, c)
    }
}
void  State::_sub_Op_SqrtVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 12679 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 19556 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, sqrt8F_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 12659 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 19565 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, sqrt4F_rule, c)
    }
}
void  State::_sub_Op_LShiftCntV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IMMI];
        DFA_PRODUCTION(_LSHIFTCNTV_IMMI_, _LShiftCntV_immI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) &&
        (
#line 13094 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 19580 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
        DFA_PRODUCTION(VECY, shiftcntY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) &&
        (
#line 13083 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 19589 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
        DFA_PRODUCTION(VECX, shiftcntX_rule, c)
    }
}
void  State::_sub_Op_RShiftCntV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IMMI];
        DFA_PRODUCTION(_RSHIFTCNTV_IMMI_, _RShiftCntV_immI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) &&
        (
#line 13094 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 19604 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
        DFA_PRODUCTION(VECY, shiftcntY_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) &&
        (
#line 13083 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 19613 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
        DFA_PRODUCTION(VECX, shiftcntX_0_rule, c)
    }
}
void  State::_sub_Op_LShiftVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LSHIFTCNTV_IMMI_) &&
        (
#line 13214 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 19624 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECY, sll32B_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13201 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 19633 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, sll32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LSHIFTCNTV_IMMI_) &&
        (
#line 13120 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 19644 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECX, sll16B_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13107 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 19653 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, sll16B_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LSHIFTCNTV_IMMI_) &&
        (
#line 13241 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 19666 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECY, sll16S_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13228 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 19675 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, sll16S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LSHIFTCNTV_IMMI_) &&
        (
#line 13147 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 19686 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECX, sll8S_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13134 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 19695 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, sll8S_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LSHIFTCNTV_IMMI_) &&
        (
#line 13265 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 19708 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECY, sll8I_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13255 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 19717 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, sll8I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LSHIFTCNTV_IMMI_) &&
        (
#line 13171 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 19728 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECX, sll4I_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13161 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 19737 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, sll4I_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LSHIFTCNTV_IMMI_) &&
        (
#line 13285 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 19750 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECY, sll4L_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13275 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 19759 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, sll4L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LSHIFTCNTV_IMMI_) &&
        (
#line 13191 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 19770 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECX, sll2L_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13181 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 19779 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, sll2L_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) &&
        (
#line 13594 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 19792 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECY, sra32B_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13581 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 19801 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, sra32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) &&
        (
#line 13500 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 19812 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECX, sra16B_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13487 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 19821 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, sra16B_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) &&
        (
#line 13621 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 19834 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECY, sra16S_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13608 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 19843 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, sra16S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) &&
        (
#line 13527 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 19854 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECX, sra8S_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13514 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 19863 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, sra8S_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) &&
        (
#line 13645 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 19876 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECY, sra8I_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13635 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 19885 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, sra8I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) &&
        (
#line 13551 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 19896 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECX, sra4I_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13541 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 19905 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, sra4I_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) &&
        (
#line 13665 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 19918 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECY, sra4L_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13655 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 19927 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, sra4L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) &&
        (
#line 13571 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 19938 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECX, sra2L_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13561 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 19947 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, sra2L_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) &&
        (
#line 13404 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 19960 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECY, srl32B_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13391 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 19969 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, srl32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) &&
        (
#line 13310 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 19980 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECX, srl16B_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13297 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 19989 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, srl16B_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) &&
        (
#line 13431 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 20002 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECY, srl16S_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13418 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 20011 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, srl16S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) &&
        (
#line 13337 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 20022 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECX, srl8S_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13324 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 20031 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, srl8S_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) &&
        (
#line 13455 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 20044 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECY, srl8I_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13445 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 20053 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, srl8I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) &&
        (
#line 13361 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 20064 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECX, srl4I_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13351 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 20073 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, srl4I_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) &&
        (
#line 13475 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 20086 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECY, srl4L_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13465 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 20095 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, srl4L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) &&
        (
#line 13381 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 20106 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_]+100;
        DFA_PRODUCTION(VECX, srl2L_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13371 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 20115 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, srl2L_rule, c)
      }
    }
}
void  State::_sub_Op_AndV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _XORV__REPLICATEI_IMMI_M1__VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14033 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 20128 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV__REPLICATEI_IMMI_M1__VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, andnV32_10_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _XORV__REPLICATEI_IMMI_M1__VECY) &&
        (
#line 14033 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 20137 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_XORV__REPLICATEI_IMMI_M1__VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, andnV32_8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV_VECY__REPLICATEI_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14033 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 20148 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV_VECY__REPLICATEI_IMMI_M1_]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, andnV32_9_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _XORV_VECY__REPLICATEI_IMMI_M1_) &&
        (
#line 14033 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 20159 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_XORV_VECY__REPLICATEI_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, andnV32_7_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV__REPLICATES_IMMI_M1__VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14033 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 20170 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV__REPLICATES_IMMI_M1__VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, andnV32_6_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _XORV__REPLICATES_IMMI_M1__VECY) &&
        (
#line 14033 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 20181 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_XORV__REPLICATES_IMMI_M1__VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, andnV32_4_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV_VECY__REPLICATES_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14033 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 20192 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV_VECY__REPLICATES_IMMI_M1_]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, andnV32_5_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _XORV_VECY__REPLICATES_IMMI_M1_) &&
        (
#line 14033 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 20203 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_XORV_VECY__REPLICATES_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, andnV32_3_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV__REPLICATEB_IMMI_M1__VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14033 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 20214 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV__REPLICATEB_IMMI_M1__VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, andnV32_2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _XORV__REPLICATEB_IMMI_M1__VECY) &&
        (
#line 14033 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 20225 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_XORV__REPLICATEB_IMMI_M1__VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, andnV32_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV_VECY__REPLICATEB_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14033 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 20236 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV_VECY__REPLICATEB_IMMI_M1_]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, andnV32_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _XORV_VECY__REPLICATEB_IMMI_M1_) &&
        (
#line 14033 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 20247 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_XORV_VECY__REPLICATEB_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, andnV32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV__REPLICATEI_IMMI_M1__VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14021 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 20258 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV__REPLICATEI_IMMI_M1__VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, andnV16_10_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _XORV__REPLICATEI_IMMI_M1__VECX) &&
        (
#line 14021 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 20267 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_XORV__REPLICATEI_IMMI_M1__VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, andnV16_8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV_VECX__REPLICATEI_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14021 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 20278 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV_VECX__REPLICATEI_IMMI_M1_]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, andnV16_9_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _XORV_VECX__REPLICATEI_IMMI_M1_) &&
        (
#line 14021 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 20289 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_XORV_VECX__REPLICATEI_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, andnV16_7_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV__REPLICATES_IMMI_M1__VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14021 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 20300 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV__REPLICATES_IMMI_M1__VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, andnV16_6_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _XORV__REPLICATES_IMMI_M1__VECX) &&
        (
#line 14021 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 20311 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_XORV__REPLICATES_IMMI_M1__VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, andnV16_4_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV_VECX__REPLICATES_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14021 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 20322 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV_VECX__REPLICATES_IMMI_M1_]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, andnV16_5_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _XORV_VECX__REPLICATES_IMMI_M1_) &&
        (
#line 14021 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 20333 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_XORV_VECX__REPLICATES_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, andnV16_3_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV__REPLICATEB_IMMI_M1__VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14021 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 20344 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV__REPLICATEB_IMMI_M1__VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, andnV16_2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _XORV__REPLICATEB_IMMI_M1__VECX) &&
        (
#line 14021 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 20355 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_XORV__REPLICATEB_IMMI_M1__VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, andnV16_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV_VECX__REPLICATEB_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14021 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 20366 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV_VECX__REPLICATEB_IMMI_M1_]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, andnV16_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _XORV_VECX__REPLICATEB_IMMI_M1_) &&
        (
#line 14021 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 20377 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_XORV_VECX__REPLICATEB_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, andnV16_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEB_IMMIU8_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13879 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 20388 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEB_IMMIU8_]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, and32B_imm_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _REPLICATEB_IMMIU8_) &&
        (
#line 13879 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 20399 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_REPLICATEB_IMMIU8_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, and32B_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13869 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 20410 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, andV32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEB_IMMIU8_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13859 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 20421 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEB_IMMIU8_]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, and16B_imm_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _REPLICATEB_IMMIU8_) &&
        (
#line 13859 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 20432 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_REPLICATEB_IMMIU8_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, and16B_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13849 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 20443 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, andV16_rule, c)
      }
    }
}
void  State::_sub_Op_AndReductionV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14598 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 4 && vector_element_basic_type(n->in(2)) == T_LONG
#line 20456 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(MREGL, reduce_and4L_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, reduce_and4L_rule, c)
        DFA_PRODUCTION(V1REGL, reduce_and4L_rule, c)
        DFA_PRODUCTION(A0REGL, reduce_and4L_rule, c)
        DFA_PRODUCTION(A1REGL, reduce_and4L_rule, c)
        DFA_PRODUCTION(A2REGL, reduce_and4L_rule, c)
        DFA_PRODUCTION(A3REGL, reduce_and4L_rule, c)
        DFA_PRODUCTION(T0REGL, reduce_and4L_rule, c)
        DFA_PRODUCTION(T1REGL, reduce_and4L_rule, c)
        DFA_PRODUCTION(T3REGL, reduce_and4L_rule, c)
        DFA_PRODUCTION(T8REGL, reduce_and4L_rule, c)
        DFA_PRODUCTION(A4REGL, reduce_and4L_rule, c)
        DFA_PRODUCTION(A5REGL, reduce_and4L_rule, c)
        DFA_PRODUCTION(A6REGL, reduce_and4L_rule, c)
        DFA_PRODUCTION(A7REGL, reduce_and4L_rule, c)
        DFA_PRODUCTION(S0REGL, reduce_and4L_rule, c)
        DFA_PRODUCTION(S1REGL, reduce_and4L_rule, c)
        DFA_PRODUCTION(S3REGL, reduce_and4L_rule, c)
        DFA_PRODUCTION(S4REGL, reduce_and4L_rule, c)
        DFA_PRODUCTION(S7REGL, reduce_and4L_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14587 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 8 && vector_element_basic_type(n->in(2)) == T_INT
#line 20486 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(MREGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MS0REGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MS1REGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MS3REGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MS4REGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MS5REGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MS6REGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MS7REGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MT0REGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MT1REGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MT2REGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MT3REGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MT8REGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MT4REGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MA0REGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MA1REGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MA2REGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MA3REGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MA4REGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MA5REGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MA6REGI, reduce_and8I_rule, c)
        DFA_PRODUCTION(MA7REGI, reduce_and8I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14576 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 16 && vector_element_basic_type(n->in(2)) == T_SHORT
#line 20519 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_and16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_and16S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14565 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 32 && vector_element_basic_type(n->in(2)) == T_BYTE
#line 20602 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_and32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_and32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14554 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 2 && vector_element_basic_type(n->in(2)) == T_LONG
#line 20685 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, reduce_and2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, reduce_and2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, reduce_and2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, reduce_and2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, reduce_and2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, reduce_and2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, reduce_and2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, reduce_and2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, reduce_and2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, reduce_and2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, reduce_and2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, reduce_and2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, reduce_and2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, reduce_and2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, reduce_and2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, reduce_and2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, reduce_and2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, reduce_and2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, reduce_and2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, reduce_and2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14543 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 4 && vector_element_basic_type(n->in(2)) == T_INT
#line 20759 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_and4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_and4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14532 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 8 && vector_element_basic_type(n->in(2)) == T_SHORT
#line 20842 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_and8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_and8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14521 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 16 && vector_element_basic_type(n->in(2)) == T_BYTE
#line 20925 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_and16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_and16B_rule, c)
      }
    }
}
void  State::_sub_Op_OrV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _XORV__REPLICATEI_IMMI_M1__VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14059 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 21010 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV__REPLICATEI_IMMI_M1__VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, ornV32_10_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _XORV__REPLICATEI_IMMI_M1__VECY) &&
        (
#line 14059 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 21019 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_XORV__REPLICATEI_IMMI_M1__VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, ornV32_8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV_VECY__REPLICATEI_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14059 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 21030 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV_VECY__REPLICATEI_IMMI_M1_]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, ornV32_9_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _XORV_VECY__REPLICATEI_IMMI_M1_) &&
        (
#line 14059 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 21041 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_XORV_VECY__REPLICATEI_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, ornV32_7_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV__REPLICATES_IMMI_M1__VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14059 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 21052 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV__REPLICATES_IMMI_M1__VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, ornV32_6_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _XORV__REPLICATES_IMMI_M1__VECY) &&
        (
#line 14059 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 21063 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_XORV__REPLICATES_IMMI_M1__VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, ornV32_4_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV_VECY__REPLICATES_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14059 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 21074 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV_VECY__REPLICATES_IMMI_M1_]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, ornV32_5_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _XORV_VECY__REPLICATES_IMMI_M1_) &&
        (
#line 14059 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 21085 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_XORV_VECY__REPLICATES_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, ornV32_3_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV__REPLICATEB_IMMI_M1__VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14059 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 21096 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV__REPLICATEB_IMMI_M1__VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, ornV32_2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _XORV__REPLICATEB_IMMI_M1__VECY) &&
        (
#line 14059 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 21107 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_XORV__REPLICATEB_IMMI_M1__VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, ornV32_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV_VECY__REPLICATEB_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14059 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 21118 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV_VECY__REPLICATEB_IMMI_M1_]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, ornV32_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _XORV_VECY__REPLICATEB_IMMI_M1_) &&
        (
#line 14059 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 21129 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_XORV_VECY__REPLICATEB_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, ornV32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV__REPLICATEI_IMMI_M1__VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14047 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 21140 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV__REPLICATEI_IMMI_M1__VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, ornV16_10_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _XORV__REPLICATEI_IMMI_M1__VECX) &&
        (
#line 14047 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 21149 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_XORV__REPLICATEI_IMMI_M1__VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, ornV16_8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV_VECX__REPLICATEI_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14047 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 21160 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV_VECX__REPLICATEI_IMMI_M1_]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, ornV16_9_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _XORV_VECX__REPLICATEI_IMMI_M1_) &&
        (
#line 14047 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 21171 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_XORV_VECX__REPLICATEI_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, ornV16_7_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV__REPLICATES_IMMI_M1__VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14047 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 21182 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV__REPLICATES_IMMI_M1__VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, ornV16_6_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _XORV__REPLICATES_IMMI_M1__VECX) &&
        (
#line 14047 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 21193 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_XORV__REPLICATES_IMMI_M1__VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, ornV16_4_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV_VECX__REPLICATES_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14047 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 21204 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV_VECX__REPLICATES_IMMI_M1_]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, ornV16_5_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _XORV_VECX__REPLICATES_IMMI_M1_) &&
        (
#line 14047 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 21215 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_XORV_VECX__REPLICATES_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, ornV16_3_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV__REPLICATEB_IMMI_M1__VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14047 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 21226 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV__REPLICATEB_IMMI_M1__VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, ornV16_2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _XORV__REPLICATEB_IMMI_M1__VECX) &&
        (
#line 14047 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 21237 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_XORV__REPLICATEB_IMMI_M1__VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, ornV16_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORV_VECX__REPLICATEB_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14047 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 21248 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORV_VECX__REPLICATEB_IMMI_M1_]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, ornV16_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _XORV_VECX__REPLICATEB_IMMI_M1_) &&
        (
#line 14047 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 21259 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_XORV_VECX__REPLICATEB_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, ornV16_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEB_IMMIU8_) && STATE__VALID_CHILD(_kids[1], VECY) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEB_IMMIU8_]+_kids[1]->_cost[VECY];
        DFA_PRODUCTION(_ORV__REPLICATEB_IMMIU8__VECY, _OrV__ReplicateB_immIU8__vecY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _REPLICATEB_IMMIU8_) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_REPLICATEB_IMMIU8_];
        DFA_PRODUCTION(_ORV_VECY__REPLICATEB_IMMIU8_, _OrV_vecY__ReplicateB_immIU8__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY];
        DFA_PRODUCTION(_ORV_VECY_VECY, _OrV_vecY_vecY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEB_IMMIU8_) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEB_IMMIU8_]+_kids[1]->_cost[VECX];
        DFA_PRODUCTION(_ORV__REPLICATEB_IMMIU8__VECX, _OrV__ReplicateB_immIU8__vecX_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _REPLICATEB_IMMIU8_) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_REPLICATEB_IMMIU8_];
        DFA_PRODUCTION(_ORV_VECX__REPLICATEB_IMMIU8_, _OrV_vecX__ReplicateB_immIU8__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX];
        DFA_PRODUCTION(_ORV_VECX_VECX, _OrV_vecX_vecX_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEB_IMMIU8_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13921 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 21294 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEB_IMMIU8_]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, or32B_imm_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _REPLICATEB_IMMIU8_) &&
        (
#line 13921 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 21305 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_REPLICATEB_IMMIU8_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, or32B_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13911 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 21316 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, orV32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEB_IMMIU8_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13901 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 21327 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEB_IMMIU8_]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, or16B_imm_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _REPLICATEB_IMMIU8_) &&
        (
#line 13901 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 21338 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_REPLICATEB_IMMIU8_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, or16B_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13891 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 21349 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, orV16_rule, c)
      }
    }
}
void  State::_sub_Op_OrReductionV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14688 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 4 && vector_element_basic_type(n->in(2)) == T_LONG
#line 21362 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(MREGL, reduce_or4L_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, reduce_or4L_rule, c)
        DFA_PRODUCTION(V1REGL, reduce_or4L_rule, c)
        DFA_PRODUCTION(A0REGL, reduce_or4L_rule, c)
        DFA_PRODUCTION(A1REGL, reduce_or4L_rule, c)
        DFA_PRODUCTION(A2REGL, reduce_or4L_rule, c)
        DFA_PRODUCTION(A3REGL, reduce_or4L_rule, c)
        DFA_PRODUCTION(T0REGL, reduce_or4L_rule, c)
        DFA_PRODUCTION(T1REGL, reduce_or4L_rule, c)
        DFA_PRODUCTION(T3REGL, reduce_or4L_rule, c)
        DFA_PRODUCTION(T8REGL, reduce_or4L_rule, c)
        DFA_PRODUCTION(A4REGL, reduce_or4L_rule, c)
        DFA_PRODUCTION(A5REGL, reduce_or4L_rule, c)
        DFA_PRODUCTION(A6REGL, reduce_or4L_rule, c)
        DFA_PRODUCTION(A7REGL, reduce_or4L_rule, c)
        DFA_PRODUCTION(S0REGL, reduce_or4L_rule, c)
        DFA_PRODUCTION(S1REGL, reduce_or4L_rule, c)
        DFA_PRODUCTION(S3REGL, reduce_or4L_rule, c)
        DFA_PRODUCTION(S4REGL, reduce_or4L_rule, c)
        DFA_PRODUCTION(S7REGL, reduce_or4L_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14677 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 8 && vector_element_basic_type(n->in(2)) == T_INT
#line 21392 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(MREGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MS0REGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MS1REGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MS3REGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MS4REGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MS5REGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MS6REGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MS7REGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MT0REGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MT1REGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MT2REGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MT3REGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MT8REGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MT4REGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MA0REGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MA1REGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MA2REGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MA3REGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MA4REGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MA5REGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MA6REGI, reduce_or8I_rule, c)
        DFA_PRODUCTION(MA7REGI, reduce_or8I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14666 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 16 && vector_element_basic_type(n->in(2)) == T_SHORT
#line 21425 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_or16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_or16S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14655 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 32 && vector_element_basic_type(n->in(2)) == T_BYTE
#line 21508 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_or32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_or32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14644 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 2 && vector_element_basic_type(n->in(2)) == T_LONG
#line 21591 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, reduce_or2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, reduce_or2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, reduce_or2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, reduce_or2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, reduce_or2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, reduce_or2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, reduce_or2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, reduce_or2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, reduce_or2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, reduce_or2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, reduce_or2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, reduce_or2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, reduce_or2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, reduce_or2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, reduce_or2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, reduce_or2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, reduce_or2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, reduce_or2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, reduce_or2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, reduce_or2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14633 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 4 && vector_element_basic_type(n->in(2)) == T_INT
#line 21665 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_or4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_or4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14622 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 8 && vector_element_basic_type(n->in(2)) == T_SHORT
#line 21748 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_or8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_or8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14611 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 16 && vector_element_basic_type(n->in(2)) == T_BYTE
#line 21831 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_or16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_or16B_rule, c)
      }
    }
}
void  State::_sub_Op_XorV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEI_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], VECY) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEI_IMMI_M1_]+_kids[1]->_cost[VECY];
        DFA_PRODUCTION(_XORV__REPLICATEI_IMMI_M1__VECY, _XorV__ReplicateI_immI_M1__vecY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _REPLICATEI_IMMI_M1_) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_REPLICATEI_IMMI_M1_];
        DFA_PRODUCTION(_XORV_VECY__REPLICATEI_IMMI_M1_, _XorV_vecY__ReplicateI_immI_M1__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATES_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], VECY) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATES_IMMI_M1_]+_kids[1]->_cost[VECY];
        DFA_PRODUCTION(_XORV__REPLICATES_IMMI_M1__VECY, _XorV__ReplicateS_immI_M1__vecY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _REPLICATES_IMMI_M1_) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_REPLICATES_IMMI_M1_];
        DFA_PRODUCTION(_XORV_VECY__REPLICATES_IMMI_M1_, _XorV_vecY__ReplicateS_immI_M1__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEB_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], VECY) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEB_IMMI_M1_]+_kids[1]->_cost[VECY];
        DFA_PRODUCTION(_XORV__REPLICATEB_IMMI_M1__VECY, _XorV__ReplicateB_immI_M1__vecY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _REPLICATEB_IMMI_M1_) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_REPLICATEB_IMMI_M1_];
        DFA_PRODUCTION(_XORV_VECY__REPLICATEB_IMMI_M1_, _XorV_vecY__ReplicateB_immI_M1__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEI_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEI_IMMI_M1_]+_kids[1]->_cost[VECX];
        DFA_PRODUCTION(_XORV__REPLICATEI_IMMI_M1__VECX, _XorV__ReplicateI_immI_M1__vecX_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _REPLICATEI_IMMI_M1_) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_REPLICATEI_IMMI_M1_];
        DFA_PRODUCTION(_XORV_VECX__REPLICATEI_IMMI_M1_, _XorV_vecX__ReplicateI_immI_M1__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATES_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATES_IMMI_M1_]+_kids[1]->_cost[VECX];
        DFA_PRODUCTION(_XORV__REPLICATES_IMMI_M1__VECX, _XorV__ReplicateS_immI_M1__vecX_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _REPLICATES_IMMI_M1_) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_REPLICATES_IMMI_M1_];
        DFA_PRODUCTION(_XORV_VECX__REPLICATES_IMMI_M1_, _XorV_vecX__ReplicateS_immI_M1__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEB_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEB_IMMI_M1_]+_kids[1]->_cost[VECX];
        DFA_PRODUCTION(_XORV__REPLICATEB_IMMI_M1__VECX, _XorV__ReplicateB_immI_M1__vecX_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _REPLICATEB_IMMI_M1_) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_REPLICATEB_IMMI_M1_];
        DFA_PRODUCTION(_XORV_VECX__REPLICATEB_IMMI_M1_, _XorV_vecX__ReplicateB_immI_M1__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEB_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], _ORV__REPLICATEB_IMMIU8__VECY) &&
        (
#line 14009 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 21964 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEB_IMMI_M1_]+_kids[1]->_cost[_ORV__REPLICATEB_IMMIU8__VECY]+100;
        DFA_PRODUCTION(VECY, nor32B_imm_2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ORV__REPLICATEB_IMMIU8__VECY) && STATE__VALID_CHILD(_kids[1], _REPLICATEB_IMMI_M1_) &&
        (
#line 14009 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 21973 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ORV__REPLICATEB_IMMIU8__VECY]+_kids[1]->_cost[_REPLICATEB_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, nor32B_imm_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEB_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], _ORV_VECY__REPLICATEB_IMMIU8_) &&
        (
#line 14009 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 21984 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEB_IMMI_M1_]+_kids[1]->_cost[_ORV_VECY__REPLICATEB_IMMIU8_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, nor32B_imm_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ORV_VECY__REPLICATEB_IMMIU8_) && STATE__VALID_CHILD(_kids[1], _REPLICATEB_IMMI_M1_) &&
        (
#line 14009 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 21995 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ORV_VECY__REPLICATEB_IMMIU8_]+_kids[1]->_cost[_REPLICATEB_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, nor32B_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEI_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], _ORV_VECY_VECY) &&
        (
#line 13997 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 22006 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEI_IMMI_M1_]+_kids[1]->_cost[_ORV_VECY_VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, norV32_4_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ORV_VECY_VECY) && STATE__VALID_CHILD(_kids[1], _REPLICATEI_IMMI_M1_) &&
        (
#line 13997 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 22017 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ORV_VECY_VECY]+_kids[1]->_cost[_REPLICATEI_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, norV32_3_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATES_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], _ORV_VECY_VECY) &&
        (
#line 13997 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 22028 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATES_IMMI_M1_]+_kids[1]->_cost[_ORV_VECY_VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, norV32_2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ORV_VECY_VECY) && STATE__VALID_CHILD(_kids[1], _REPLICATES_IMMI_M1_) &&
        (
#line 13997 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 22039 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ORV_VECY_VECY]+_kids[1]->_cost[_REPLICATES_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, norV32_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEB_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], _ORV_VECY_VECY) &&
        (
#line 13997 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 22050 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEB_IMMI_M1_]+_kids[1]->_cost[_ORV_VECY_VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, norV32_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ORV_VECY_VECY) && STATE__VALID_CHILD(_kids[1], _REPLICATEB_IMMI_M1_) &&
        (
#line 13997 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 22061 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ORV_VECY_VECY]+_kids[1]->_cost[_REPLICATEB_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, norV32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEB_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], _ORV__REPLICATEB_IMMIU8__VECX) &&
        (
#line 13987 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 22072 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEB_IMMI_M1_]+_kids[1]->_cost[_ORV__REPLICATEB_IMMIU8__VECX]+100;
        DFA_PRODUCTION(VECX, nor16B_imm_2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ORV__REPLICATEB_IMMIU8__VECX) && STATE__VALID_CHILD(_kids[1], _REPLICATEB_IMMI_M1_) &&
        (
#line 13987 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 22081 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ORV__REPLICATEB_IMMIU8__VECX]+_kids[1]->_cost[_REPLICATEB_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, nor16B_imm_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEB_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], _ORV_VECX__REPLICATEB_IMMIU8_) &&
        (
#line 13987 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 22092 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEB_IMMI_M1_]+_kids[1]->_cost[_ORV_VECX__REPLICATEB_IMMIU8_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, nor16B_imm_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ORV_VECX__REPLICATEB_IMMIU8_) && STATE__VALID_CHILD(_kids[1], _REPLICATEB_IMMI_M1_) &&
        (
#line 13987 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 22103 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ORV_VECX__REPLICATEB_IMMIU8_]+_kids[1]->_cost[_REPLICATEB_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, nor16B_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEI_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], _ORV_VECX_VECX) &&
        (
#line 13975 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 22114 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEI_IMMI_M1_]+_kids[1]->_cost[_ORV_VECX_VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, norV16_4_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ORV_VECX_VECX) && STATE__VALID_CHILD(_kids[1], _REPLICATEI_IMMI_M1_) &&
        (
#line 13975 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 22125 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ORV_VECX_VECX]+_kids[1]->_cost[_REPLICATEI_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, norV16_3_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATES_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], _ORV_VECX_VECX) &&
        (
#line 13975 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 22136 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATES_IMMI_M1_]+_kids[1]->_cost[_ORV_VECX_VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, norV16_2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ORV_VECX_VECX) && STATE__VALID_CHILD(_kids[1], _REPLICATES_IMMI_M1_) &&
        (
#line 13975 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 22147 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ORV_VECX_VECX]+_kids[1]->_cost[_REPLICATES_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, norV16_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEB_IMMI_M1_) && STATE__VALID_CHILD(_kids[1], _ORV_VECX_VECX) &&
        (
#line 13975 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 22158 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEB_IMMI_M1_]+_kids[1]->_cost[_ORV_VECX_VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, norV16_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ORV_VECX_VECX) && STATE__VALID_CHILD(_kids[1], _REPLICATEB_IMMI_M1_) &&
        (
#line 13975 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 22169 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ORV_VECX_VECX]+_kids[1]->_cost[_REPLICATEB_IMMI_M1_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, norV16_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEB_IMMIU8_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13963 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 22180 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEB_IMMIU8_]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, xor32B_imm_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _REPLICATEB_IMMIU8_) &&
        (
#line 13963 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 22191 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_REPLICATEB_IMMIU8_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, xor32B_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 13953 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 22202 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, xorV32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _REPLICATEB_IMMIU8_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13943 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 22213 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_REPLICATEB_IMMIU8_]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, xor16B_imm_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _REPLICATEB_IMMIU8_) &&
        (
#line 13943 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 22224 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_REPLICATEB_IMMIU8_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, xor16B_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 13933 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 22235 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, xorV16_rule, c)
      }
    }
}
void  State::_sub_Op_XorReductionV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14778 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 4 && vector_element_basic_type(n->in(2)) == T_LONG
#line 22248 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(MREGL, reduce_xor4L_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, reduce_xor4L_rule, c)
        DFA_PRODUCTION(V1REGL, reduce_xor4L_rule, c)
        DFA_PRODUCTION(A0REGL, reduce_xor4L_rule, c)
        DFA_PRODUCTION(A1REGL, reduce_xor4L_rule, c)
        DFA_PRODUCTION(A2REGL, reduce_xor4L_rule, c)
        DFA_PRODUCTION(A3REGL, reduce_xor4L_rule, c)
        DFA_PRODUCTION(T0REGL, reduce_xor4L_rule, c)
        DFA_PRODUCTION(T1REGL, reduce_xor4L_rule, c)
        DFA_PRODUCTION(T3REGL, reduce_xor4L_rule, c)
        DFA_PRODUCTION(T8REGL, reduce_xor4L_rule, c)
        DFA_PRODUCTION(A4REGL, reduce_xor4L_rule, c)
        DFA_PRODUCTION(A5REGL, reduce_xor4L_rule, c)
        DFA_PRODUCTION(A6REGL, reduce_xor4L_rule, c)
        DFA_PRODUCTION(A7REGL, reduce_xor4L_rule, c)
        DFA_PRODUCTION(S0REGL, reduce_xor4L_rule, c)
        DFA_PRODUCTION(S1REGL, reduce_xor4L_rule, c)
        DFA_PRODUCTION(S3REGL, reduce_xor4L_rule, c)
        DFA_PRODUCTION(S4REGL, reduce_xor4L_rule, c)
        DFA_PRODUCTION(S7REGL, reduce_xor4L_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14767 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 8 && vector_element_basic_type(n->in(2)) == T_INT
#line 22278 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(MREGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MS0REGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MS1REGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MS3REGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MS4REGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MS5REGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MS6REGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MS7REGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MT0REGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MT1REGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MT2REGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MT3REGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MT8REGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MT4REGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MA0REGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MA1REGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MA2REGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MA3REGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MA4REGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MA5REGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MA6REGI, reduce_xor8I_rule, c)
        DFA_PRODUCTION(MA7REGI, reduce_xor8I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14756 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 16 && vector_element_basic_type(n->in(2)) == T_SHORT
#line 22311 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_xor16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_xor16S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14745 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 32 && vector_element_basic_type(n->in(2)) == T_BYTE
#line 22394 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_xor32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_xor32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14734 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 2 && vector_element_basic_type(n->in(2)) == T_LONG
#line 22477 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, reduce_xor2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, reduce_xor2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, reduce_xor2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, reduce_xor2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, reduce_xor2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, reduce_xor2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, reduce_xor2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, reduce_xor2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, reduce_xor2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, reduce_xor2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, reduce_xor2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, reduce_xor2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, reduce_xor2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, reduce_xor2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, reduce_xor2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, reduce_xor2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, reduce_xor2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, reduce_xor2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, reduce_xor2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, reduce_xor2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14723 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 4 && vector_element_basic_type(n->in(2)) == T_INT
#line 22551 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_xor4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_xor4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14712 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 8 && vector_element_basic_type(n->in(2)) == T_SHORT
#line 22634 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_xor8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_xor8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14701 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 16 && vector_element_basic_type(n->in(2)) == T_BYTE
#line 22717 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_xor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_xor16B_rule, c)
      }
    }
}
void  State::_sub_Op_MinV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12578 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_DOUBLE
#line 22802 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, min4D_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12563 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8 && vector_element_basic_type(n) == T_FLOAT
#line 22811 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, min8F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12553 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_LONG
#line 22822 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, min4L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12543 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8 && vector_element_basic_type(n) == T_INT
#line 22833 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, min8I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12533 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16 && vector_element_basic_type(n) == T_SHORT
#line 22844 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, min16S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12523 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32 && vector_element_basic_type(n) == T_BYTE
#line 22855 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, min32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 12508 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2 && vector_element_basic_type(n) == T_DOUBLE
#line 22866 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, min2D_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 12493 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_FLOAT
#line 22875 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, min4F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 12483 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2 && vector_element_basic_type(n) == T_LONG
#line 22886 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, min2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 12473 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_INT
#line 22897 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, min4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 12463 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8 && vector_element_basic_type(n) == T_SHORT
#line 22908 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, min8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 12453 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16 && vector_element_basic_type(n) == T_BYTE
#line 22919 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, min16B_rule, c)
      }
    }
}
void  State::_sub_Op_MaxV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12436 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_DOUBLE
#line 22932 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, max4D_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12421 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8 && vector_element_basic_type(n) == T_FLOAT
#line 22941 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, max8F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12411 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_LONG
#line 22952 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, max4L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12401 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8 && vector_element_basic_type(n) == T_INT
#line 22963 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, max8I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12391 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16 && vector_element_basic_type(n) == T_SHORT
#line 22974 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, max16S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 12381 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32 && vector_element_basic_type(n) == T_BYTE
#line 22985 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, max32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 12366 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2 && vector_element_basic_type(n) == T_DOUBLE
#line 22996 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, max2D_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 12351 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_FLOAT
#line 23005 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, max4F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 12341 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2 && vector_element_basic_type(n) == T_LONG
#line 23016 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, max2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 12331 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_INT
#line 23027 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, max4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 12321 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8 && vector_element_basic_type(n) == T_SHORT
#line 23038 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, max8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 12311 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16 && vector_element_basic_type(n) == T_BYTE
#line 23049 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, max16B_rule, c)
      }
    }
}
void  State::_sub_Op_MinReductionV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14508 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 4 && vector_element_basic_type(n->in(2)) == T_LONG
#line 23062 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(MREGL, reduce_min4L_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, reduce_min4L_rule, c)
        DFA_PRODUCTION(V1REGL, reduce_min4L_rule, c)
        DFA_PRODUCTION(A0REGL, reduce_min4L_rule, c)
        DFA_PRODUCTION(A1REGL, reduce_min4L_rule, c)
        DFA_PRODUCTION(A2REGL, reduce_min4L_rule, c)
        DFA_PRODUCTION(A3REGL, reduce_min4L_rule, c)
        DFA_PRODUCTION(T0REGL, reduce_min4L_rule, c)
        DFA_PRODUCTION(T1REGL, reduce_min4L_rule, c)
        DFA_PRODUCTION(T3REGL, reduce_min4L_rule, c)
        DFA_PRODUCTION(T8REGL, reduce_min4L_rule, c)
        DFA_PRODUCTION(A4REGL, reduce_min4L_rule, c)
        DFA_PRODUCTION(A5REGL, reduce_min4L_rule, c)
        DFA_PRODUCTION(A6REGL, reduce_min4L_rule, c)
        DFA_PRODUCTION(A7REGL, reduce_min4L_rule, c)
        DFA_PRODUCTION(S0REGL, reduce_min4L_rule, c)
        DFA_PRODUCTION(S1REGL, reduce_min4L_rule, c)
        DFA_PRODUCTION(S3REGL, reduce_min4L_rule, c)
        DFA_PRODUCTION(S4REGL, reduce_min4L_rule, c)
        DFA_PRODUCTION(S7REGL, reduce_min4L_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14497 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 8 && vector_element_basic_type(n->in(2)) == T_INT
#line 23092 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(MREGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MS0REGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MS1REGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MS3REGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MS4REGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MS5REGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MS6REGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MS7REGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MT0REGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MT1REGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MT2REGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MT3REGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MT8REGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MT4REGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MA0REGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MA1REGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MA2REGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MA3REGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MA4REGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MA5REGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MA6REGI, reduce_min8I_rule, c)
        DFA_PRODUCTION(MA7REGI, reduce_min8I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14486 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 16 && vector_element_basic_type(n->in(2)) == T_SHORT
#line 23125 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_min16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_min16S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14475 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 32 && vector_element_basic_type(n->in(2)) == T_BYTE
#line 23208 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_min32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_min32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14464 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 2 && vector_element_basic_type(n->in(2)) == T_LONG
#line 23291 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, reduce_min2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, reduce_min2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, reduce_min2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, reduce_min2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, reduce_min2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, reduce_min2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, reduce_min2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, reduce_min2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, reduce_min2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, reduce_min2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, reduce_min2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, reduce_min2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, reduce_min2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, reduce_min2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, reduce_min2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, reduce_min2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, reduce_min2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, reduce_min2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, reduce_min2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, reduce_min2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14453 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 4 && vector_element_basic_type(n->in(2)) == T_INT
#line 23365 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_min4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_min4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14442 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 8 && vector_element_basic_type(n->in(2)) == T_SHORT
#line 23448 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_min8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_min8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14431 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 16 && vector_element_basic_type(n->in(2)) == T_BYTE
#line 23531 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_min16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_min16B_rule, c)
      }
    }
}
void  State::_sub_Op_MaxReductionV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14418 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 4 && vector_element_basic_type(n->in(2)) == T_LONG
#line 23616 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(MREGL, reduce_max4L_rule, c)
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION(V0REGL, reduce_max4L_rule, c)
        DFA_PRODUCTION(V1REGL, reduce_max4L_rule, c)
        DFA_PRODUCTION(A0REGL, reduce_max4L_rule, c)
        DFA_PRODUCTION(A1REGL, reduce_max4L_rule, c)
        DFA_PRODUCTION(A2REGL, reduce_max4L_rule, c)
        DFA_PRODUCTION(A3REGL, reduce_max4L_rule, c)
        DFA_PRODUCTION(T0REGL, reduce_max4L_rule, c)
        DFA_PRODUCTION(T1REGL, reduce_max4L_rule, c)
        DFA_PRODUCTION(T3REGL, reduce_max4L_rule, c)
        DFA_PRODUCTION(T8REGL, reduce_max4L_rule, c)
        DFA_PRODUCTION(A4REGL, reduce_max4L_rule, c)
        DFA_PRODUCTION(A5REGL, reduce_max4L_rule, c)
        DFA_PRODUCTION(A6REGL, reduce_max4L_rule, c)
        DFA_PRODUCTION(A7REGL, reduce_max4L_rule, c)
        DFA_PRODUCTION(S0REGL, reduce_max4L_rule, c)
        DFA_PRODUCTION(S1REGL, reduce_max4L_rule, c)
        DFA_PRODUCTION(S3REGL, reduce_max4L_rule, c)
        DFA_PRODUCTION(S4REGL, reduce_max4L_rule, c)
        DFA_PRODUCTION(S7REGL, reduce_max4L_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14407 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 8 && vector_element_basic_type(n->in(2)) == T_INT
#line 23646 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(MREGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MS0REGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MS1REGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MS3REGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MS4REGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MS5REGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MS6REGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MS7REGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MT0REGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MT1REGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MT2REGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MT3REGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MT8REGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MT4REGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MA0REGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MA1REGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MA2REGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MA3REGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MA4REGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MA5REGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MA6REGI, reduce_max8I_rule, c)
        DFA_PRODUCTION(MA7REGI, reduce_max8I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14396 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 16 && vector_element_basic_type(n->in(2)) == T_SHORT
#line 23679 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_max16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_max16S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 14385 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 32 && vector_element_basic_type(n->in(2)) == T_BYTE
#line 23762 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_max32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_max32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14374 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 2 && vector_element_basic_type(n->in(2)) == T_LONG
#line 23845 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION(MREGL, reduce_max2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGLORI2L) || _cost[MREGLORI2L] > c) {
        DFA_PRODUCTION(MREGLORI2L, mRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION(V0REGL, reduce_max2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION(V1REGL, reduce_max2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION(A0REGL, reduce_max2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION(A1REGL, reduce_max2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION(A2REGL, reduce_max2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION(A3REGL, reduce_max2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION(T0REGL, reduce_max2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION(T1REGL, reduce_max2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION(T3REGL, reduce_max2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION(T8REGL, reduce_max2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION(A4REGL, reduce_max2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION(A5REGL, reduce_max2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION(A6REGL, reduce_max2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION(A7REGL, reduce_max2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION(S0REGL, reduce_max2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION(S1REGL, reduce_max2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION(S3REGL, reduce_max2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION(S4REGL, reduce_max2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION(S7REGL, reduce_max2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14363 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 4 && vector_element_basic_type(n->in(2)) == T_INT
#line 23919 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_max4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_max4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14352 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 8 && vector_element_basic_type(n->in(2)) == T_SHORT
#line 24002 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_max8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_max8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14341 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n->in(2)) == 16 && vector_element_basic_type(n->in(2)) == T_BYTE
#line 24085 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, reduce_max16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, reduce_max16B_rule, c)
      }
    }
}
void  State::_sub_Op_LoadVector(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 11329 "src/hotspot/cpu/loongarch/loongarch_64.ad"
n->as_LoadVector()->memory_size() == 32
#line 24170 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
        DFA_PRODUCTION(VECY, loadV32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 11319 "src/hotspot/cpu/loongarch/loongarch_64.ad"
n->as_LoadVector()->memory_size() == 16
#line 24179 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
        DFA_PRODUCTION(VECX, loadV16_rule, c)
    }
}
void  State::_sub_Op_StoreVector(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 11351 "src/hotspot/cpu/loongarch/loongarch_64.ad"
n->as_StoreVector()->memory_size() == 32
#line 24190 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(UNIVERSE, storeV32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 11341 "src/hotspot/cpu/loongarch/loongarch_64.ad"
n->as_StoreVector()->memory_size() == 16
#line 24199 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeV16_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[IMMI_M1];
        DFA_PRODUCTION(_REPLICATEB_IMMI_M1_, _ReplicateB_immI_M1__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMIU8) ) {
      unsigned int c = _kids[0]->_cost[IMMIU8];
        DFA_PRODUCTION(_REPLICATEB_IMMIU8_, _ReplicateB_immIU8__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMIU5) ) {
      unsigned int c = _kids[0]->_cost[IMMIU5];
        DFA_PRODUCTION(_REPLICATEB_IMMIU5_, _ReplicateB_immIU5__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_M128_255) &&
        (
#line 11473 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 24224 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI_M128_255]+100;
        DFA_PRODUCTION(VECY, repl32B_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) &&
        (
#line 11463 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 24233 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, repl32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_M128_255) &&
        (
#line 11373 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 24244 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI_M128_255]+100;
        DFA_PRODUCTION(VECX, repl16B_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) &&
        (
#line 11363 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 24253 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, repl16B_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[IMMI_M1];
        DFA_PRODUCTION(_REPLICATES_IMMI_M1_, _ReplicateS_immI_M1__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMIU5) ) {
      unsigned int c = _kids[0]->_cost[IMMIU5];
        DFA_PRODUCTION(_REPLICATES_IMMIU5_, _ReplicateS_immIU5__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI10) &&
        (
#line 11493 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 24274 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI10]+100;
        DFA_PRODUCTION(VECY, repl16S_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) &&
        (
#line 11483 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 24283 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, repl16S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI10) &&
        (
#line 11393 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 24294 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI10]+100;
        DFA_PRODUCTION(VECX, repl8S_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) &&
        (
#line 11383 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 24303 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, repl8S_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[IMMI_M1];
        DFA_PRODUCTION(_REPLICATEI_IMMI_M1_, _ReplicateI_immI_M1__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMIU5) ) {
      unsigned int c = _kids[0]->_cost[IMMIU5];
        DFA_PRODUCTION(_REPLICATEI_IMMIU5_, _ReplicateI_immIU5__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI10) &&
        (
#line 11513 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 24324 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI10]+100;
        DFA_PRODUCTION(VECY, repl8I_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) &&
        (
#line 11503 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 24333 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, repl8I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI10) &&
        (
#line 11413 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 24344 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI10]+100;
        DFA_PRODUCTION(VECX, repl4I_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) &&
        (
#line 11403 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 24353 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, repl4I_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMLU5) ) {
      unsigned int c = _kids[0]->_cost[IMMLU5];
        DFA_PRODUCTION(_REPLICATEL_IMMLU5_, _ReplicateL_immLU5__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMML10) &&
        (
#line 11533 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 24370 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML10]+100;
        DFA_PRODUCTION(VECY, repl4L_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) &&
        (
#line 11523 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 24379 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, repl4L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML10) &&
        (
#line 11433 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 24390 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML10]+100;
        DFA_PRODUCTION(VECX, repl2L_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) &&
        (
#line 11423 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 24399 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, repl2L_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 11543 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8
#line 24412 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION(VECY, repl8F_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 11443 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 24421 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION(VECX, repl4F_rule, c)
    }
}
void  State::_sub_Op_ReplicateD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 11553 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4
#line 24432 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION(VECY, repl4D_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 11453 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2
#line 24441 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION(VECX, repl2D_rule, c)
    }
}
void  State::_sub_Op_VectorMaskCmp(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_VECY_VECY) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15445 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 24452 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_VECY_VECY]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION(VECY, cmpV32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_VECX_VECX) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15433 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 24461 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_VECX_VECX]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION(VECX, cmpV16_rule, c)
    }
}
void  State::_sub_Op_VectorTest(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 15412 "src/hotspot/cpu/loongarch/loongarch_64.ad"
static_cast<const VectorTestNode*>(n)->get_predicate() == BoolTest::overflow
#line 24472 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(MREGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION(NO_AX_MREGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MS0REGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MS1REGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MS3REGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MS4REGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MS5REGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MS6REGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MS7REGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MT0REGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MT1REGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MT2REGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MT3REGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MT8REGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MT4REGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MA0REGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MA1REGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MA2REGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MA3REGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MA4REGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MA5REGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MA6REGI, alltrue_in_maskV32_rule, c)
        DFA_PRODUCTION(MA7REGI, alltrue_in_maskV32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 15394 "src/hotspot/cpu/loongarch/loongarch_64.ad"
static_cast<const VectorTestNode*>(n)->get_predicate() == BoolTest::ne
#line 24505 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, anytrue_in_maskV32_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, anytrue_in_maskV32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 15377 "src/hotspot/cpu/loongarch/loongarch_64.ad"
static_cast<const VectorTestNode*>(n)->get_predicate() == BoolTest::overflow
#line 24588 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, alltrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, alltrue_in_maskV16_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 15361 "src/hotspot/cpu/loongarch/loongarch_64.ad"
static_cast<const VectorTestNode*>(n)->get_predicate() == BoolTest::ne
#line 24671 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION(MREGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGIORL2I) || _cost[MREGIORL2I] > c) {
        DFA_PRODUCTION(MREGIORL2I, mRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION(NO_AX_MREGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION(MS0REGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION(MS1REGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION(MS3REGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION(MS4REGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION(MS5REGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION(MS6REGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION(MS7REGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION(MT0REGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION(MT1REGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION(MT2REGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION(MT3REGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION(MT8REGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION(MT4REGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION(MA0REGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION(MA1REGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION(MA2REGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION(MA3REGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION(MA4REGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION(MA5REGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION(MA6REGI, anytrue_in_maskV16_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION(MA7REGI, anytrue_in_maskV16_rule, c)
      }
    }
}
void  State::_sub_Op_VectorBlend(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_VECY_VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 15280 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32
#line 24756 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_VECY_VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, blendV32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_VECX_VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 15269 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16
#line 24765 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_VECX_VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, blendV16_rule, c)
    }
}
void  State::_sub_Op_VectorRearrange(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 15537 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16 && vector_element_basic_type(n) == T_SHORT
#line 24776 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, rearrange16S_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 15524 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32 && vector_element_basic_type(n) == T_BYTE
#line 24785 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, rearrange32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 15514 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16 && vector_element_basic_type(n) == T_BYTE
#line 24796 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, rearrange16B_rule, c)
    }
}
void  State::_sub_Op_VectorLoadMask(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 15312 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16 && vector_element_basic_type(n) == T_SHORT
#line 24807 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECY, loadmask16S_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 15302 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32 && vector_element_basic_type(n) == T_BYTE
#line 24816 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, loadmask32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 15292 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16 && vector_element_basic_type(n) == T_BYTE
#line 24827 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, loadmask16B_rule, c)
    }
}
void  State::_sub_Op_VectorLoadShuffle(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 15502 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16 && vector_element_basic_type(n) == T_SHORT
#line 24838 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECY, loadShuffle16S_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 15492 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32 && vector_element_basic_type(n) == T_BYTE
#line 24847 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, loadShuffle32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 15482 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16 && vector_element_basic_type(n) == T_BYTE
#line 24858 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, loadShuffle16B_rule, c)
    }
}
void  State::_sub_Op_VectorLoadConst(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI_0) &&
        (
#line 15469 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32 && vector_element_basic_type(n) == T_BYTE
#line 24869 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI_0]+100;
        DFA_PRODUCTION(VECY, loadcon32B_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_0) &&
        (
#line 15458 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16 && vector_element_basic_type(n) == T_BYTE
#line 24878 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI_0]+100;
        DFA_PRODUCTION(VECX, loadcon16B_rule, c)
    }
}
void  State::_sub_Op_VectorStoreMask(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI_2) &&
        (
#line 15345 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 24889 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI_2]+100;
        DFA_PRODUCTION(VECX, storemask16S_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI_1) &&
        (
#line 15335 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32
#line 24898 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI_1]+100;
        DFA_PRODUCTION(VECY, storemask32B_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI_1) &&
        (
#line 15325 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16
#line 24907 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI_1]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, storemask16B_rule, c)
      }
    }
}
void  State::_sub_Op_VectorReinterpret(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 15114 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16 && vector_length_in_bytes(n->in(1)) == 32
#line 24920 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
        DFA_PRODUCTION(VECX, reinterpretY2X_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 15096 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32 && vector_length_in_bytes(n->in(1)) == 16
#line 24929 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECY, reinterpretX2Y_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 15085 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 32 && vector_length_in_bytes(n->in(1)) == 32
#line 24938 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, reinterpretY_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 15074 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length_in_bytes(n) == 16 && vector_length_in_bytes(n->in(1)) == 16
#line 24949 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, reinterpretX_rule, c)
      }
    }
}
void  State::_sub_Op_VectorCastB2X(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 14821 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16 && vector_element_basic_type(n) == T_SHORT
#line 24962 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECY, cvt16Bto16S_rule, c)
    }
}
void  State::_sub_Op_VectorCastS2X(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 14855 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8 && vector_element_basic_type(n) == T_FLOAT
#line 24973 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECY, cvt8Sto8F_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 14845 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8 && vector_element_basic_type(n) == T_INT
#line 24982 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, cvt8Sto8I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 14833 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16 && vector_element_basic_type(n) == T_BYTE
#line 24993 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
        DFA_PRODUCTION(VECX, cvt16Sto16B_rule, c)
    }
}
void  State::_sub_Op_VectorCastI2X(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 14910 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_DOUBLE
#line 25004 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECY, cvt4Ito4D_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 14900 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8 && vector_element_basic_type(n) == T_FLOAT
#line 25013 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, cvt8Ito8F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 14890 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_LONG
#line 25024 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, cvt4Ito4L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 14880 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_FLOAT
#line 25035 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, cvt4Ito4F_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 14868 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8 && vector_element_basic_type(n) == T_SHORT
#line 25044 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, cvt8Ito8S_rule, c)
      }
    }
}
void  State::_sub_Op_VectorCastL2X(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 14957 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_DOUBLE
#line 25057 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, cvt4Lto4D_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 14947 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2 && vector_element_basic_type(n) == T_DOUBLE
#line 25066 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, cvt2Lto2D_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 14935 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_FLOAT
#line 25075 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, cvt4Lto4F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 14923 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_INT
#line 25086 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, cvt4Lto4I_rule, c)
      }
    }
}
void  State::_sub_Op_VectorCastF2X(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 15014 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_DOUBLE
#line 25099 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECY, cvt4Fto4D_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 15002 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_LONG
#line 25108 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, cvt4Fto4L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 14992 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8 && vector_element_basic_type(n) == T_INT
#line 25119 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, cvt8Fto8I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 14982 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_INT
#line 25130 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, cvt4Fto4I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 14969 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8 && vector_element_basic_type(n) == T_SHORT
#line 25139 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, cvt8Fto8S_rule, c)
      }
    }
}
void  State::_sub_Op_VectorCastD2X(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 15061 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_LONG
#line 25152 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
        DFA_PRODUCTION(VECY, cvt4Dto4L_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 15051 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2 && vector_element_basic_type(n) == T_LONG
#line 25161 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION(VECX, cvt2Dto2L_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 15039 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_FLOAT
#line 25170 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, cvt4Dto4F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 15027 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_INT
#line 25181 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, cvt4Dto4I_rule, c)
      }
    }
}
void  State::_sub_Op_VectorInsert(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_VECY_REGD) && STATE__VALID_CHILD(_kids[1], IMMIU2) &&
        (
#line 15256 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_DOUBLE
#line 25194 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_VECY_REGD]+_kids[1]->_cost[IMMIU2]+100;
        DFA_PRODUCTION(VECY, insert4D_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_VECY_REGF) && STATE__VALID_CHILD(_kids[1], IMMIU3) &&
        (
#line 15246 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8 && vector_element_basic_type(n) == T_FLOAT
#line 25203 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_VECY_REGF]+_kids[1]->_cost[IMMIU3]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, insert8F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_VECY_MREGL) && STATE__VALID_CHILD(_kids[1], IMMIU2) &&
        (
#line 15236 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_LONG
#line 25214 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_VECY_MREGL]+_kids[1]->_cost[IMMIU2]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, insert4L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_VECY_MREGI) && STATE__VALID_CHILD(_kids[1], IMMIU3) &&
        (
#line 15226 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8 && vector_element_basic_type(n) == T_INT
#line 25225 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_VECY_MREGI]+_kids[1]->_cost[IMMIU3]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, insert8I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_VECY_MREGI) && STATE__VALID_CHILD(_kids[1], IMMIU4) &&
        (
#line 15210 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16 && vector_element_basic_type(n) == T_SHORT
#line 25236 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_VECY_MREGI]+_kids[1]->_cost[IMMIU4]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, insert16S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_VECY_MREGI) && STATE__VALID_CHILD(_kids[1], IMMIU5) &&
        (
#line 15194 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 32 && vector_element_basic_type(n) == T_BYTE
#line 25247 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_VECY_MREGI]+_kids[1]->_cost[IMMIU5]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION(VECY, insert32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_VECX_REGD) && STATE__VALID_CHILD(_kids[1], IMMIU1) &&
        (
#line 15182 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2 && vector_element_basic_type(n) == T_DOUBLE
#line 25258 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_VECX_REGD]+_kids[1]->_cost[IMMIU1]+100;
        DFA_PRODUCTION(VECX, insert2D_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_VECX_REGF) && STATE__VALID_CHILD(_kids[1], IMMIU2) &&
        (
#line 15170 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_FLOAT
#line 25267 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_VECX_REGF]+_kids[1]->_cost[IMMIU2]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, insert4F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_VECX_MREGL) && STATE__VALID_CHILD(_kids[1], IMMIU1) &&
        (
#line 15160 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 2 && vector_element_basic_type(n) == T_LONG
#line 25278 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_VECX_MREGL]+_kids[1]->_cost[IMMIU1]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, insert2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_VECX_MREGI) && STATE__VALID_CHILD(_kids[1], IMMIU2) &&
        (
#line 15150 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 4 && vector_element_basic_type(n) == T_INT
#line 25289 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_VECX_MREGI]+_kids[1]->_cost[IMMIU2]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, insert4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_VECX_MREGI) && STATE__VALID_CHILD(_kids[1], IMMIU3) &&
        (
#line 15140 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 8 && vector_element_basic_type(n) == T_SHORT
#line 25300 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_VECX_MREGI]+_kids[1]->_cost[IMMIU3]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, insert8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_VECX_MREGI) && STATE__VALID_CHILD(_kids[1], IMMIU4) &&
        (
#line 15130 "src/hotspot/cpu/loongarch/loongarch_64.ad"
vector_length(n) == 16 && vector_element_basic_type(n) == T_BYTE
#line 25311 "dfa_loongarch.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_VECX_MREGI]+_kids[1]->_cost[IMMIU4]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION(VECX, insert16B_rule, c)
      }
    }
}
bool State::DFA(int opcode, const Node *n) {
  switch(opcode) {
  case Op_RegN: { _sub_Op_RegN(n);
    break;
  }
  case Op_RegI: { _sub_Op_RegI(n);
    break;
  }
  case Op_RegP: { _sub_Op_RegP(n);
    break;
  }
  case Op_RegF: { _sub_Op_RegF(n);
    break;
  }
  case Op_RegD: { _sub_Op_RegD(n);
    break;
  }
  case Op_RegL: { _sub_Op_RegL(n);
    break;
  }
  case Op_VecX: { _sub_Op_VecX(n);
    break;
  }
  case Op_VecY: { _sub_Op_VecY(n);
    break;
  }
  case Op_RegFlags: { _sub_Op_RegFlags(n);
    break;
  }
  case Op_AbsD: { _sub_Op_AbsD(n);
    break;
  }
  case Op_AbsF: { _sub_Op_AbsF(n);
    break;
  }
  case Op_AbsI: { _sub_Op_AbsI(n);
    break;
  }
  case Op_AbsL: { _sub_Op_AbsL(n);
    break;
  }
  case Op_AddD: { _sub_Op_AddD(n);
    break;
  }
  case Op_AddF: { _sub_Op_AddF(n);
    break;
  }
  case Op_AddI: { _sub_Op_AddI(n);
    break;
  }
  case Op_AddL: { _sub_Op_AddL(n);
    break;
  }
  case Op_AddP: { _sub_Op_AddP(n);
    break;
  }
  case Op_AndI: { _sub_Op_AndI(n);
    break;
  }
  case Op_AndL: { _sub_Op_AndL(n);
    break;
  }
  case Op_Binary: { _sub_Op_Binary(n);
    break;
  }
  case Op_Bool: { _sub_Op_Bool(n);
    break;
  }
  case Op_ReverseBytesI: { _sub_Op_ReverseBytesI(n);
    break;
  }
  case Op_ReverseBytesL: { _sub_Op_ReverseBytesL(n);
    break;
  }
  case Op_ReverseBytesUS: { _sub_Op_ReverseBytesUS(n);
    break;
  }
  case Op_ReverseBytesS: { _sub_Op_ReverseBytesS(n);
    break;
  }
  case Op_CallDynamicJava: { _sub_Op_CallDynamicJava(n);
    break;
  }
  case Op_CallLeaf: { _sub_Op_CallLeaf(n);
    break;
  }
  case Op_CallLeafNoFP: { _sub_Op_CallLeafNoFP(n);
    break;
  }
  case Op_CallRuntime: { _sub_Op_CallRuntime(n);
    break;
  }
  case Op_CallStaticJava: { _sub_Op_CallStaticJava(n);
    break;
  }
  case Op_CastDD: { _sub_Op_CastDD(n);
    break;
  }
  case Op_CastFF: { _sub_Op_CastFF(n);
    break;
  }
  case Op_CastII: { _sub_Op_CastII(n);
    break;
  }
  case Op_CastLL: { _sub_Op_CastLL(n);
    break;
  }
  case Op_CastVV: { _sub_Op_CastVV(n);
    break;
  }
  case Op_CastX2P: { _sub_Op_CastX2P(n);
    break;
  }
  case Op_CastP2X: { _sub_Op_CastP2X(n);
    break;
  }
  case Op_CastPP: { _sub_Op_CastPP(n);
    break;
  }
  case Op_CheckCastPP: { _sub_Op_CheckCastPP(n);
    break;
  }
  case Op_ClearArray: { _sub_Op_ClearArray(n);
    break;
  }
  case Op_CMoveD: { _sub_Op_CMoveD(n);
    break;
  }
  case Op_CMoveF: { _sub_Op_CMoveF(n);
    break;
  }
  case Op_CMoveI: { _sub_Op_CMoveI(n);
    break;
  }
  case Op_CMoveL: { _sub_Op_CMoveL(n);
    break;
  }
  case Op_CMoveP: { _sub_Op_CMoveP(n);
    break;
  }
  case Op_CMoveN: { _sub_Op_CMoveN(n);
    break;
  }
  case Op_CmpN: { _sub_Op_CmpN(n);
    break;
  }
  case Op_CmpD: { _sub_Op_CmpD(n);
    break;
  }
  case Op_CmpD3: { _sub_Op_CmpD3(n);
    break;
  }
  case Op_CmpF: { _sub_Op_CmpF(n);
    break;
  }
  case Op_CmpF3: { _sub_Op_CmpF3(n);
    break;
  }
  case Op_CmpI: { _sub_Op_CmpI(n);
    break;
  }
  case Op_CmpL: { _sub_Op_CmpL(n);
    break;
  }
  case Op_CmpL3: { _sub_Op_CmpL3(n);
    break;
  }
  case Op_CmpLTMask: { _sub_Op_CmpLTMask(n);
    break;
  }
  case Op_CmpP: { _sub_Op_CmpP(n);
    break;
  }
  case Op_CmpU: { _sub_Op_CmpU(n);
    break;
  }
  case Op_CmpUL: { _sub_Op_CmpUL(n);
    break;
  }
  case Op_CompareAndSwapI: { _sub_Op_CompareAndSwapI(n);
    break;
  }
  case Op_CompareAndSwapL: { _sub_Op_CompareAndSwapL(n);
    break;
  }
  case Op_CompareAndSwapP: { _sub_Op_CompareAndSwapP(n);
    break;
  }
  case Op_CompareAndSwapN: { _sub_Op_CompareAndSwapN(n);
    break;
  }
  case Op_WeakCompareAndSwapI: { _sub_Op_WeakCompareAndSwapI(n);
    break;
  }
  case Op_WeakCompareAndSwapL: { _sub_Op_WeakCompareAndSwapL(n);
    break;
  }
  case Op_WeakCompareAndSwapP: { _sub_Op_WeakCompareAndSwapP(n);
    break;
  }
  case Op_WeakCompareAndSwapN: { _sub_Op_WeakCompareAndSwapN(n);
    break;
  }
  case Op_CompareAndExchangeI: { _sub_Op_CompareAndExchangeI(n);
    break;
  }
  case Op_CompareAndExchangeL: { _sub_Op_CompareAndExchangeL(n);
    break;
  }
  case Op_CompareAndExchangeP: { _sub_Op_CompareAndExchangeP(n);
    break;
  }
  case Op_CompareAndExchangeN: { _sub_Op_CompareAndExchangeN(n);
    break;
  }
  case Op_GetAndAddI: { _sub_Op_GetAndAddI(n);
    break;
  }
  case Op_GetAndAddL: { _sub_Op_GetAndAddL(n);
    break;
  }
  case Op_GetAndSetI: { _sub_Op_GetAndSetI(n);
    break;
  }
  case Op_GetAndSetL: { _sub_Op_GetAndSetL(n);
    break;
  }
  case Op_GetAndSetP: { _sub_Op_GetAndSetP(n);
    break;
  }
  case Op_GetAndSetN: { _sub_Op_GetAndSetN(n);
    break;
  }
  case Op_ConN: { _sub_Op_ConN(n);
    break;
  }
  case Op_ConNKlass: { _sub_Op_ConNKlass(n);
    break;
  }
  case Op_ConD: { _sub_Op_ConD(n);
    break;
  }
  case Op_ConF: { _sub_Op_ConF(n);
    break;
  }
  case Op_ConI: { _sub_Op_ConI(n);
    break;
  }
  case Op_ConL: { _sub_Op_ConL(n);
    break;
  }
  case Op_ConP: { _sub_Op_ConP(n);
    break;
  }
  case Op_Conv2B: { _sub_Op_Conv2B(n);
    break;
  }
  case Op_ConvD2F: { _sub_Op_ConvD2F(n);
    break;
  }
  case Op_ConvD2I: { _sub_Op_ConvD2I(n);
    break;
  }
  case Op_ConvD2L: { _sub_Op_ConvD2L(n);
    break;
  }
  case Op_ConvF2D: { _sub_Op_ConvF2D(n);
    break;
  }
  case Op_ConvF2I: { _sub_Op_ConvF2I(n);
    break;
  }
  case Op_ConvF2L: { _sub_Op_ConvF2L(n);
    break;
  }
  case Op_ConvI2D: { _sub_Op_ConvI2D(n);
    break;
  }
  case Op_ConvI2F: { _sub_Op_ConvI2F(n);
    break;
  }
  case Op_ConvI2L: { _sub_Op_ConvI2L(n);
    break;
  }
  case Op_ConvL2D: { _sub_Op_ConvL2D(n);
    break;
  }
  case Op_ConvL2F: { _sub_Op_ConvL2F(n);
    break;
  }
  case Op_ConvL2I: { _sub_Op_ConvL2I(n);
    break;
  }
  case Op_CountedLoopEnd: { _sub_Op_CountedLoopEnd(n);
    break;
  }
  case Op_CountLeadingZerosI: { _sub_Op_CountLeadingZerosI(n);
    break;
  }
  case Op_CountLeadingZerosL: { _sub_Op_CountLeadingZerosL(n);
    break;
  }
  case Op_CountTrailingZerosI: { _sub_Op_CountTrailingZerosI(n);
    break;
  }
  case Op_CountTrailingZerosL: { _sub_Op_CountTrailingZerosL(n);
    break;
  }
  case Op_CreateEx: { _sub_Op_CreateEx(n);
    break;
  }
  case Op_DecodeN: { _sub_Op_DecodeN(n);
    break;
  }
  case Op_DecodeNKlass: { _sub_Op_DecodeNKlass(n);
    break;
  }
  case Op_DivD: { _sub_Op_DivD(n);
    break;
  }
  case Op_DivF: { _sub_Op_DivF(n);
    break;
  }
  case Op_DivI: { _sub_Op_DivI(n);
    break;
  }
  case Op_DivL: { _sub_Op_DivL(n);
    break;
  }
  case Op_EncodeISOArray: { _sub_Op_EncodeISOArray(n);
    break;
  }
  case Op_EncodeP: { _sub_Op_EncodeP(n);
    break;
  }
  case Op_EncodePKlass: { _sub_Op_EncodePKlass(n);
    break;
  }
  case Op_FastLock: { _sub_Op_FastLock(n);
    break;
  }
  case Op_FastUnlock: { _sub_Op_FastUnlock(n);
    break;
  }
  case Op_FmaD: { _sub_Op_FmaD(n);
    break;
  }
  case Op_FmaF: { _sub_Op_FmaF(n);
    break;
  }
  case Op_Goto: { _sub_Op_Goto(n);
    break;
  }
  case Op_Halt: { _sub_Op_Halt(n);
    break;
  }
  case Op_HasNegatives: { _sub_Op_HasNegatives(n);
    break;
  }
  case Op_If: { _sub_Op_If(n);
    break;
  }
  case Op_LShiftI: { _sub_Op_LShiftI(n);
    break;
  }
  case Op_LShiftL: { _sub_Op_LShiftL(n);
    break;
  }
  case Op_LoadB: { _sub_Op_LoadB(n);
    break;
  }
  case Op_LoadUB: { _sub_Op_LoadUB(n);
    break;
  }
  case Op_LoadUS: { _sub_Op_LoadUS(n);
    break;
  }
  case Op_LoadD: { _sub_Op_LoadD(n);
    break;
  }
  case Op_LoadD_unaligned: { _sub_Op_LoadD_unaligned(n);
    break;
  }
  case Op_LoadF: { _sub_Op_LoadF(n);
    break;
  }
  case Op_LoadI: { _sub_Op_LoadI(n);
    break;
  }
  case Op_LoadKlass: { _sub_Op_LoadKlass(n);
    break;
  }
  case Op_LoadNKlass: { _sub_Op_LoadNKlass(n);
    break;
  }
  case Op_LoadL: { _sub_Op_LoadL(n);
    break;
  }
  case Op_LoadL_unaligned: { _sub_Op_LoadL_unaligned(n);
    break;
  }
  case Op_LoadPLocked: { _sub_Op_LoadPLocked(n);
    break;
  }
  case Op_LoadP: { _sub_Op_LoadP(n);
    break;
  }
  case Op_LoadN: { _sub_Op_LoadN(n);
    break;
  }
  case Op_LoadRange: { _sub_Op_LoadRange(n);
    break;
  }
  case Op_LoadS: { _sub_Op_LoadS(n);
    break;
  }
  case Op_MaxI: { _sub_Op_MaxI(n);
    break;
  }
  case Op_MemBarAcquire: { _sub_Op_MemBarAcquire(n);
    break;
  }
  case Op_LoadFence: { _sub_Op_LoadFence(n);
    break;
  }
  case Op_MemBarAcquireLock: { _sub_Op_MemBarAcquireLock(n);
    break;
  }
  case Op_MemBarRelease: { _sub_Op_MemBarRelease(n);
    break;
  }
  case Op_StoreFence: { _sub_Op_StoreFence(n);
    break;
  }
  case Op_MemBarReleaseLock: { _sub_Op_MemBarReleaseLock(n);
    break;
  }
  case Op_MemBarVolatile: { _sub_Op_MemBarVolatile(n);
    break;
  }
  case Op_MemBarStoreStore: { _sub_Op_MemBarStoreStore(n);
    break;
  }
  case Op_MinI: { _sub_Op_MinI(n);
    break;
  }
  case Op_ModI: { _sub_Op_ModI(n);
    break;
  }
  case Op_ModL: { _sub_Op_ModL(n);
    break;
  }
  case Op_MoveI2F: { _sub_Op_MoveI2F(n);
    break;
  }
  case Op_MoveF2I: { _sub_Op_MoveF2I(n);
    break;
  }
  case Op_MoveL2D: { _sub_Op_MoveL2D(n);
    break;
  }
  case Op_MoveD2L: { _sub_Op_MoveD2L(n);
    break;
  }
  case Op_MulD: { _sub_Op_MulD(n);
    break;
  }
  case Op_MulF: { _sub_Op_MulF(n);
    break;
  }
  case Op_MulHiL: { _sub_Op_MulHiL(n);
    break;
  }
  case Op_MulI: { _sub_Op_MulI(n);
    break;
  }
  case Op_MulL: { _sub_Op_MulL(n);
    break;
  }
  case Op_NegD: { _sub_Op_NegD(n);
    break;
  }
  case Op_NegF: { _sub_Op_NegF(n);
    break;
  }
  case Op_OrI: { _sub_Op_OrI(n);
    break;
  }
  case Op_OrL: { _sub_Op_OrL(n);
    break;
  }
  case Op_PartialSubtypeCheck: { _sub_Op_PartialSubtypeCheck(n);
    break;
  }
  case Op_PopCountI: { _sub_Op_PopCountI(n);
    break;
  }
  case Op_PopCountL: { _sub_Op_PopCountL(n);
    break;
  }
  case Op_PopCountVI: { _sub_Op_PopCountVI(n);
    break;
  }
  case Op_PrefetchAllocation: { _sub_Op_PrefetchAllocation(n);
    break;
  }
  case Op_RShiftI: { _sub_Op_RShiftI(n);
    break;
  }
  case Op_RShiftL: { _sub_Op_RShiftL(n);
    break;
  }
  case Op_Rethrow: { _sub_Op_Rethrow(n);
    break;
  }
  case Op_Return: { _sub_Op_Return(n);
    break;
  }
  case Op_RoundDouble: { _sub_Op_RoundDouble(n);
    break;
  }
  case Op_RoundDoubleMode: { _sub_Op_RoundDoubleMode(n);
    break;
  }
  case Op_RoundDoubleModeV: { _sub_Op_RoundDoubleModeV(n);
    break;
  }
  case Op_RoundFloat: { _sub_Op_RoundFloat(n);
    break;
  }
  case Op_RotateLeft: { _sub_Op_RotateLeft(n);
    break;
  }
  case Op_RotateLeftV: { _sub_Op_RotateLeftV(n);
    break;
  }
  case Op_RotateRight: { _sub_Op_RotateRight(n);
    break;
  }
  case Op_RotateRightV: { _sub_Op_RotateRightV(n);
    break;
  }
  case Op_SafePoint: { _sub_Op_SafePoint(n);
    break;
  }
  case Op_ShenandoahCompareAndExchangeP: { _sub_Op_ShenandoahCompareAndExchangeP(n);
    break;
  }
  case Op_ShenandoahCompareAndExchangeN: { _sub_Op_ShenandoahCompareAndExchangeN(n);
    break;
  }
  case Op_ShenandoahCompareAndSwapN: { _sub_Op_ShenandoahCompareAndSwapN(n);
    break;
  }
  case Op_ShenandoahCompareAndSwapP: { _sub_Op_ShenandoahCompareAndSwapP(n);
    break;
  }
  case Op_ShenandoahWeakCompareAndSwapN: { _sub_Op_ShenandoahWeakCompareAndSwapN(n);
    break;
  }
  case Op_ShenandoahWeakCompareAndSwapP: { _sub_Op_ShenandoahWeakCompareAndSwapP(n);
    break;
  }
  case Op_CopySignD: { _sub_Op_CopySignD(n);
    break;
  }
  case Op_CopySignF: { _sub_Op_CopySignF(n);
    break;
  }
  case Op_SqrtD: { _sub_Op_SqrtD(n);
    break;
  }
  case Op_StoreB: { _sub_Op_StoreB(n);
    break;
  }
  case Op_StoreC: { _sub_Op_StoreC(n);
    break;
  }
  case Op_StoreCM: { _sub_Op_StoreCM(n);
    break;
  }
  case Op_StorePConditional: { _sub_Op_StorePConditional(n);
    break;
  }
  case Op_StoreIConditional: { _sub_Op_StoreIConditional(n);
    break;
  }
  case Op_StoreLConditional: { _sub_Op_StoreLConditional(n);
    break;
  }
  case Op_StoreD: { _sub_Op_StoreD(n);
    break;
  }
  case Op_StoreF: { _sub_Op_StoreF(n);
    break;
  }
  case Op_StoreI: { _sub_Op_StoreI(n);
    break;
  }
  case Op_StoreL: { _sub_Op_StoreL(n);
    break;
  }
  case Op_StoreP: { _sub_Op_StoreP(n);
    break;
  }
  case Op_StoreN: { _sub_Op_StoreN(n);
    break;
  }
  case Op_StoreNKlass: { _sub_Op_StoreNKlass(n);
    break;
  }
  case Op_StrComp: { _sub_Op_StrComp(n);
    break;
  }
  case Op_StrCompressedCopy: { _sub_Op_StrCompressedCopy(n);
    break;
  }
  case Op_StrEquals: { _sub_Op_StrEquals(n);
    break;
  }
  case Op_StrIndexOf: { _sub_Op_StrIndexOf(n);
    break;
  }
  case Op_StrIndexOfChar: { _sub_Op_StrIndexOfChar(n);
    break;
  }
  case Op_StrInflatedCopy: { _sub_Op_StrInflatedCopy(n);
    break;
  }
  case Op_SubD: { _sub_Op_SubD(n);
    break;
  }
  case Op_SubF: { _sub_Op_SubF(n);
    break;
  }
  case Op_SubI: { _sub_Op_SubI(n);
    break;
  }
  case Op_SubL: { _sub_Op_SubL(n);
    break;
  }
  case Op_TailCall: { _sub_Op_TailCall(n);
    break;
  }
  case Op_TailJump: { _sub_Op_TailJump(n);
    break;
  }
  case Op_ThreadLocal: { _sub_Op_ThreadLocal(n);
    break;
  }
  case Op_URShiftI: { _sub_Op_URShiftI(n);
    break;
  }
  case Op_URShiftL: { _sub_Op_URShiftL(n);
    break;
  }
  case Op_XorI: { _sub_Op_XorI(n);
    break;
  }
  case Op_XorL: { _sub_Op_XorL(n);
    break;
  }
  case Op_AddVB: { _sub_Op_AddVB(n);
    break;
  }
  case Op_AddVS: { _sub_Op_AddVS(n);
    break;
  }
  case Op_AddVI: { _sub_Op_AddVI(n);
    break;
  }
  case Op_AddReductionVI: { _sub_Op_AddReductionVI(n);
    break;
  }
  case Op_AddVL: { _sub_Op_AddVL(n);
    break;
  }
  case Op_AddReductionVL: { _sub_Op_AddReductionVL(n);
    break;
  }
  case Op_AddVF: { _sub_Op_AddVF(n);
    break;
  }
  case Op_AddReductionVF: { _sub_Op_AddReductionVF(n);
    break;
  }
  case Op_AddVD: { _sub_Op_AddVD(n);
    break;
  }
  case Op_AddReductionVD: { _sub_Op_AddReductionVD(n);
    break;
  }
  case Op_SubVB: { _sub_Op_SubVB(n);
    break;
  }
  case Op_SubVS: { _sub_Op_SubVS(n);
    break;
  }
  case Op_SubVI: { _sub_Op_SubVI(n);
    break;
  }
  case Op_SubVL: { _sub_Op_SubVL(n);
    break;
  }
  case Op_SubVF: { _sub_Op_SubVF(n);
    break;
  }
  case Op_SubVD: { _sub_Op_SubVD(n);
    break;
  }
  case Op_MulVB: { _sub_Op_MulVB(n);
    break;
  }
  case Op_MulVS: { _sub_Op_MulVS(n);
    break;
  }
  case Op_MulVI: { _sub_Op_MulVI(n);
    break;
  }
  case Op_MulReductionVI: { _sub_Op_MulReductionVI(n);
    break;
  }
  case Op_MulVL: { _sub_Op_MulVL(n);
    break;
  }
  case Op_MulReductionVL: { _sub_Op_MulReductionVL(n);
    break;
  }
  case Op_MulVF: { _sub_Op_MulVF(n);
    break;
  }
  case Op_MulReductionVF: { _sub_Op_MulReductionVF(n);
    break;
  }
  case Op_MulVD: { _sub_Op_MulVD(n);
    break;
  }
  case Op_MulReductionVD: { _sub_Op_MulReductionVD(n);
    break;
  }
  case Op_MulAddVS2VI: { _sub_Op_MulAddVS2VI(n);
    break;
  }
  case Op_FmaVD: { _sub_Op_FmaVD(n);
    break;
  }
  case Op_FmaVF: { _sub_Op_FmaVF(n);
    break;
  }
  case Op_DivVF: { _sub_Op_DivVF(n);
    break;
  }
  case Op_DivVD: { _sub_Op_DivVD(n);
    break;
  }
  case Op_AbsVB: { _sub_Op_AbsVB(n);
    break;
  }
  case Op_AbsVS: { _sub_Op_AbsVS(n);
    break;
  }
  case Op_AbsVI: { _sub_Op_AbsVI(n);
    break;
  }
  case Op_AbsVL: { _sub_Op_AbsVL(n);
    break;
  }
  case Op_AbsVF: { _sub_Op_AbsVF(n);
    break;
  }
  case Op_AbsVD: { _sub_Op_AbsVD(n);
    break;
  }
  case Op_NegVI: { _sub_Op_NegVI(n);
    break;
  }
  case Op_NegVF: { _sub_Op_NegVF(n);
    break;
  }
  case Op_NegVD: { _sub_Op_NegVD(n);
    break;
  }
  case Op_SqrtVD: { _sub_Op_SqrtVD(n);
    break;
  }
  case Op_SqrtVF: { _sub_Op_SqrtVF(n);
    break;
  }
  case Op_LShiftCntV: { _sub_Op_LShiftCntV(n);
    break;
  }
  case Op_RShiftCntV: { _sub_Op_RShiftCntV(n);
    break;
  }
  case Op_LShiftVB: { _sub_Op_LShiftVB(n);
    break;
  }
  case Op_LShiftVS: { _sub_Op_LShiftVS(n);
    break;
  }
  case Op_LShiftVI: { _sub_Op_LShiftVI(n);
    break;
  }
  case Op_LShiftVL: { _sub_Op_LShiftVL(n);
    break;
  }
  case Op_RShiftVB: { _sub_Op_RShiftVB(n);
    break;
  }
  case Op_RShiftVS: { _sub_Op_RShiftVS(n);
    break;
  }
  case Op_RShiftVI: { _sub_Op_RShiftVI(n);
    break;
  }
  case Op_RShiftVL: { _sub_Op_RShiftVL(n);
    break;
  }
  case Op_URShiftVB: { _sub_Op_URShiftVB(n);
    break;
  }
  case Op_URShiftVS: { _sub_Op_URShiftVS(n);
    break;
  }
  case Op_URShiftVI: { _sub_Op_URShiftVI(n);
    break;
  }
  case Op_URShiftVL: { _sub_Op_URShiftVL(n);
    break;
  }
  case Op_AndV: { _sub_Op_AndV(n);
    break;
  }
  case Op_AndReductionV: { _sub_Op_AndReductionV(n);
    break;
  }
  case Op_OrV: { _sub_Op_OrV(n);
    break;
  }
  case Op_OrReductionV: { _sub_Op_OrReductionV(n);
    break;
  }
  case Op_XorV: { _sub_Op_XorV(n);
    break;
  }
  case Op_XorReductionV: { _sub_Op_XorReductionV(n);
    break;
  }
  case Op_MinV: { _sub_Op_MinV(n);
    break;
  }
  case Op_MaxV: { _sub_Op_MaxV(n);
    break;
  }
  case Op_MinReductionV: { _sub_Op_MinReductionV(n);
    break;
  }
  case Op_MaxReductionV: { _sub_Op_MaxReductionV(n);
    break;
  }
  case Op_LoadVector: { _sub_Op_LoadVector(n);
    break;
  }
  case Op_StoreVector: { _sub_Op_StoreVector(n);
    break;
  }
  case Op_ReplicateB: { _sub_Op_ReplicateB(n);
    break;
  }
  case Op_ReplicateS: { _sub_Op_ReplicateS(n);
    break;
  }
  case Op_ReplicateI: { _sub_Op_ReplicateI(n);
    break;
  }
  case Op_ReplicateL: { _sub_Op_ReplicateL(n);
    break;
  }
  case Op_ReplicateF: { _sub_Op_ReplicateF(n);
    break;
  }
  case Op_ReplicateD: { _sub_Op_ReplicateD(n);
    break;
  }
  case Op_VectorMaskCmp: { _sub_Op_VectorMaskCmp(n);
    break;
  }
  case Op_VectorTest: { _sub_Op_VectorTest(n);
    break;
  }
  case Op_VectorBlend: { _sub_Op_VectorBlend(n);
    break;
  }
  case Op_VectorRearrange: { _sub_Op_VectorRearrange(n);
    break;
  }
  case Op_VectorLoadMask: { _sub_Op_VectorLoadMask(n);
    break;
  }
  case Op_VectorLoadShuffle: { _sub_Op_VectorLoadShuffle(n);
    break;
  }
  case Op_VectorLoadConst: { _sub_Op_VectorLoadConst(n);
    break;
  }
  case Op_VectorStoreMask: { _sub_Op_VectorStoreMask(n);
    break;
  }
  case Op_VectorReinterpret: { _sub_Op_VectorReinterpret(n);
    break;
  }
  case Op_VectorCastB2X: { _sub_Op_VectorCastB2X(n);
    break;
  }
  case Op_VectorCastS2X: { _sub_Op_VectorCastS2X(n);
    break;
  }
  case Op_VectorCastI2X: { _sub_Op_VectorCastI2X(n);
    break;
  }
  case Op_VectorCastL2X: { _sub_Op_VectorCastL2X(n);
    break;
  }
  case Op_VectorCastF2X: { _sub_Op_VectorCastF2X(n);
    break;
  }
  case Op_VectorCastD2X: { _sub_Op_VectorCastD2X(n);
    break;
  }
  case Op_VectorInsert: { _sub_Op_VectorInsert(n);
    break;
  }
  
  default:
    tty->print("Default case invoked for: \n");
    tty->print("   opcode  = %d, \"%s\"\n", opcode, NodeClassNames[opcode]);
    return false;
  }
  return true;
}
